//*****************************************************************************
//*
//*		
//*		ColorListBox.h
//*
//*
//*****************************************************************************
#ifndef 	__COLORLISTBOX_H__
#define 	__COLORLISTBOX_H__

#if _MSC_VER > 1000
#pragma once
#endif
				 
#include	<AfxMt.h>
#include	<AfxCmn.h>
#include	"ColorListBoxWnd.h"

#define 	CLB_COLOR_EVEN			(CLB_MAX_COLOR+0)		// Hinergrund fr   gerade Zeilen
#define 	CLB_COLOR_ODD			(CLB_MAX_COLOR+1)		// Hinergrund fr ungerade Zeilen
#define 	CLB_COLOR_EVEN_SEL		(CLB_MAX_COLOR+2)		// Hinergrund fr   gerade selektierte Zeilen 
#define 	CLB_COLOR_ODD_SEL		(CLB_MAX_COLOR+3)		// Hinergrund fr ungerade selektierte Zeilen
#define 	CLB_COLOR_EVEN_FOCUS	(CLB_MAX_COLOR+4)		// Hinergrund fr   gerade selektierte Zeilen ohne Focus
#define 	CLB_COLOR_ODD_FOCUS		(CLB_MAX_COLOR+5)		// Hinergrund fr ungerade selektierte Zeilen ohne Focus

#define 	CLB_FLAG_MARKOFF		CLB_EX_MARKOFF			// Keine       Markierungen
#define 	CLB_FLAG_MARKSINGLE		CLB_EX_MARKSINGLE		// Mehrzeilige Markierungen
#define 	CLB_FLAG_MARKMULTI		CLB_EX_MARKMULTI		// Einzeilige  Markierungen
#define 	CLB_FLAG_MARKFULL		CLB_EX_MARKFULL			// Ganzzeilige Markierungen
#define 	CLB_FLAG_MARKMASK		CLB_EX_MARKMASK			// Maske fr Markierungsart
#define 	CLB_FLAG_STEPMISC		CLB_EX_STEPMISC			// Bei Wortsprngen auch diversen Zeichen anhalten
#define 	CLB_FLAG_STEPFIRST		CLB_EX_STEPFIRST		// Bei Wortsprngen nur am Beginn eines Wortes/Bereichs anhalten
#define 	CLB_FLAG_STEPUPPER		CLB_EX_STEPUPPER		// Bei Wortsprngen auch Gro/Kleinbergngen anhalten
#define 	CLB_FLAG_STEPUNTER		CLB_EX_STEPUNTER		// Bei Wortsprngen das '-' nicht als Buchstaben betrachten
#define 	CLB_FLAG_STEPALL		CLB_EX_STEPALL			// Bei Wortsprungoptionen
#define 	CLB_FLAG_LINES			CLB_EX_GRIDLINES		// Einen Rahmen um jede Zeile zeichnen
#define 	CLB_FLAG_ALTERNATED		CLB_EX_ALTERNATECOLOR	// Abwechselnde Faren fr die Zeilen
#define 	CLB_FLAG_SELMARK		CLB_EX_SELMARK			// Ausgewhlte Zeile markieren
#define 	CLB_FLAG_SELFIELD		CLB_EX_CHECKBOXES		// Auswahlfelder einblenden
#define 	CLB_FLAG_SELDBLCLK		CLB_EX_SELDBLCLICK		// Auswahl mit Doppelklick
#define 	CLB_FLAG_SELSPACE		CLB_EX_SELSPACE			// Auswahl mit SPACE-Taste
#define 	CLB_FLAG_SELRETURN		CLB_EX_SELRETURN		// Auswahl mit SPACE-Taste
#define 	CLB_FLAG_CURSOR			CLB_EX_CURSOR			// Cursor ein bzw. ausblenden
#define 	CLB_FLAG_WORDDBLCLK		CLB_EX_SELWORDDBL		// Wortauswahl mit Doppelklick
#define 	CLB_FLAG_TABEXIT		CLB_EX_TABEXIT			// Bei TAB den Fokus ans Elternfenster geben
#define 	CLB_FLAG_NOCONTEXT		CLB_EX_NOCONTEXTMENU	// Kein Kontextmen
#define 	CLB_FLAG_NOCHGNOTIFY 	CLB_EX_NOCHANGENOTIFY	// Keine Nachrichten beim Whlen eines Eintrages	
#define 	CLB_FLAG_NOCHARSELCET	CLB_EX_NOCHARSELCET		// Keine Auswahl von Zeilen ber Texteingabe
#define 	CLB_FLAG_ALL			0xFFFFFFFF				// Maske fr alle Optionen

#define 	ID_COLORLISTBOX_DEF		0x9718

//*****************************************************************************
//*
//*		CColorListBox
//*
//*****************************************************************************
class CColorListBox : public CListBox
{
	
	DECLARE_DYNAMIC(CColorListBox)

public:
				CColorListBox();
	virtual		BOOL Create  (                DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID=ID_COLORLISTBOX_DEF);
				BOOL Create  (                DWORD dwStyle,UINT uItem       ,CDialog *pDlg   ,UINT nId=ID_COLORLISTBOX_DEF);
				BOOL CreateEx(DWORD dwExStyle,DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID=ID_COLORLISTBOX_DEF);
				BOOL CreateEx(DWORD dwExStyle,DWORD dwStyle,UINT uItem       ,CDialog *pDlg   ,UINT nId=ID_COLORLISTBOX_DEF);

	
	int			SelectString	(int    nAfter,LPCTSTR pItem,BOOL bExact=FALSE);
	int			FindString     	(int    nAfter,LPCTSTR pItem,BOOL bExact=FALSE);
	int			FindString     	(int    nAfter,LPCTSTR pItem);
	int			FindStringExact	(int    nAfter,LPCTSTR pItem);
	int			GetCursor      	(int   &iPosX  ,int &iPosY) const;
	int			GetMark        	(int   &iStart ,int &iStop) const;
	int			GetMark        	(int   &iStartX,int &iStartY,int &iStopX,int &iStopY) const;
	int			HitTest			(int	iPosX,int	iPosY,unsigned *pFlags=0);
	int			HitTest			(CPoint sPoint           ,unsigned *pFlags=0);
	UINT		ItemFromPoint  	(CPoint sPoint,BOOL &bOutside  ) const;
	UINT		ItemFromPoint  	(CPoint sPoint,BOOL *pOutside=0) const;
	BOOL		SetFont        	(CFont *pFont);
	BOOL		SetFont        	(HFONT  hFont);
	BOOL		SetFont		   	(int    iFont);
	BOOL		EnsureVisible  	(int	nIndex,BOOL bPartialOK=FALSE);
	CImageList *GetImageList	(						int nImageListType=CLBIL_STATE);
	CImageList *SetImageList	(CImageList *pImageList,int nImageListType=CLBIL_STATE);
	HIMAGELIST  SetImageList	(HIMAGELIST  hImageList,int nImageListType=CLBIL_STATE);
	int			FindItem		(CLB_FIND   *pData,int nAfter=-1);
	int			AddString      	(                          LPCTSTR pItem,const VOID *pColor=0,int iLen=-1,int iState=0);
	int			AddString      	(                          LPCTSTR pItem,      BYTE  bColor  ,int iLen=-1,int iState=0);
	int			AddString      	(            LPARAM lParam,LPCTSTR pItem,const VOID *pColor=0,int iLen=-1,int iState=0);
	int			AddString      	(            LPARAM lParam,LPCTSTR pItem,      BYTE  bColor  ,int iLen=-1,int iState=0);
	int			AddString      	(            LPARAM lParam,LPCTSTR pItem,const VOID *pColor  ,int iLen   ,int iState,int iIdent);
	int			AddString      	(            LPARAM lParam,LPCTSTR pItem,      BYTE  bColor  ,int iLen   ,int iState,int iIdent);
	int     	InsertString   	(int nIndex,               LPCTSTR pItem,const VOID *pColor=0,int iLen=-1,int iState=0);
	int     	InsertString   	(int nIndex,               LPCTSTR pItem,      BYTE  bColor  ,int iLen=-1,int iState=0);
	int     	InsertString   	(int nIndex, LPARAM lParam,LPCTSTR pItem,const VOID *pColor=0,int iLen=-1,int iState=0);
	int     	InsertString   	(int nIndex, LPARAM lParam,LPCTSTR pItem,      BYTE  bColor  ,int iLen=-1,int iState=0);
	int     	InsertString   	(int nIndex, LPARAM lParam,LPCTSTR pItem,const VOID *pColor  ,int iLen   ,int iState,int iIdent);
	int     	InsertString   	(int nIndex, LPARAM lParam,LPCTSTR pItem,      BYTE  bColor  ,int iLen   ,int iState,int iIdent);
	int			DeleteString   	(int nIndex);
	int			SetSel		   	(int nIndex,BOOL bSelect,BOOL bNotify);
	int			SetSel		   	(int nIndex,BOOL bSelect=TRUE);
	int			EnableSel	   	(int nIndex,BOOL bEnable=TRUE);
	LRESULT		SetItemDataPtr 	(int nIndex,LPVOID   pPtr);
	LPARAM		SetItemData	   	(int nIndex,LPARAM   iValue);
	int			SetItemState    (int nIndex,WORD     wState,WORD wMask);
	BOOL     	SetText        	(int nIndex,LPCTSTR  pText,			const VOID *pColor);
	BOOL     	SetText        	(int nIndex,LPCTSTR  pText,int iLen,const VOID *pColor);
	BOOL     	SetText        	(int nIndex,LPCTSTR  pText,int iLen,const BYTE  bColor);
	BOOL     	SetText        	(int nIndex,LPCTSTR  pText,int iLen=-1);
	int			GetText        	(int nIndex,LPTSTR   pBuffer,int iSize);
	int			GetText        	(int nIndex,LPTSTR   pBuffer);
	int 		GetText        	(int nIndex,CString &sString);
	LPCTSTR		GetText			(int nIndex);
	LPCTSTR		GetText			(int nIndex,int &iSize);
	int			GetTextColor    (int nIndex,LPVOID   pBuffer,int iSize);
	int			GetTextColor    (int nIndex,LPVOID   pBuffer);
	const BYTE *GetTextColor   	(int nIndex);
	const BYTE *GetTextColor   	(int nIndex,int	    &iSize);
	int 		GetItemIcon   	(int nIndex);
	BOOL		SetItemIcon   	(int nIndex,unsigned uIcon);
	int			GetTextLen     	(int nIndex) const;
	int			GetItemState    (int nIndex) const;
	LPARAM  	GetItemData	   	(int nIndex) const;
	LPVOID		GetItemDataPtr 	(int nIndex) const;
	int			GetItemIdent    (int nIndex);
	int			GetSelectedText (CString &sText,int iMode=0);
	DWORD		GetExtendedStyle() const;
	DWORD		SetExtendedStyle(DWORD dwStyle);
	DWORD		SetExtendedStyle(DWORD dwStyle,DWORD dwMask);
	BOOL		SetTextColor   	(int nIndex,const VOID *pColor,int iLen);
	BOOL		SetTextColor   	(int nIndex,const VOID *pColor);
	BOOL		SetTextColor   	(int nIndex,const BYTE  bColor=0);
	int			SetColor       	(int iNr   ,COLORREF cRgbText,COLORREF cRgbHg=0xFFFFFFFF);
	int			SetFlags       	(int iFlags,int iMask=CLB_FLAG_ALL);
	int			CaclSize        (int iPosX ,LPCTSTR pText,const VOID *pColor,int iLen=-1);
	void		SetKeyStepMode 	(int iMisc,int iFirst=0,int iUpper=0,int iUnter=0); 
	void		SetContextMode 	(int iMode );
	void		SetSelectDblclk	(int iMode );
	void		SetSelectReturn	(int iMode );
	void		SetSelectSpace 	(int iMode );
	void		SetSelectWord  	(int iMode );
	void 		SetMarkType    	(int iType );
	void		SetMarkMode    	(int iOn   );
	void		SetCharSelect  	(int iOn   );
	void		SetCursorMode  	(int iOn   );
	BOOL		SetCursor    	(int iLine,int iPos=0);
	BOOL		SetSelMark     	(int iLine,int iPos=0);
	BOOL		SetItemIdent    (int iLine,DWORD uIdent);
	void		SetTabExit	   	(int iOn   );
	void		SetChangeNotify	(int iOn   );
	void		SetAlternated  	(int iOn   );
	void		SetLineFrames  	(int iOn   );
	void 		SetSelectMode  	(int iOn   );
	int  		SetTabSize     	(int iTab  );
	int			SetTabStops	   	(int iTabs,INT *pTabStops);
	int			SetTabStops	   	(const int &iTabStop);
	int			SelectAll		(int iSel=1);
	int			SelectNone		();
	int			SelectWord     	();
	LPARAM		GetOption		(int iOption) const;
	LPARAM		SetOption		(int iOption,LPARAM  iValue);
	int			IsSeleced      	() const;
	int			GetFontHeight  	() const;
	int			GetFontWidth   	() const;
	int			GetTabSize     	() const;
	int			GetLineCount   	() const;
	int			GetCount       	() const;
	void		OnCopy			();
	void		Copy           	();
	void		MarkAll		   	();	
	void		ResetContent   	();
	LPVOID		GetLineCbParam  () const;
	LPVOID		SetLineCbParam  (LPVOID pParam);
	PFCLBLINECB	GetLineCallback	() const;
	PFCLBLINECB	SetLineCallback	(PFCLBLINECB pProc);
	DWORD		GetStyle        ();
	DWORD		SetStyle        (DWORD dwStyle);
	DWORD		SetStyle        (DWORD dwStyle,DWORD dwMask);
				
};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline void			CColorListBox::OnCopy		   (){Copy();}
inline BOOL			CColorListBox::SetFont		   (int iFont							  ){return SetFont((HFONT)((iFont)? 1:0));}
inline int 			CColorListBox::SetTabSize      (int iTab							  ){iTab=-iTab; return SetTabStops(1,&iTab);}
inline int			CColorListBox::SetTabStops	   (const int &iTabStop					  ){return SetTabStops(1,&(INT)iTabStop);}
inline BOOL			CColorListBox::Create		   (DWORD dwStyle,UINT uItem,CDialog *pDlg,UINT nId){return CreateEx(0,dwStyle,uItem,pDlg,nId);}
inline UINT			CColorListBox::ItemFromPoint   (CPoint sPoint,            BOOL &bOutside) const	{return CListBox::ItemFromPoint(sPoint,bOutside);}
inline UINT			CColorListBox::ItemFromPoint   (CPoint sPoint,            BOOL *pOutside) const {BOOL bOut;return ItemFromPoint(sPoint,(pOutside)? *pOutside:bOut);}
inline int			CColorListBox::AddString       (                          LPCTSTR pItem,const VOID *pColor,int iLen,int iState           ){return InsertString(-1           ,pItem,pColor,iLen,iState);}
inline int			CColorListBox::AddString       (                          LPCTSTR pItem,      BYTE  bColor,int iLen,int iState           ){return InsertString(-1           ,pItem,bColor,iLen,iState);}
inline int			CColorListBox::AddString       (            LPARAM lParam,LPCTSTR pItem,const VOID *pColor,int iLen,int iState           ){return InsertString(-1    ,lParam,pItem,pColor,iLen,iState);}
inline int			CColorListBox::AddString       (            LPARAM lParam,LPCTSTR pItem,      BYTE  bColor,int iLen,int iState           ){return InsertString(-1    ,lParam,pItem,bColor,iLen,iState);}
inline int			CColorListBox::AddString       (            LPARAM lParam,LPCTSTR pItem,const VOID *pColor,int iLen,int iState,int iIdent){return InsertString(-1    ,lParam,pItem,pColor,iLen,iState,iIdent);}
inline int			CColorListBox::AddString       (            LPARAM lParam,LPCTSTR pItem,      BYTE  bColor,int iLen,int iState,int iIdent){return InsertString(-1    ,lParam,pItem,bColor,iLen,iState,iIdent);}
inline int			CColorListBox::InsertString    (int nIndex               ,LPCTSTR pText,      BYTE  bColor,int iLen,int iState           ){return InsertString(nIndex       ,pText,(BYTE*)bColor,iLen,iState);}
inline int			CColorListBox::InsertString    (int nIndex ,LPARAM lParam,LPCTSTR pText,      BYTE  bColor,int iLen,int iState           ){return InsertString(nIndex,lParam,pText,(BYTE*)bColor,iLen,iState);}
inline int			CColorListBox::InsertString    (int nIndex ,LPARAM lParam,LPCTSTR pText,      BYTE  bColor,int iLen,int iState,int iIdent){return InsertString(nIndex,lParam,pText,(BYTE*)bColor,iLen,iState,iIdent);}
inline BOOL			CColorListBox::SetText         (int nIndex ,LPCTSTR pText,int iLen,const BYTE  bColor){return SetText(nIndex,pText,iLen,(BYTE*)bColor);}
inline BOOL     	CColorListBox::SetText         (int nIndex ,LPCTSTR pText         ,const VOID *pColor){return SetText(nIndex,pText,-1         ,pColor);}
inline BOOL			CColorListBox::SetTextColor    (int nIndex ,const BYTE bColor ){return SetTextColor(nIndex,(LPBYTE)bColor);}
inline int			CColorListBox::SetSel          (int nIndex ,BOOL bSelect){return SetSel(nIndex,bSelect,FALSE);}
inline LRESULT		CColorListBox::SetItemDataPtr  (int nIndex, LPVOID  pPtr){return SetItemData(nIndex,(LPARAM)pPtr);};
inline LPVOID		CColorListBox::GetItemDataPtr  (int nIndex) const{return (LPVOID)GetItemData(nIndex);};
inline int			CColorListBox::IsSeleced	   ()const {int iTemp1,iTemp2;return GetMark(iTemp1,iTemp2);}
inline int			CColorListBox::FindString      (int nAfter,LPCTSTR pText){return FindString(nAfter,pText,FALSE);}
inline int			CColorListBox::FindStringExact (int nAfter,LPCTSTR pText){return FindString(nAfter,pText,TRUE);}
inline int			CColorListBox::FindItem		   (CLB_FIND *pData,int nAfter ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_FindItem(m_hWnd,nAfter,pData);}

inline void			CColorListBox::ResetContent    ()                           {ASSERT(::IsWindow(m_hWnd));       ColorListBox_DeleteAllItems  (m_hWnd);}
inline DWORD		CColorListBox::GetExtendedStyle() const						{ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetExtendedStyle(m_hWnd);}
inline DWORD		CColorListBox::SetExtendedStyle(DWORD dwStyle)				{ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetExtendedStyle(m_hWnd,dwStyle); }
inline DWORD		CColorListBox::SetExtendedStyle(DWORD dwStyle,DWORD dwMask ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetExtendedStyleEx(m_hWnd,dwStyle,dwMask); }
inline BOOL			CColorListBox::SetFont		   (HFONT hFont			       ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetFont(m_hWnd,hFont,TRUE);}
inline int			CColorListBox::SetTabStops	   (int iTabs,INT *pTabStops   ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetTabStops(m_hWnd,iTabs,pTabStops);}
inline LPARAM		CColorListBox::GetItemData     (int iLine                  ) const   {ASSERT(::IsWindow(m_hWnd)); return ColorListBox_GetItemData(m_hWnd,iLine);}
inline LPARAM		CColorListBox::SetItemData     (int iLine ,LPARAM lParam   )         {ASSERT(::IsWindow(m_hWnd)); return ColorListBox_SetItemData(m_hWnd,iLine,lParam);}
inline int			CColorListBox::GetItemState    (int iLine                  ) const   {ASSERT(::IsWindow(m_hWnd)); return ColorListBox_GetItemState(m_hWnd,iLine);}
inline int			CColorListBox::SetItemState    (int iLine,WORD wState,WORD wMask)    {ASSERT(::IsWindow(m_hWnd)); return ColorListBox_SetItemState(m_hWnd,iLine,wState,wMask);}
inline int			CColorListBox::DeleteString    (int iLine                  )         {ASSERT(::IsWindow(m_hWnd)); return ColorListBox_DeleteItems(m_hWnd,iLine,1);}
inline int			CColorListBox::SelectString    (int nAfter,LPCTSTR pText,BOOL bExact){ASSERT(::IsWindow(m_hWnd)); return (int)::SendMessage(m_hWnd,(bExact)? CLB_SELECTSTRINGEXACT:LB_SELECTSTRING,nAfter,(LPARAM)pText);}
inline int			CColorListBox::FindString      (int nAfter,LPCTSTR pText,BOOL bExact){ASSERT(::IsWindow(m_hWnd)); return (int)::SendMessage(m_hWnd,(bExact)? LB_FINDSTRINGEXACT:LB_FINDSTRING     ,nAfter,(LPARAM)pText);}
inline int			CColorListBox::GetLineCount    (       )const{ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetVisibleCount(m_hWnd);}
inline int			CColorListBox::GetCount        (       )const{ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetCount(m_hWnd);}
inline int			CColorListBox::GetFontHeight   (       )const{ASSERT(::IsWindow(m_hWnd));return (int)ColorListBox_GetOption(m_hWnd,CLBO_FONTHEIGHT); }
inline int			CColorListBox::GetFontWidth    (       )const{ASSERT(::IsWindow(m_hWnd));return (int)ColorListBox_GetOption(m_hWnd,CLBO_FONTWIDTH ); }
inline int			CColorListBox::GetTabSize      (       )const{ASSERT(::IsWindow(m_hWnd));return (int)ColorListBox_GetOption(m_hWnd,CLBO_TABSTEPS  ); }
inline void 		CColorListBox::MarkAll		   (       ){ASSERT(::IsWindow(m_hWnd));ColorListBox_MarkAll(m_hWnd);}
inline void 		CColorListBox::Copy			   (       ){ASSERT(::IsWindow(m_hWnd));ColorListBox_Copy(m_hWnd);}
inline void			CColorListBox::SetChangeNotify (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_NOCHANGENOTIFY:0,CLB_EX_NOCHANGENOTIFY);}
inline void			CColorListBox::SetAlternated   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_ALTERNATECOLOR:0,CLB_EX_ALTERNATECOLOR);}
inline void			CColorListBox::SetContextMode  (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_NOCONTEXTMENU :0,CLB_EX_NOCONTEXTMENU );}
inline void			CColorListBox::SetCharSelect   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_NOCHARSELCET  :0,CLB_EX_NOCHARSELCET  );}
inline void			CColorListBox::SetSelectDblclk (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_FLAG_SELDBLCLK   :0,CLB_EX_SELDBLCLICK   );}
inline void			CColorListBox::SetSelectMode   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_CHECKBOXES    :0,CLB_EX_CHECKBOXES    );}
inline void			CColorListBox::SetLineFrames   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_GRIDLINES     :0,CLB_EX_GRIDLINES     );}
inline void			CColorListBox::SetCursorMode   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_CURSOR        :0,CLB_EX_CURSOR        );}
inline void			CColorListBox::SetTabExit      (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_TABEXIT       :0,CLB_EX_TABEXIT       );}
inline void			CColorListBox::SetMarkMode     (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_SELMARK       :0,CLB_EX_SELMARK       );}
inline void			CColorListBox::SetSelectSpace  (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_SELSPACE      :0,CLB_EX_SELSPACE      );}
inline void			CColorListBox::SetSelectReturn (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_SELRETURN     :0,CLB_EX_SELRETURN     );}
inline void			CColorListBox::SetSelectWord   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_SELWORDDBL    :0,CLB_EX_SELWORDDBL    );}
inline int			CColorListBox::GetTextLen	   (int iLine) const {ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetTextLen(m_hWnd,iLine);}
inline void			CColorListBox::SetMarkType     (int iType){ASSERT(CLB_EX_MARKMASK==3);ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,iType,CLB_EX_MARKMASK);}
inline void			CColorListBox::SetKeyStepMode  (int iMisc,int iFirst,int iUpper,int iUnter){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,((iMisc)? CLB_EX_STEPMISC:0)|((iFirst)? CLB_EX_STEPFIRST:0)|((iUpper)? CLB_EX_STEPUPPER:0)|((iUnter)? CLB_EX_STEPUNTER:0),CLB_EX_STEPALL);}
inline int			CColorListBox::GetMark         (int &iStartX,int &iStartY,int &iStopX,int &iStopY)const{INT iRet,aVal[4];ASSERT(::IsWindow(m_hWnd));iRet=ColorListBox_GetMarkEx(m_hWnd,aVal);iStartX=aVal[0];iStartY=aVal[1];iStopX=aVal[2];iStopY=aVal[3];return iRet;}
inline int			CColorListBox::GetMark         (int &iStart ,int &iStop)const{ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetMark(m_hWnd,&iStart,&iStop);}
inline BOOL			CColorListBox::EnsureVisible   (int nIndex,BOOL bPartialOK){ASSERT(::IsWindow(m_hWnd));return ColorListBox_EnsureVisible(m_hWnd,nIndex,bPartialOK);}
inline BOOL			CColorListBox::SetSel		   (int nIndex,BOOL bSelect,BOOL bNotify){ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetSel(m_hWnd,nIndex,bSelect,bNotify);}
inline CImageList  *CColorListBox::GetImageList	   (int nImageListType){ ASSERT(::IsWindow(m_hWnd)); return CImageList::FromHandle(ColorListBox_GetImageList(m_hWnd,nImageListType));}
inline HIMAGELIST	CColorListBox::SetImageList	   (HIMAGELIST  hImageList,int nImageListType){ ASSERT(::IsWindow(m_hWnd)); return ColorListBox_SetImageList(m_hWnd,hImageList,nImageListType);}
inline CImageList  *CColorListBox::SetImageList	   (CImageList* pImageList,int nImageListType){ HIMAGELIST hImageList=CColorListBox::SetImageList(pImageList->GetSafeHandle(),nImageListType); if(!hImageList)return 0; return CImageList::FromHandle(hImageList);}
inline LPVOID		CColorListBox::GetLineCbParam  () const										{ ASSERT(::IsWindow(m_hWnd)); return (PFCLBLINECB)ColorListBox_SetOption(m_hWnd,CLBO_LINECBPARAM ,0);}
inline LPVOID		CColorListBox::SetLineCbParam  (LPVOID pParam)								{ ASSERT(::IsWindow(m_hWnd)); return (PFCLBLINECB)ColorListBox_SetOption(m_hWnd,CLBO_LINECBPARAM ,pParam);}
inline PFCLBLINECB	CColorListBox::GetLineCallback () const										{ ASSERT(::IsWindow(m_hWnd)); return (PFCLBLINECB)ColorListBox_SetOption(m_hWnd,CLBO_LINECALLBACK,0);}
inline PFCLBLINECB	CColorListBox::SetLineCallback (PFCLBLINECB pProc)							{ ASSERT(::IsWindow(m_hWnd)); return (PFCLBLINECB)ColorListBox_SetOption(m_hWnd,CLBO_LINECALLBACK,pProc);}
inline int			CColorListBox::SelectAll	   (int iSel)									{ ASSERT(::IsWindow(m_hWnd)); return              ColorListBox_SelectAll(m_hWnd,iSel);}
inline int			CColorListBox::SelectNone	   ()											{ ASSERT(::IsWindow(m_hWnd)); return              ColorListBox_SelectAll(m_hWnd,0   );}
inline LPARAM		CColorListBox::SetOption       (int iOption,LPARAM iValue)					{ ASSERT(::IsWindow(m_hWnd)); return              ColorListBox_SetOption(m_hWnd,iOption,iValue); }
inline LPARAM		CColorListBox::GetOption       (int iOption) const							{ ASSERT(::IsWindow(m_hWnd)); return              ColorListBox_GetOption(m_hWnd,iOption); }
inline int 			CColorListBox::GetItemIcon     (int nIndex               ){return CLBS_ICON_GET(GetItemState(nIndex));}
inline BOOL			CColorListBox::SetItemIcon     (int nIndex,unsigned uIcon){return SetItemState(nIndex,CLBS_ICON_SET(uIcon),CLBS_ICON_MASK);}
inline BOOL			CColorListBox::SetFont         (CFont *pFont){if(!pFont)return FALSE;if(!pFont->m_hObject)return FALSE;return SetFont((HFONT)pFont->m_hObject);}
inline int			CColorListBox::EnableSel	   (int nIndex,BOOL bEnable){CLB_ITEM sItem;ASSERT(::IsWindow(m_hWnd));sItem.uMask=CLBF_STATE;sItem.uState=(bEnable)? 0:CLBS_NOBOX;sItem.uStateMask=CLBS_NOBOX;sItem.iItem=nIndex;return ColorListBox_SetItem(m_hWnd,&sItem,0);}
inline int			CColorListBox::SetColor		   (int iNr,COLORREF cRgbText,COLORREF cRgbHg){ASSERT(::IsWindow(m_hWnd));if((unsigned)iNr>=CLB_MAX_COLOR+CLB_ADD_COLOR){return LB_ERR;}if(cRgbText!=0xFFFFFFFF){ColorListBox_SetColor(m_hWnd,iNr,cRgbText);}ColorListBox_SetColor(m_hWnd,iNr+CLB_MAX_COLOR+CLB_ADD_COLOR,cRgbHg);return iNr;}
inline int			CColorListBox::SetFlags		   (int iFlags,int iMask){int iOld;ASSERT(::IsWindow(m_hWnd));iOld=ColorListBox_GetExtendedStyle(m_hWnd);ColorListBox_SetExtendedStyleEx(m_hWnd,iFlags,iMask);return iOld;}
inline int			CColorListBox::CaclSize        (int iPosX ,LPCTSTR pText,const VOID *pColor,int iLen)           {ASSERT(::IsWindow(m_hWnd));CLB_ITEM sItem;                                            sItem.iTextMax=iLen;sItem.pColor=(LPBYTE)pColor;sItem.pText=(LPTSTR)pText;return ColorListBox_CaclSize(m_hWnd,iPosX,&sItem);}
inline int			CColorListBox::InsertString	   (int nIndex,LPCTSTR pText,const VOID *pColor,int iLen,int iState){ASSERT(::IsWindow(m_hWnd));CLB_ITEM sItem;sItem.uMask=CLBF_TEXT|CLBF_COLOR|CLBF_STATE;sItem.iTextMax=iLen;sItem.pColor=(LPBYTE)pColor;sItem.pText=(LPTSTR)pText;sItem.uState=iState;sItem.uStateMask=0xFFFFFFFF;sItem.iItem=nIndex;return ColorListBox_InsertItem(m_hWnd,&sItem,iState&(CLBF_FAST|CLBF_ENDSCROLL));}
inline int			CColorListBox::InsertString	   (int nIndex,LPARAM lParam,LPCTSTR pText,const VOID *pColor,int iLen,int iState           ){ASSERT(::IsWindow(m_hWnd));CLB_ITEM sItem;sItem.uMask=CLBF_TEXT|CLBF_COLOR|CLBF_STATE|CLBF_PARAM           ;sItem.iTextMax=iLen;sItem.lParam=lParam;sItem.pColor=(LPBYTE)pColor;sItem.pText=(LPTSTR)pText;sItem.uState=iState                 ;sItem.uStateMask=0xFFFFFFFF;sItem.iItem=nIndex;return ColorListBox_InsertItem(m_hWnd,&sItem,iState&(CLBF_FAST|CLBF_ENDSCROLL));}
inline int			CColorListBox::InsertString	   (int nIndex,LPARAM lParam,LPCTSTR pText,const VOID *pColor,int iLen,int iState,int iIdent){ASSERT(::IsWindow(m_hWnd));CLB_ITEM sItem;sItem.uMask=CLBF_TEXT|CLBF_COLOR|CLBF_STATE|CLBF_PARAM|CLBF_IDENT;sItem.iTextMax=iLen;sItem.lParam=lParam;sItem.pColor=(LPBYTE)pColor;sItem.pText=(LPTSTR)pText;sItem.uState=MAKELONG(iState,iIdent);sItem.uStateMask=0xFFFFFFFF;sItem.iItem=nIndex;return ColorListBox_InsertItem(m_hWnd,&sItem,iState&(CLBF_FAST|CLBF_ENDSCROLL));}
inline BOOL			CColorListBox::SetTextColor	   (int nIndex,const VOID *pColor         ){ASSERT(::IsWindow(m_hWnd));CLB_ITEM sItem;sItem.iItem=nIndex;sItem.uMask=CLBF_COLOR;sItem.pColor=(LPBYTE)pColor;sItem.iTextMax=0x4000;return ColorListBox_SetItem(m_hWnd,&sItem,0);}
inline BOOL			CColorListBox::SetTextColor	   (int nIndex,const VOID *pColor,int iLen){ASSERT(::IsWindow(m_hWnd));CLB_ITEM	sItem;sItem.iItem=nIndex;sItem.uMask=CLBF_COLOR;sItem.pColor=(LPBYTE)pColor;sItem.iTextMax=iLen  ;return ColorListBox_SetItem(m_hWnd,&sItem,0);}
inline BOOL			CColorListBox::SetText		   (int nIndex,LPCTSTR pText,int iLen,const VOID *pColor){ASSERT(::IsWindow(m_hWnd));CLB_ITEM sItem;if(iLen<0)iLen=(int)_tcslen(pText);sItem.iItem=nIndex;sItem.uMask=((LPARAM)pColor==0xFF)? CLBF_TEXT:CLBF_TEXT|CLBF_COLOR;sItem.pColor=(LPBYTE)pColor;sItem.pText=(LPTSTR)pText;sItem.iTextMax=iLen;return ColorListBox_SetItem(m_hWnd,&sItem,0);}
inline BOOL			CColorListBox::SetText		   (int nIndex,LPCTSTR pText,int iLen                   ){ASSERT(::IsWindow(m_hWnd));CLB_ITEM sItem;if(iLen<0)iLen=(int)_tcslen(pText);sItem.iItem=nIndex;sItem.uMask=CLBF_TEXT;sItem.pText=(LPTSTR)pText;sItem.iTextMax=iLen;return ColorListBox_SetItem(m_hWnd,&sItem,0);}
inline LPCTSTR		CColorListBox::GetText		   (int nIndex,int &iSize){ASSERT(::IsWindow(m_hWnd));CLB_ITEM sItem;sItem.uMask=CLBF_TEXTPTR|CLBF_TEXT;sItem.iItem=nIndex;if(!ColorListBox_GetItem(m_hWnd,&sItem)){iSize=0;return 0;}iSize = sItem.iTextMax;return sItem.pText;}
inline LPCTSTR		CColorListBox::GetText		   (int nIndex           ){ASSERT(::IsWindow(m_hWnd));CLB_ITEM sItem;sItem.uMask=CLBF_TEXTPTR|CLBF_TEXT;sItem.iItem=nIndex;if(!ColorListBox_GetItem(m_hWnd,&sItem)){        return 0;}                       return sItem.pText;}
inline int			CColorListBox::GetText		   (int nIndex,LPTSTR pBuffer){ASSERT(::IsWindow(m_hWnd));CLB_ITEM sItem;sItem.uMask=CLBF_TEXT;sItem.iItem=nIndex;sItem.iTextMax=0x4000;sItem.pText=pBuffer;if(!ColorListBox_GetItem(m_hWnd,&sItem)){return LB_ERR;}return sItem.iTextMax;}
inline int			CColorListBox::GetText		   (int nIndex,LPTSTR pBuffer,int iSize){ASSERT(::IsWindow(m_hWnd));CLB_ITEM sItem;sItem.uMask=CLBF_TEXT;sItem.iItem=nIndex;sItem.iTextMax=iSize;sItem.pText=pBuffer;if(!ColorListBox_GetItem(m_hWnd,&sItem)){iSize = 0;return LB_ERR;}return sItem.iTextMax;}
inline BOOL			CColorListBox::SetCursor       (int iLine,int iPos){ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetCursor (m_hWnd,iLine,iPos);}
inline BOOL			CColorListBox::SetSelMark      (int iLine,int iPos){ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetSelMark(m_hWnd,iLine,iPos);}
inline BOOL			CColorListBox::SetItemIdent    (int iLine,DWORD uIdent){ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetItemIdent(m_hWnd,iLine,uIdent);}
inline int 			CColorListBox::GetItemIdent    (int iLine             ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetItemIdent(m_hWnd,iLine);}
inline BOOL			CColorListBox::GetCursor       (int&iPosX,int&iPosY) const  { ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetCursor(m_hWnd,(WPARAM)&iPosX,(LPARAM)&iPosY);}
inline DWORD		CColorListBox::GetStyle        ()	 						{ ASSERT(::IsWindow(m_hWnd)); return ColorListBox_GetStyle(m_hWnd); }
inline DWORD		CColorListBox::SetStyle        (DWORD dwStyle)				{ ASSERT(::IsWindow(m_hWnd)); return ColorListBox_SetStyle(m_hWnd,dwStyle); }
inline DWORD		CColorListBox::SetStyle        (DWORD dwStyle,DWORD dwMask)	{ ASSERT(::IsWindow(m_hWnd)); return ColorListBox_SetStyleEx(m_hWnd,dwStyle,dwMask); }

//{{AFX_INSERT_LOCATION}}

#endif
