//*****************************************************************************
//*
//*		
//*		ColorListBoxCtrl.h
//*
//*
//*****************************************************************************
#ifndef 	__FASTLISTCTRL_H__
#define 	__FASTLISTCTRL_H__

#if _MSC_VER > 1000
#pragma once
#endif

#include	<AfxMt.h>
#include	<AfxCmn.h>
#include	"ColorListBoxWnd.h"

#define 	CLB_COLOR_EVEN			(CLB_MAX_COLOR+0)		// Hinergrund fr   gerade Zeilen
#define 	CLB_COLOR_ODD			(CLB_MAX_COLOR+1)		// Hinergrund fr ungerade Zeilen
#define 	CLB_COLOR_EVEN_SEL		(CLB_MAX_COLOR+2)		// Hinergrund fr   gerade selektierte Zeilen 
#define 	CLB_COLOR_ODD_SEL		(CLB_MAX_COLOR+3)		// Hinergrund fr ungerade selektierte Zeilen
#define 	CLB_COLOR_EVEN_FOCUS	(CLB_MAX_COLOR+4)		// Hinergrund fr   gerade selektierte Zeilen ohne Focus
#define 	CLB_COLOR_ODD_FOCUS		(CLB_MAX_COLOR+5)		// Hinergrund fr ungerade selektierte Zeilen ohne Focus

#define 	CLB_FLAG_MARKOFF		CLB_EX_MARKOFF			// Keine       Markierungen
#define 	CLB_FLAG_MARKSINGLE		CLB_EX_MARKSINGLE		// Mehrzeilige Markierungen
#define 	CLB_FLAG_MARKMULTI		CLB_EX_MARKMULTI		// Einzeilige  Markierungen
#define 	CLB_FLAG_MARKFULL		CLB_EX_MARKFULL			// Ganzzeilige Markierungen
#define 	CLB_FLAG_MARKMASK		CLB_EX_MARKMASK			// Maske fr Markierungsart
#define 	CLB_FLAG_STEPMISC		CLB_EX_STEPMISC			// Bei Wortsprngen auch diversen Zeichen anhalten
#define 	CLB_FLAG_STEPFIRST		CLB_EX_STEPFIRST		// Bei Wortsprngen nur am Beginn eines Wortes/Bereichs anhalten
#define 	CLB_FLAG_STEPUPPER		CLB_EX_STEPUPPER		// Bei Wortsprngen auch Gro/Kleinbergngen anhalten
#define 	CLB_FLAG_STEPUNTER		CLB_EX_STEPUNTER		// Bei Wortsprngen das '-' nicht als Buchstaben betrachten
#define 	CLB_FLAG_STEPALL		CLB_EX_STEPALL			// Bei Wortsprungoptionen
#define 	CLB_FLAG_LINES			CLB_EX_GRIDLINES		// Einen Rahmen um jede Zeile zeichen
#define 	CLB_FLAG_ALTERNATED		CLB_EX_ALTERNATECOLOR	// Abwechselnde Faren fr die Zeilen
#define 	CLB_FLAG_SELMARK		CLB_EX_SELMARK			// Ausgewhlte Zeile markieren
#define 	CLB_FLAG_SELFIELD		CLB_EX_CHECKBOXES		// Auswahlfelder einblenden
#define 	CLB_FLAG_SELDBLCLK		CLB_EX_SELDBLCLICK		// Auswahl mit Doppelcklick
#define 	CLB_FLAG_SELSPACE		CLB_EX_SELSPACE			// Auswahl mit SPACE-Taste
#define 	CLB_FLAG_SELRETURN		CLB_EX_SELRETURN		// Auswahl mit SPACE-Taste
#define 	CLB_FLAG_CURSOR			CLB_EX_CURSOR			// Cursor ein bzw. ausblenden
#define 	CLB_FLAG_WORDDBLCLK		CLB_EX_SELWORDDBL		// Wortauswahl mit Doppelcklick
#define 	CLB_FLAG_TABEXIT		CLB_EX_TABEXIT			// Bei TAB den Focus ans Elternfenster geben
#define 	CLB_FLAG_NOCONTEXT		CLB_EX_NOCONTEXTMENU	// Kein Kontextmen
#define 	CLB_FLAG_NOCHGNOTIFY 	CLB_EX_NOCHANGENOTIFY	// Keine Nachrichten beim Whlen eines Eintrages	
#define 	CLB_FLAG_NOCHARSELCET	CLB_EX_NOCHARSELCET		// Keine Auswahl von Zeilen ber Texteingabe
#define 	CLB_FLAG_ALL			0xFFFFFFFF				// Maske fr alle Optionen



//*****************************************************************************
//*
//*		CColorListBox
//*
//*****************************************************************************
class CColorListBox : public CListBox
{
	
	DECLARE_DYNAMIC(CColorListBox)

public:
			CColorListBox();
	virtual BOOL CColorListBox::Create  (                DWORD dwStyle,const RECT &sRect,CWnd* pParentWnd,UINT nID=0);
	        BOOL CColorListBox::CreateEx(DWORD dwExStyle,DWORD dwStyle,const RECT &sRect,CWnd* pParentWnd,UINT nID=0);

	
	int		SelectString	(int    nAfter,LPCTSTR pItem,BOOL bExact=FALSE);
	int		FindString     	(int    nAfter,LPCTSTR pItem,BOOL bExact=FALSE);
	int		FindString     	(int    nAfter,LPCTSTR pItem);
	int		FindStringExact	(int    nAfter,LPCTSTR pItem);
	int		GetMark        	(int   &iStart ,int &iStop);
	int		GetMark        	(int   &iStartX,int &iStartY,int &iStopX,int &iStopY);
	UINT	ItemFromPoint  	(CPoint sPoint,BOOL &bOutside  ) const;
	UINT	ItemFromPoint  	(CPoint sPoint,BOOL *pOutside=0) const;
	BOOL	SetFont        	(CFont *pFont);
	BOOL	SetFont        	(HFONT  hFont);
	BOOL	SetFont		   	(int    iFont);
	BOOL	EnsureVisible  	(int nIndex, BOOL    bPartialOK=FALSE);
	int		AddString      	(                          LPCTSTR pItem,const BYTE *pColor=0,int iLen=-1,int iState=0,int iMask=0);
	int		AddString      	(                          LPCTSTR pItem,      BYTE  bColor  ,int iLen=-1,int iState=0,int iMask=0);
	int		AddString      	(            LPARAM lParam,LPCTSTR pItem,const BYTE *pColor=0,int iLen=-1,int iState=0,int iMask=0);
	int		AddString      	(            LPARAM lParam,LPCTSTR pItem,      BYTE  bColor  ,int iLen=-1,int iState=0,int iMask=0);
	int     InsertString   	(int nIndex,               LPCTSTR pItem,const BYTE *pColor=0,int iLen=-1,int iState=0,int iMask=0);
	int     InsertString   	(int nIndex,               LPCTSTR pItem,      BYTE  bColor  ,int iLen=-1,int iState=0,int iMask=0);
	int     InsertString   	(int nIndex, LPARAM lParam,LPCTSTR pItem,const BYTE *pColor=0,int iLen=-1,int iState=0,int iMask=0);
	int     InsertString   	(int nIndex, LPARAM lParam,LPCTSTR pItem,      BYTE  bColor  ,int iLen=-1,int iState=0,int iMask=0);
	int		DeleteString   	(int nIndex);
	int		SetSel		   	(int nIndex,BOOL bSelect,BOOL bNotify);
	int		SetSel		   	(int nIndex,BOOL bSelect=TRUE);
	int		EnableSel	   	(int nIndex,BOOL bEnable=TRUE);
	int		SetItemDataPtr 	(int nIndex,LPVOID   pPtr);
	LPARAM	SetItemData	   	(int nIndex,LPARAM   iValue);
	int     SetText        	(int nIndex,LPCTSTR  pText,int iLen,const BYTE *pColor);
	int     SetText        	(int nIndex,LPCTSTR  pText,int iLen=-1,   BYTE  bColor=0xFF);
	int		GetText        	(int nIndex,LPTSTR   pBuffer,int iSize);
	int		GetText        	(int nIndex,LPTSTR   pBuffer);
	int 	GetText        	(int nIndex,CString &sString);
	LPCTSTR	GetText        	(int nIndex,int	    &iSize);
	LPCTSTR	GetText        	(int nIndex);
	int		GetTextLen     	(int nIndex) const;
	LPARAM  GetItemData	   	(int nIndex) const;
	LPVOID	GetItemDataPtr 	(int nIndex) const;
	DWORD	GetExtendedStyle() const;
	DWORD	SetExtendedStyle(DWORD dwStyle);
	DWORD	SetExtendedStyle(DWORD dwStyle,DWORD dwMask);
	int		SetTextColor   	(int nIndex,const BYTE *pColor);
	int		SetTextColor   	(int nIndex,      BYTE  bColor=0);
	int		SetColor       	(int iNr   ,COLORREF cRgbText,COLORREF cRgbHg=0xFFFFFFFF);
	int		SetFlags       	(int iFlags,int iMask=CLB_FLAG_ALL);
	void	SetKeyStepMode 	(int iMisc,int iFirst=0,int iUpper=0,int iUnter=0); 
	void	SetContextMode 	(int iMode );
	void	SetSelectDblclk	(int iMode );
	void	SetSelectReturn	(int iMode );
	void	SetSelectSpace 	(int iMode );
	void	SetSelectWord  	(int iMode );
	void 	SetMarkType    	(int iType );
	void	SetMarkMode    	(int iOn   );
	void	SetCharSelect  	(int iOn   );
	void	SetCursorMode  	(int iOn   );
	void	SetTabExit	   	(int iOn   );
	void	SetChangeNotify	(int iOn   );
	void	SetAlternated  	(int iOn   );
	void	SetLineFrames  	(int iOn   );
	void 	SetSelectMode  	(int iOn   );
	int  	SetTabSize     	(int iTab  );
	int		SetTabStops	   	(int iTabs,INT *pTabStops);
	int		SetTabStops	   	(const int &iTabStop);
	int		SelectWord     	();
	int		IsSeleced      	();
	int		GetFontHeight  	();
	int		GetFontWidth   	();
	int		GetTabSize     	();
	int		GetLineCount   	();
	void	ResetContent   	();
	int		GetCount       	();
	void	MarkAll		   	();	
	void	Copy           	();


public:

	
};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline BOOL		CColorListBox::SetFont		   (int iFont								  ){return SetFont((HFONT)((iFont)? 1:0));}
inline int 		CColorListBox::SetTabSize      (int iTab								  ){iTab=-iTab; return SetTabStops(1,&iTab);}
inline int		CColorListBox::SetTabStops	   (const int &iTabStop					  ){return SetTabStops(1,&(INT)iTabStop);}
inline UINT		CColorListBox::ItemFromPoint   (CPoint sPoint,            BOOL &bOutside) const	{return CListBox::ItemFromPoint(sPoint,bOutside);}
inline UINT		CColorListBox::ItemFromPoint   (CPoint sPoint,            BOOL *pOutside) const {BOOL bOut;return ItemFromPoint(sPoint,(pOutside)? *pOutside:bOut);}
inline int		CColorListBox::AddString       (                          LPCTSTR pItem,const BYTE *pColor,int iLen,int iState,int iMask){return InsertString(-1           ,pItem,pColor,iLen,iState,iMask);}
inline int		CColorListBox::AddString       (                          LPCTSTR pItem,      BYTE  bColor,int iLen,int iState,int iMask){return InsertString(-1           ,pItem,bColor,iLen,iState,iMask);}
inline int		CColorListBox::AddString       (            LPARAM lParam,LPCTSTR pItem,const BYTE *pColor,int iLen,int iState,int iMask){return InsertString(-1    ,lParam,pItem,pColor,iLen,iState,iMask);}
inline int		CColorListBox::AddString       (            LPARAM lParam,LPCTSTR pItem,      BYTE  bColor,int iLen,int iState,int iMask){return InsertString(-1    ,lParam,pItem,bColor,iLen,iState,iMask);}
inline int		CColorListBox::InsertString    (int nIndex               ,LPCTSTR pText,      BYTE  bColor,int iLen,int iState,int iMask){return InsertString(nIndex       ,pText,(BYTE*)bColor,iLen,iState,iMask);}
inline int		CColorListBox::InsertString    (int nIndex ,LPARAM lParam,LPCTSTR pText,      BYTE  bColor,int iLen,int iState,int iMask){return InsertString(nIndex,lParam,pText,(BYTE*)bColor,iLen,iState,iMask);}
inline int		CColorListBox::SetText         (int nIndex ,LPCTSTR pText,int iLen,BYTE  bColor){return SetText     (nIndex,pText,iLen,(BYTE*)bColor);}
inline int		CColorListBox::SetTextColor    (int nIndex, BYTE bColor ){return SetTextColor(nIndex,(BYTE*)bColor);}
inline int		CColorListBox::SetSel          (int nIndex ,BOOL bSelect){return SetSel(nIndex,bSelect,FALSE);}
inline int		CColorListBox::SetItemDataPtr  (int nIndex, LPVOID  pPtr){return SetItemData(nIndex,(LPARAM)pPtr);};
inline LPVOID	CColorListBox::GetItemDataPtr  (int nIndex) const{return (LPVOID)GetItemData(nIndex);};
inline int		CColorListBox::IsSeleced	   (){int iTemp1,iTemp2;return GetMark(iTemp1,iTemp2);}
inline int		CColorListBox::FindString      (int nAfter,LPCTSTR pText){return FindString(nAfter,pText,FALSE);}
inline int		CColorListBox::FindStringExact (int nAfter,LPCTSTR pText){return FindString(nAfter,pText,TRUE);}

inline void		CColorListBox::ResetContent    ()                           {ASSERT(::IsWindow(m_hWnd));       ColorListBox_DeleteAllItems  (m_hWnd);}
inline DWORD	CColorListBox::GetExtendedStyle() const						{ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetExtendedStyle(m_hWnd);}
inline DWORD	CColorListBox::SetExtendedStyle(DWORD dwStyle)				{ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetExtendedStyle(m_hWnd,dwStyle); }
inline DWORD	CColorListBox::SetExtendedStyle(DWORD dwStyle,DWORD dwMask ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetExtendedStyleEx(m_hWnd,dwStyle,dwMask); }
inline BOOL		CColorListBox::SetFont		   (HFONT hFont			       ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetFont(m_hWnd,hFont,TRUE);}
inline int		CColorListBox::SetTabStops	   (int iTabs,INT *pTabStops   ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetTabStops(m_hWnd,iTabs,pTabStops);}
inline LPARAM	CColorListBox::GetItemData     (int iLine                  ) const   {ASSERT(::IsWindow(m_hWnd)); return ColorListBox_GetItemData(m_hWnd,iLine);}
inline LPARAM	CColorListBox::SetItemData     (int iLine ,LPARAM lParam   )         {ASSERT(::IsWindow(m_hWnd)); return ColorListBox_SetItemData(m_hWnd,iLine,lParam);}
inline int		CColorListBox::DeleteString    (int iLine                  )         {ASSERT(::IsWindow(m_hWnd)); return ColorListBox_DeleteItems(m_hWnd,iLine,1);}
inline int		CColorListBox::SelectString    (int nAfter,LPCTSTR pText,BOOL bExact){ASSERT(::IsWindow(m_hWnd)); return (int)::SendMessage(m_hWnd,(bExact)? CLB_SELECTSTRINGEXACT:LB_SELECTSTRING,nAfter,(LPARAM)pText);}
inline int		CColorListBox::FindString      (int nAfter,LPCTSTR pText,BOOL bExact){ASSERT(::IsWindow(m_hWnd)); return (int)::SendMessage(m_hWnd,(bExact)? LB_FINDSTRINGEXACT:LB_FINDSTRING     ,nAfter,(LPARAM)pText);}
inline int		CColorListBox::GetLineCount    (       ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetVisibleCount(m_hWnd);}
inline int		CColorListBox::GetCount        (       ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetCount(m_hWnd);}
inline int		CColorListBox::GetFontHeight   (       ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetOption(m_hWnd,CLBO_FONTHEIGHT); }
inline int		CColorListBox::GetFontWidth    (       ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetOption(m_hWnd,CLBO_FONTWIDTH ); }
inline int		CColorListBox::GetTabSize      (       ){ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetOption(m_hWnd,CLBO_TABSTEPS  ); }
inline void 	CColorListBox::MarkAll		   (       ){ASSERT(::IsWindow(m_hWnd));ColorListBox_MarkAll(m_hWnd);}
inline void 	CColorListBox::Copy			   (       ){ASSERT(::IsWindow(m_hWnd));ColorListBox_Copy(m_hWnd);}
inline void		CColorListBox::SetChangeNotify (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_NOCHANGENOTIFY:0,CLB_EX_NOCHANGENOTIFY);}
inline void		CColorListBox::SetAlternated   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_ALTERNATECOLOR:0,CLB_EX_ALTERNATECOLOR);}
inline void		CColorListBox::SetContextMode  (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_NOCONTEXTMENU :0,CLB_EX_NOCONTEXTMENU );}
inline void		CColorListBox::SetCharSelect   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_NOCHARSELCET  :0,CLB_EX_NOCHARSELCET  );}
inline void		CColorListBox::SetSelectDblclk (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_FLAG_SELDBLCLK   :0,CLB_EX_SELDBLCLICK   );}
inline void		CColorListBox::SetSelectMode   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_CHECKBOXES    :0,CLB_EX_CHECKBOXES    );}
inline void		CColorListBox::SetLineFrames   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_GRIDLINES     :0,CLB_EX_GRIDLINES     );}
inline void		CColorListBox::SetCursorMode   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_CURSOR        :0,CLB_EX_CURSOR        );}
inline void		CColorListBox::SetTabExit      (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_TABEXIT       :0,CLB_EX_TABEXIT       );}
inline void		CColorListBox::SetMarkMode     (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_SELMARK       :0,CLB_EX_SELMARK       );}
inline void		CColorListBox::SetSelectSpace  (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_SELSPACE      :0,CLB_EX_SELSPACE      );}
inline void		CColorListBox::SetSelectReturn (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_SELRETURN     :0,CLB_EX_SELRETURN     );}
inline void		CColorListBox::SetSelectWord   (int iOn){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,(iOn)? CLB_EX_SELWORDDBL    :0,CLB_EX_SELWORDDBL    );}
inline int		CColorListBox::GetTextLen	   (int iLine) const {ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetTextLen(m_hWnd,iLine);}
inline void		CColorListBox::SetMarkType     (int iType){ASSERT(CLB_EX_MARKMASK==3);ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,iType,CLB_EX_MARKMASK);}
inline void		CColorListBox::SetKeyStepMode  (int iMisc,int iFirst,int iUpper,int iUnter){ASSERT(::IsWindow(m_hWnd));ColorListBox_SetExtendedStyleEx(m_hWnd,((iMisc)? CLB_EX_STEPMISC:0)|((iFirst)? CLB_EX_STEPFIRST:0)|((iUpper)? CLB_EX_STEPUPPER:0)|((iUnter)? CLB_EX_STEPUNTER:0),CLB_EX_STEPALL);}
inline int		CColorListBox::GetMark         (int &iStartX,int &iStartY,int &iStopX,int &iStopY){INT iRet,aVal[4];ASSERT(::IsWindow(m_hWnd));iRet=ColorListBox_GetMarkEx(m_hWnd,aVal);iStartX=aVal[0];iStartY=aVal[1];iStopX=aVal[2];iStopY=aVal[3];return iRet;}
inline int		CColorListBox::GetMark         (int &iStart ,int &iStop){ASSERT(::IsWindow(m_hWnd));return ColorListBox_GetMark(m_hWnd,&iStart,&iStop);}
inline BOOL		CColorListBox::EnsureVisible   (int nIndex,BOOL bPartialOK){ASSERT(::IsWindow(m_hWnd));return ColorListBox_EnsureVisible(m_hWnd,nIndex,bPartialOK);}
inline BOOL		CColorListBox::SetSel		   (int nIndex,BOOL bSelect,BOOL bNotify){ASSERT(::IsWindow(m_hWnd));return ColorListBox_SetSel(m_hWnd,nIndex,bSelect,bNotify);}

//{{AFX_INSERT_LOCATION}}

#endif
