//*****************************************************************************
//*
//*
//*		ColorListBox.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include	<AfxWin.h>
#include	"ColorListBox.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


#define 	SELECT_SIZE		24
#define 	SELECT_HEIGHT	14
#define 	ID_COPY			0x619F
#define 	ID_MARKALL		0x6170
#define 	LINE_DATA_SIZE	((unsigned)&(((LineData*)0)->bData))

#ifndef	   _WIN64
#ifndef 	DWORD_PTR
#define 	DWORD_PTR		DWORD
#endif
#endif


BEGIN_MESSAGE_MAP(CColorListBox, CWnd)
	//{{AFX_MSG_MAP(CColorListBox)
	ON_WM_CHAR()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_SYSCOLORCHANGE()
	ON_WM_SHOWWINDOW()
	ON_WM_MOUSEWHEEL()
	ON_WM_MOUSEMOVE()
	ON_WM_KILLFOCUS()
	ON_WM_SETFOCUS()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_MARKALL,OnMarkAll)
	ON_COMMAND(ID_COPY,OnCopy)
	ON_MESSAGE(WM_COPY,OnCopy)
	ON_MESSAGE(WM_GETDLGCODE,OnGetDlgCode)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

HPEN CColorListBox::pData->hPen1=0;
HPEN CColorListBox::pData->hPen2=0;

const int	iKeyMaskFirst       = (30<< 0)|(28<< 5)|(24<<10)|(16<<15);
const int	iKeyMaskDefault		= (28<< 0)|(28<< 5)|( 3<<10)|( 3<<15)|(3<<20);
const int	iKeyMaskDefaultUl	= (24<< 0)|(24<< 5)|(24<<10)|( 7<<15)|(7<<20);
const int	iKeyMaskExtentedUl	= ( 6<< 0)|( 1<< 5)|( 1<<10);
const int	iKeyMaskExtented	= ( 2<< 0)|( 1<< 5);
const int	iKeyMaskUpperCase   = (16<<10)|(16<<15);




#define 	CLASS_NAME	_T("ColorListBox")				// Name der Klasse
int			CColorListBox::pData->iRegClassDone = 0;			// Wurde die Klasse registiert

//*****************************************************************************
//*
//*		IsChar
//*
//*****************************************************************************
//	Prft ob ein Zeichen ein Buchstabe ist
static inline int IsChar(TCHAR cChar)
{
unsigned	uVal;

	if(sizeof(TCHAR)==1)
			uVal = (unsigned char)cChar;
	else	uVal = cChar;

	if(uVal>='a')
		{
		if(uVal<='z')return 1;
		if(uVal>=192)return 1;
		return 1;
		}
	else{
		if(uVal=='_')return 1;
		if(uVal> 'Z')return 0;
		if(uVal>='A')return 1;
		if(uVal< '0')return 0;
		if(uVal> '9')return 0;
		}

return 1;
}

//*****************************************************************************
//*
//*		CharType
//*
//*****************************************************************************
//	Holt den Typ von einem Zeichen
//	cChar		; Ist das Zeichen das analysiert werden soll
//	Ergibt den Typ des Zeichens
//				0 = Leerzeichen
//				1 = Diverse Zeichen
//				2 = Das '_' Zeichen
//				3 = Kleinbuchstaben oder Zahlen
//				4 = Grosbuchstaben
static inline int CharType(TCHAR cChar)
{
unsigned	uVal;

	if(sizeof(TCHAR)==1)
			uVal = (unsigned char)cChar;
	else	uVal = cChar;

	if(uVal>'Z')
		{
		if(uVal< 'a')
			{
			if(uVal=='_')return 2;
			return 1;
			}

		if(uVal<='z')return 3;
		if(uVal>=221)return 3;
		if(uVal>=192)return 4;
		return 0;
		}
	else{
		if(uVal>='A')return 4;
		if(uVal<=' ')return 0;
		if(uVal< '0')return 1;
		if(uVal> '9')return 1;
		}

return 3;
}

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CColorListBox::CColorListBox()
{
WNDCLASS	sClass;
HINSTANCE	hInst;


	if(!pData->hPen1)pData->hPen1=CreatePen(PS_SOLID,2,RGB(0,128,0));
	if(!pData->hPen2)pData->hPen2=CreatePen(PS_SOLID,1,RGB(0,255,0));


	if(!pData->iRegClassDone)								// Neue Klasse erzeugen
		{
		hInst = AfxGetInstanceHandle();


		if(!GetClassInfo(hInst,CLASS_NAME,&sClass))		// Existiert die Klasse bereits
			{
			sClass.style			= CS_DBLCLKS|CS_HREDRAW|CS_VREDRAW;
			sClass.lpfnWndProc		= ::DefWindowProc;
			sClass.cbClsExtra		= 0;
			sClass.cbWndExtra		= 0;
			sClass.hInstance		= hInst;
			sClass.hIcon			= NULL;
			sClass.hCursor			= LoadCursor(NULL,IDC_ARROW);
			sClass.hbrBackground	= (HBRUSH)GetStockObject(NULL_BRUSH);
			sClass.lpszMenuName		= NULL;
			sClass.lpszClassName	= CLASS_NAME;


			if (!AfxRegisterClass(&sClass))
				{
				AfxThrowResourceException();
				}
			}

		pData->iRegClassDone = 1;
		}


	pData->pLines		= 0;								// Zeiger auf Zeilendaten
	pData->uListItemsCount	= 0;								// Anzahl der Zeilen
	pData->iLineSize		= 0;								// Anzahl der Zeileneintrge in pData->pLines

	memset(pData->aColorHg   ,0xFF,sizeof(pData->aColorHg   ));
	memset(pData->aColorText ,0x00,sizeof(pData->aColorText ));
	memset(pData->aColorFixed,0x00,sizeof(pData->aColorFixed));

	pData->aColorHg  [3] = GetSysColor(COLOR_HIGHLIGHT);		//			*
	pData->aColorText[0] = GetSysColor(COLOR_WINDOWTEXT);	// Farben fr den text
	pData->aColorText[1] = GetSysColor(COLOR_WINDOWTEXT);	//			*
	pData->aColorText[2] = GetSysColor(COLOR_WINDOWTEXT);	//			*
	pData->aColorText[3] = GetSysColor(COLOR_HIGHLIGHTTEXT);	//			*
	pData->hFont  = (HFONT)GetStockObject(ANSI_FIXED_FONT);	// Ausgewhlter Font
	pData->iFontVar		= 0;								// Ist es ein Font mit variabler Breite
	pData->iColorCount   = 4;								// Anzahl der Farben
	pData->uSelectedLine		= LB_ERR;							// Ausgewhlte Zeile
	pData->uScrollX		= 0;								// Scrollposition
	pData->uScrollY		= 0;								//			*
	pData->uSizeX		= 0;								// Fenstergbreite in Pixel
	pData->uSizeY		= 0;								//			*
	pData->uSizeCharX		= 0;								// Fenstergre in Buchstaben
	pData->uPageEnties		= 0;								//			*
	pData->iFontWidth		= 1;								// Schriftgre in Pixel
	pData->iFontHeight		= 1;								//			*
	pData->iCursorX		= 0;								// Aktuelle Cursor Position
	pData->iCursorY		= 0;								//			*
	pData->iCaretX		= 0;								// Koortinaten fr Caret
	pData->iCaretY		= 0;								//			*
	pData->iCaretOn		= 0;								// Ist der Cursor sichtbar
	pData->iCaretExist	= 0;								// Wurde das Caret erzeugt
	pData->iMaxX			= 0;								// Maximale X-Gre
	pData->iAddRows		= 0;								// Pixelreihen einfgen nach Zeile
	pData->bIsVisible	= 0;								// Ist das Fenster sichtbar
	pData->bKeyStepMisc	= 1;								// Bei Wortsprngen auch diversen Zeichen anhalten
	pData->bKeyStepFirst = 0;								// Bei Wortsprngen nur am Beginn eines Wortes/Bereichs anhalten
	pData->bKeyStepUpper = 0;								// Bei Wortsprngen auch Gro/Kleinbergngen anhalten
	pData->bKeyStepUnter = 0;								// Bei Wortsprngen das '_' nicht als Buchstaben betrachten
	pData->bTabExit		= 0;								// Bei TAB den Focus ans Elternfenster geben
	pData->cHasFocus		= 0;								// Hat das Fenster den Focus
	pData->bHasLines		= 0;								// Trennlinien zwischen den Zeilen
	pData->cHasCaret		= 0;								// Hat das Fenster einen Cursor
	pData->uStyleEx&CBL_EX_HASBUTTONS	= 0;								// Hat das Fenster Hckchen zum auswhlen
	pData->bNoContext	= 0;								// Kein Conteext-Men mit rechter Maustaste
	pData->bSelSpace		= 0;								// Auswahl mit SPACE-Taste
	pData->uStyleEx&CBL_EX_SELRETURN	= 0;								// Auswahl mit RETURN-Taste
	pData->bSelDblclk	= 0;								// Auswahl mit Doppelclick
	pData->uStyleEx&CBL_EX_SELWORDDBL	= 0;								// Wortauswahl mit Doppelcklick
	pData->bAlternated	= 0;								// Abwecheselnde Farbe fr Zeilen
	pData->iMarkType		= 2;								// Erlaubte Markierungsart (0=Keine 1=Einzeilig 2=Mehzeilig 3=Nur ganze Zeilen)
	pData->iMarkMode		= 0;								// Ist eine Marke vorhanden 0=Keine 1=Ziehen 2=Fertig
	pData->cTimerOn		= 0;								// Ist der Scrolltimer ein
	pData->cSelectEnable = 1;								// Die Selectierte Zeile anzeigen
	pData->iMarkStartX	= 0;								// Beginn einer Marke
	pData->iMarkStartY	= 0;								//			*
	pData->iMarkStopX	= 0;								// Ende   einer Marke
	pData->iMarkStopY	= 0;								//			*
	pData->iTabSteps		= 4;								// Ist die Tab-Breite in Buchstaben
	pData->iTabSize		= 160;								// Ist die Tab-Breite in Pixel
	pData->aTabPos[0]	= 160;								// Tabulatorpositionen
	pData->iTabCount		= 1;								// Anzhalt der Eintrge in pData->aTabPos
	pData->uShiftY	= 0;								// Um wievile Bits mssen scroll werte verschoben werden
	pData->iKeyStepMask	= iKeyMaskDefault;					// Maske fr Wortsprnge mit der Tastatur

	pData->aColorText[1] |= 0xFF000000;						// Farben vom ursprnglichen Text holen
	pData->aColorText[2] |= 0xFF000000;						//			*


	UpdateColors();

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CColorListBox::~CColorListBox()
{
int		i;


	for(i=0;i<pData->uListItemsCount;i++)
		{
		delete pData->pLines[i];
		}

	if(pData->pLines)delete pData->pLines;



}


//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
void CColorListBox::OnPaint()
{
int			iLine,iEnd,i;
int			iXpos,iYpos;
int			iChar,iNum;
CPaintDC	sDc(this);
LineData   *pLine;
BYTE	   *pColor;
TCHAR	   *pText;
COLORREF	uColor;
COLORREF	uColEx;
BYTE		bData;
BYTE		bText;
BYTE		bDone;
CRect		sArea;
CRect		sRect;
CSize		sSize;
int			iOff;
int			iPos;
int			iStartX=0;
int			iStopX =0;
int			iStartY=0;
int			iStopY =0;



	pData->sSemaphor.Lock();

	GetClientRect(sRect);

	sSize.cy = pData->iFontHeight;
	iOff	 =-pData->uScrollX;
	iEnd	 = pData->uListItemsCount;
	iYpos	 = 0;
	bDone	 = 0;

	sDc.SetBkMode(OPAQUE);
	sDc.SelectObject(pData->hFont);
	sDc.SelectStockObject(BLACK_PEN);
	sDc.SelectStockObject(WHITE_BRUSH);

	if(pData->uStyleEx&CBL_EX_HASBUTTONS)									// Box mit Hkchen zeichen
		{
		sDc.SetWindowOrg(-SELECT_SIZE,0);
		}


	if(pData->iMarkMode)										// Daten der Markierung
		{
		if(pData->iMarkStartY<pData->iMarkStopY || (pData->iMarkStartY==pData->iMarkStopY && pData->iMarkStartX<pData->iMarkStopX))
			{
			iStartX = pData->iMarkStartX;
			iStartY = pData->iMarkStartY;
			iStopX  = pData->iMarkStopX;
			iStopY  = pData->iMarkStopY;
			}
		else{
			iStartX = pData->iMarkStopX;
			iStartY = pData->iMarkStopY;
			iStopX  = pData->iMarkStartX;
			iStopY  = pData->iMarkStartY;
			}
		}




	for(iLine=pData->uScrollY;iLine<iEnd;iLine++)			// Alle sichtbaren Zeilen durchlaufen
		{
		pLine	= pData->pLines[iLine];
		pText	= (TCHAR*)pLine->bData;
		pColor	= pLine->bData+pLine->wLineSize*sizeof(TCHAR);
		iChar	= pLine->wLineLen;
		iXpos	= 0;
		bData	= 0;
		bText	= 0;

		if(iLine==pData->iCursorY)							// Den Cursor ausblenden
			{
			bDone = 1;

			if(pData->iCaretOn)
				{
				pData->iCaretOn = 0;
				HideCaret();
				}
			}

		if(iChar<=0)									// Kein Zeichen in der Zeile
			{
			iChar  = 1;
			pText  = _T(" ");
			pColor = &bData;
			}

		for(i=0;i<iChar;i+=iNum)						// Zeichne die Zeile
			{
			bData  = pColor[i];
			bText  = pColor[i];

			if(pData->uSelectedLine==iLine && pData->cSelectEnable)
				{
				bData = (pData->cHasFocus)? 1:2;

				if((pData->aColorText[bData]>>24)!=0xFF)		// Farbe aus ursprnglichen Text
					{
					bText = bData;
					iNum  = iChar-i;
					}
				else{
					for(iNum=1;i+iNum<iChar;iNum++)		// Zhle gleiche Farben
						{
						if(pColor[i+iNum]!=bText)break;
						}
					}
				}
			else for(iNum=1;i+iNum<iChar;iNum++)		// Zhle gleiche Farben
				{
				if(pColor[i+iNum]!=bData)break;
				}


			if(pData->uStyleEx&CBL_EX_HASBUTTONS)							// Box mit Hkchen zeichen
			if(i==0 && pData->uScrollX<SELECT_SIZE)
				{
				   uColor = pData->aColorHg[bData];
				if(uColor==0xFFFFFFFF)					// Standart Hintergundfarbe whlen
					{
					uColor = (pData->bAlternated && (iLine&1))? pData->aColorHg[CLB_COLOR_ODD]:pData->aColorHg[CLB_COLOR_EVEN];

					if(bData==2)
						{
						uColEx = GetSysColor(COLOR_MENU);
						uColor = ((uColor>>2)&0x3F3F3F)*3;
						uColor+= ((uColEx>>2)&0x3F3F3F);
						}
					else if(bData==1)
						{
						uColEx = GetSysColor(COLOR_HIGHLIGHT);
						uColor = ((uColor>>2)&0x3F3F3F)*3;
						uColor+= ((uColEx>>2)&0x3F3F3F);
						}
					}

				sDc.SetBkColor(uColor);

				sArea.left	 = -pData->uScrollX-SELECT_SIZE;
				sArea.right	 = -pData->uScrollX+1;
				sArea.top	 = iYpos;
				sArea.bottom = iYpos+pData->iFontHeight;

				sDc.ExtTextOut(0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);

				if(pLine->wLineSel>=2)
					{									// Keine Box zeichen
					sArea.left	 = -pData->uScrollX-SELECT_SIZE+3;
					sArea.right	 = -pData->uScrollX-SELECT_SIZE+3+11;
					sArea.top	 = iYpos+2;
					sArea.bottom = iYpos+2+11;

					sDc.ExtTextOut(0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
					}
				else{
					sDc.Rectangle(-pData->uScrollX-SELECT_SIZE+3,iYpos+2,-pData->uScrollX-SELECT_SIZE+3+11,iYpos+2+11);
					}

				if(pLine->wLineSel==1)					// Hkchen zeichen
					{
					sDc.SelectObject(pData->hPen1);
					sDc.MoveTo(-pData->uScrollX-SELECT_SIZE+4-2 ,iYpos+3+3);
					sDc.LineTo(-pData->uScrollX-SELECT_SIZE+4+2 ,iYpos+3+7);
					sDc.LineTo(-pData->uScrollX-SELECT_SIZE+4+12,iYpos+3+0);

					sDc.SelectObject(pData->hPen2);
					sDc.MoveTo(-pData->uScrollX-SELECT_SIZE+4-1 ,iYpos+3+2);
					sDc.LineTo(-pData->uScrollX-SELECT_SIZE+4+2 ,iYpos+3+5);
					sDc.LineTo(-pData->uScrollX-SELECT_SIZE+4+12,iYpos+3+0);
					sDc.SelectStockObject(BLACK_PEN);
					}
				}


			if(pData->iMarkMode)								// Ist ein Text ausgewhlt
				{
				if(iStartY<iLine && iStopY>iLine)
					{
					iNum  = iChar-i;
					bData = 3;
					}
				else if(iStartY==iLine && iStopY==iLine)
					{
					if(i< iStartX && i+iNum>iStartX)iNum=iStartX-i;
					if(i>=iStartX && i<iStopX )
						{
						if(iStopX<iChar)
								iNum=iStopX-i;
						else	iNum=iChar -i;
						bData=3;
						}
					}
				else if(iStartY==iLine)
					{
					if(i<iStartX && i+iNum>iStartX)iNum=iStartX-i;
					else if(i>=iStartX)
						{
						iNum  = iChar-iStartX;
						bData = 3;
						}
					}
				else if(iStopY==iLine && i<iStopX)
					{
					if(iStopX<iChar)
							iNum=iStopX-i;
					else	iNum=iChar -i;
					bData=3;
					}

				if(bData==3)							// Wurde etwas ausgewhlt
					{
					if((pData->aColorText[bData]>>24)==0xFF)	// Farbe aus ursprnglichen Text
						{
						for(iNum=1;i+iNum<iChar;iNum++)	// Zhle gleiche Farben
							{
							if(pColor[i+iNum]!=bText)break;
							}
						}
					else{
						bText = 3;
						}
					}

				if(i+iNum>iChar)iNum=iChar-i;
				}


			   uColor = pData->aColorHg[bData];
			if(uColor==0xFFFFFFFF)						// Standart Hintergundfarbe whlen
				{
				uColor = (pData->bAlternated && (iLine&1))? pData->aColorHg[CLB_COLOR_ODD]:pData->aColorHg[CLB_COLOR_EVEN];

				if(bData==2)
					{
					uColEx = GetSysColor(COLOR_HIGHLIGHT);
					uColor = ((uColor>>2)&0x3F3F3F)*3;
					uColor+= ((uColEx>>2)&0x3F3F3F)*1;
					}
				else if(bData==1)
					{
					uColEx = GetSysColor(COLOR_HIGHLIGHT);
					uColor = ((uColor>>2)&0x3F3F3F)*2;
					uColor+= ((uColEx>>2)&0x3F3F3F)*2;
					}
				}

			sDc.SetTextColor(pData->aColorText[bText]);
			sDc.SetBkColor  (uColor);


			if(iNum<=0)iNum=1;

			sSize  = sDc.TabbedTextOut(iXpos+iOff,iYpos,pText+i,iNum,pData->iTabCount,pData->aTabPos,iOff);

			if(pData->iAddRows)
				{
				sArea.left	 = iXpos+iOff;
				sArea.right	 = iXpos+iOff+sSize.cx+1;
				sArea.top	 = iYpos+pData->iFontHeight-pData->iAddRows;
				sArea.bottom = iYpos+pData->iFontHeight+1;

				sDc.ExtTextOut(0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
				}

			iXpos += sSize.cx;

			if(iXpos>=sRect.right-iOff)break;
			}

		if(iXpos<sRect.right-iOff)						// Restliche Zeile ausmahlen
			{
			if(pData->iMarkType!=3)
				{
				bData=0;

				if(pData->uSelectedLine==iLine && pData->cSelectEnable)
					{
					bData=(pData->cHasFocus)? 1:2;
					}
				}

			   uColor = pData->aColorHg[bData];
			if(uColor==0xFFFFFFFF)						// Standart Hintergundfarbe whlen
				{
				uColor = (pData->bAlternated && (iLine&1))? pData->aColorHg[CLB_COLOR_ODD]:pData->aColorHg[CLB_COLOR_EVEN];

				if(bData==2)
					{
					uColEx = GetSysColor(COLOR_MENU);
					uColor = ((uColor>>2)&0x3F3F3F)*3;
					uColor+= ((uColEx>>2)&0x3F3F3F);
					}
				else if(bData==1)
					{
					uColEx = GetSysColor(COLOR_HIGHLIGHT);
					uColor = ((uColor>>2)&0x3F3F3F)*3;
					uColor+= ((uColEx>>2)&0x3F3F3F);
					}
				}

			sDc.SetBkColor(uColor);

			sArea.left	 = iXpos+iOff;
			sArea.right	 = sRect.right+1;
			sArea.top	 = iYpos;
			sArea.bottom = iYpos+pData->iFontHeight+1;

			sDc.ExtTextOut(0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
			}


														// Den Cursor einblenden
		if(iLine==pData->iCursorY && pData->cHasCaret && pData->cHasFocus)
			{
			pData->iCaretX = PointOfRow(iLine,pData->iCursorX,&sDc);
			pData->iCaretY = iYpos+pData->uScrollY*(pData->iFontHeight+pData->bHasLines);
			if(pData->uStyleEx&CBL_EX_HASBUTTONS)pData->iCaretX+=SELECT_SIZE;

			if(!pData->iCaretExist)
				{
				pData->iCaretExist = 1;
				CreateSolidCaret(2,pData->iFontHeight-1);
				}

			if(pData->iCaretX>=pData->uScrollX)
			if(pData->iCaretX <pData->uScrollX+pData->uSizeX)
				{
				iPos = pData->iCaretX-pData->uScrollX;
				SetCaretPos(CPoint(iPos,iYpos+1));

				if(!pData->iCaretOn)
					{
					pData->iCaretOn=1;
					ShowCaret();
					}
				}
			}


		iYpos+=pData->iFontHeight;
		if(iYpos>=sRect.bottom)break;

		if(pData->bHasLines)									// Linien nach jeder Zeile
			{
			uColor = (pData->bAlternated && (iLine&1))? pData->aColorText[CLB_COLOR_ODD]:pData->aColorText[CLB_COLOR_EVEN];
			sDc.SetBkColor(uColor);

			sArea.left	 = -SELECT_SIZE;
			sArea.right	 =  sRect.right+1;
			sArea.top	 =  iYpos;
			sArea.bottom =  iYpos+1;

			sDc.ExtTextOut(0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);

			iYpos++;
			}
		}

	if(!bDone && pData->iCaretOn)							// Cursor ausblenden wenn er nicht im Bild ist
		{
		pData->iCaretOn=0;
		HideCaret();
		}

	pData->sSemaphor.Unlock();

	if(iYpos<sRect.bottom)								// Restliches Fenster ausmahlen
		{
		   uColor = pData->aColorHg[0];
		if(uColor==0xFFFFFFFF)							// Standart Hintergundfarbe whlen
			{
			uColor = pData->aColorHg[CLB_COLOR_EVEN];
			}

		sDc.SetBkColor(uColor);

		sArea.left	 = -SELECT_SIZE;
		sArea.right	 =  sRect.right+1;
		sArea.top	 =  iYpos;
		sArea.bottom =  sRect.bottom+1;

		sDc.ExtTextOut(0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
		}


}


//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
//	Erzeugt eine neue Listbox.
//	dwStyle		: Ist der Style des Fensters. z.B.: WS_CHILD ...
//	sRect		: Ist die Position an der das Fenster erstellt wird.
//	pParentWnd	: Ist das Elternfenster.
//	nID			: Ist die ID fr das Fenster.
//	Ergibt TRUE wenn das Fenster erstellt wurde.
BOOL CColorListBox::Create(DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID)
{

	return CWnd::Create(CLASS_NAME,_T(""),dwStyle,sRect,pParentWnd,nID,NULL);

}

//*****************************************************************************
//*
//*		CreateEx
//*
//*****************************************************************************
//	Erzeugt eine neue Listbox.
//	dwExStyle	: Ist der exdented Style des Fensters. z.B.: WS_EX_ ...
//	dwStyle		: Ist der Style des Fensters. z.B.: WS_CHILD ...
//	sRect		: Ist die Position an der das Fenster erstellt wird.
//	pParentWnd	: Ist das Elternfenster.
//	nID			: Ist die ID fr das Fenster.
//	Ergibt TRUE wenn das Fenster erstellt wurde.
BOOL CColorListBox::CreateEx(DWORD dwExStyle,DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID)
{
BOOL    bOk;



		bOk = CWnd::CreateEx(dwExStyle,CLASS_NAME,_T(""),dwStyle,sRect,pParentWnd,nID,NULL);
	if(!bOk)return FALSE;


return TRUE;
}

//*****************************************************************************
//*
//*		SetFont
//*
//*****************************************************************************
//	Die Schriftart fr die Listbox einstellen.
//	pFont		: Ist der Zeiger auf den Font
//	bRedraw		: Soll die Listbox neu gezeichnet werden.
//	Ergibt TRUE wenn der Font eingestellt wurde.
BOOL CColorListBox::SetFont(CFont *pFont,BOOL bRedraw)
{
CRect	sRect;



	if(!pFont)return FALSE;
	if(!pFont->pData->hObject)return FALSE;


return SetFont((HFONT)pFont->pData->hObject,bRedraw);
}

//*****************************************************************************
//*
//*		SetFont
//*
//*****************************************************************************
//	Die Schriftart fr die Listbox einstellen.
//	pData->hFont		: Ist der Zeiger auf den Font
//	bRedraw		: Soll die Listbox neu gezeichnet werden.
//	Ergibt TRUE wenn der Font eingestellt wurde.
BOOL CColorListBox::SetFont(HFONT hFont,BOOL bRedraw)
{
CRect		sRect;



	if(hFont==NULL   )return FALSE;
	if(hFont==pData->hFont)return TRUE;

	pData->uPageEnties--;
	pData->hFont = hFont;

	if(pData->bIsVisible)
		{
		if(pData->iTabCount>1)
			{
			SetTabStops(pData->iTabCount,pData->aTabPos);
			}
		else if(pData->iTabSteps>0)
			{
			SetTabSize(pData->iTabSteps,bRedraw);
			}

		UpdateTextSize();
		}

	GetClientRect(&sRect);
	OnSize(0,sRect.right,sRect.bottom);

	if(bRedraw)RedrawWindow();



return TRUE;
}

//*****************************************************************************
//*
//*		SetFont
//*
//*****************************************************************************
//	Whlt einen Standart-Font aus
//	iFontVar	: Font mit variabler Buchstabenbreite verwenden
//	bRedraw		: Soll die Listbox neu gezeichnet werden.
//	Ergibt TRUE wenn der Font eingestellt wurde.
BOOL CColorListBox::SetFont(int iFontVar,BOOL bRedraw)
{
HFONT	hFont;

	if(iFontVar)
		{
		hFont = (HFONT)GetStockObject(ANSI_VAR_FONT);		// Variabler Font
		}
	else{
		hFont = (HFONT)GetStockObject(ANSI_FIXED_FONT);		// Font mit fixer Breite
		}


return SetFont(hFont,bRedraw);
}

//*****************************************************************************
//*
//*		ResetContent
//*
//*****************************************************************************
//	Alle Texte aus der Listbox lschen.
void CColorListBox::ResetContent()
{
int				i,iCount;
SCROLLINFO		sScrollInfo;


	pData->sSemaphor.Lock();

	pData->uScrollX   = 0;
	pData->uScrollY   = 0;
	iCount	     = pData->uListItemsCount;
	pData->uListItemsCount = 0;
	pData->iMaxX      = 0;
	pData->uSelectedLine    = LB_ERR;
	pData->iMarkMode	 = 0;
	pData->iCursorX	 = 0;
	pData->iCursorY	 = 0;
	pData->iMaxSizeX	 = 0;
	pData->uShiftY= 0;

	for(i=0;i<iCount;i++)
		{
		delete pData->pLines[i];
		}

	if(pData->iCaretOn)
		{
		HideCaret();
		pData->iCaretOn=0;
		}

	pData->sSemaphor.Unlock();


	sScrollInfo.cbSize	= sizeof(sScrollInfo);
	sScrollInfo.fMask	= SIF_RANGE|SIF_POS|SIF_PAGE;
	sScrollInfo.nMax	= 0;
	sScrollInfo.nMin	= 0;
	sScrollInfo.nPos	= 0;
	sScrollInfo.nPage	= 0;

	SetScrollInfo(SB_VERT,&sScrollInfo);
	SetScrollInfo(SB_HORZ,&sScrollInfo);


	if(iCount)RedrawWindow();
}


//*****************************************************************************
//*
//*		InsertString
//*
//*****************************************************************************
//	Fgt einen Text in die Listbox ein.
//	nIndex		: Ist die Zeilennummer bei der der Text eingefgt werden soll.
//				  Wenn die Zeilennummer kleiner 0 ist, wird der Text am Ende
//				  eingefgt.
//	pText		: Ist der Zeiger auf den einzufgenden Text.
//	pColor		: Ist ein Zeiger auf die Farbnummern fr den Text.
//				  Die Gre dieses Arrays muss mindestens so lange sein
//				  wie die Lnge des Textes.
//	iLen		: Ist die Lnge des Textes in Zeichen. Bei -1 wird die
//				  Lnge mit strlen(pItem) ermittelt.
//	Ergibt die Zeilennummer bei der der Text eingefgt wurde, bzw. LB_ERR bei
//	einem Fehler. Wenn zuwenig Speicher vorhanden ist, wird LB_ERRSPACE zurckgegeben.
int CColorListBox::InsertString(int nIndex,LPCTSTR pText,const BYTE *pColor,int iLen)
{
SCROLLINFO	  sScrollInfo;
LineData	**pNewLines;
LineData	**pOldLines=0;
LineData	 *pLine;
CSize		  sSize;
int			  iCount;
int			  iShift;
int			  iSize;
int			  iAdd;
CDC			 *pDc;


	pData->sSemaphor.Lock();

	if(nIndex<0 || nIndex>pData->uListItemsCount)nIndex=pData->uListItemsCount;

	if(nIndex>=pData->iLineSize)							// Am Ende einfgen
		{
		iSize	  = pData->iLineSize+pData->iLineSize/2+16;
		pOldLines = pData->pLines;
		pNewLines = new PLineData[iSize];

		if(!pNewLines)
			{
			pData->sSemaphor.Unlock();
			return LB_ERRSPACE;
			}

		memcpy(pNewLines,pOldLines,sizeof(pNewLines[0])*pData->iLineSize);

		pData->pLines	= pNewLines;
		pData->iLineSize = iSize;
		}

	if(iLen<0)iLen=_tcslen(pText);


	if(iLen>=0x4000)								// Ist der String zulang ?
		{
		if(pOldLines)delete pOldLines;
		pData->sSemaphor.Unlock();
		return LB_ERRSPACE;
		}

	iSize = (iLen+3)&~3;
	pLine = (LineData*)new char[(iSize+1)*(sizeof(TCHAR)+1)+LINE_DATA_SIZE];

	if(!pLine)
		{
		if(pOldLines)delete pOldLines;
		pData->sSemaphor.Unlock();
		return LB_ERRSPACE;
		}

	pLine->lParam	   = 0;
	pLine->wLineSel	   = 0;
	pLine->wLineLen	   = iLen;
	pLine->wLineSize   = iSize;
	memcpy(pLine->bData,pText,iLen*sizeof(TCHAR));
	((TCHAR*)pLine->bData)[iLen] = 0;


	if(((DWORD_PTR)pColor)>0xFF)
			memcpy(pLine->bData+iSize*sizeof(TCHAR),      pColor,iLen);
	else	memset(pLine->bData+iSize*sizeof(TCHAR),(BYTE)pColor,iLen);

	memmove(pData->pLines+nIndex+1,pData->pLines+nIndex,(pData->uListItemsCount-nIndex)*sizeof(pData->pLines[0]));
	pData->pLines[nIndex]=pLine;
	pData->uListItemsCount++;



													// Prfen ob Linien Zahl kleiner 0x8000 ist
	for(iShift=0,iCount=pData->uListItemsCount;iCount>=0x8000;iShift++)
		{
		iCount/=2;
		}


	sScrollInfo.cbSize	= sizeof(sScrollInfo);
	sScrollInfo.fMask	= SIF_RANGE|SIF_PAGE;

	if(pData->uShiftY!=iShift)						// Hat sich der Verschub gendert
		{
		pData->uShiftY	 	= iShift;
		sScrollInfo.fMask	= SIF_RANGE|SIF_PAGE|SIF_POS;
		}

	   iAdd=pData->uPageEnties/4;
	if(iAdd>10)iAdd=10;
	if(iAdd< 2)iAdd=2;

	sScrollInfo.nPage	= (pData->uPageEnties       )>>pData->uShiftY;
	sScrollInfo.nPos	= (pData->uScrollY       )>>pData->uShiftY;
	sScrollInfo.nMax	= (pData->uListItemsCount+iAdd)>>pData->uShiftY;
	sScrollInfo.nMin	= 0;

	pData->sSemaphor.Unlock();


	SetScrollInfo(SB_VERT,&sScrollInfo);



	if(pData->iMaxX<iLen)pData->iMaxX = iLen;


	if(pData->bIsVisible)											// Wenn sichtbar dann die neue Gre berechen
		{
		pDc   = GetDC();
		pDc->SelectObject(pData->hFont);
		sSize = pDc->GetTabbedTextExtent(pText,iSize,pData->iTabCount,pData->aTabPos);
		ReleaseDC(pDc);

		if(sSize.cx>pData->iMaxSizeX)
			{
			pData->iMaxSizeX			= sSize.cx;
			sScrollInfo.nMin	= 0;
			sScrollInfo.nMax	= pData->iMaxSizeX+16;
			sScrollInfo.nPage	= pData->uSizeX;
			sScrollInfo.fMask	= SIF_RANGE|SIF_PAGE;
			sScrollInfo.cbSize	= sizeof(sScrollInfo);
			if(pData->uStyleEx&CBL_EX_HASBUTTONS)sScrollInfo.nMax+=SELECT_SIZE;
			SetScrollInfo(SB_HORZ,&sScrollInfo);
			}
		}

	if(pOldLines)delete pOldLines;

	if(nIndex>=pData->uScrollY && nIndex<=pData->uScrollY+pData->uPageEnties+1)
		{
		RedrawWindow();
		}


return nIndex;
}

//*****************************************************************************
//*
//*		SetCurSel
//*
//*****************************************************************************
//	Stellt den gerade gewhlten Text ein.
//	nIndex		: Ist die Zeilennummer vom zu whlenden Text.
//	bRedraw		: Darf das Fenster neu gezeichnet werden
//	Ergibt die Zeilennummer vom gewhlten Text, bzw. LB_ERR bei einem Fehler.
int	CColorListBox::SetCurSel(int nIndex,BOOL bRedraw)
{
int		iOldIx;


	if(nIndex<0 || nIndex>=pData->uListItemsCount)return LB_ERR;
	if(nIndex==pData->uSelectedLine)return nIndex;


	iOldIx    = pData->uSelectedLine;
	pData->uSelectedLine = nIndex;


	if(pData->cHasCaret)
		{
		iOldIx		= pData->uScrollY;
		pData->iCursorY  = nIndex;
		pData->iMarkMode	= 0;
		}

	if(!bRedraw)
		{
		return nIndex;
		}

	if(iOldIx>=pData->uScrollY)
	if(iOldIx<=pData->uScrollY+pData->uPageEnties)
		{
		RedrawWindow();
		return nIndex;
		}


	if(nIndex>=pData->uScrollY)
	if(nIndex<=pData->uScrollY+pData->uPageEnties)
		{
		RedrawWindow();
		}


return nIndex;
}


//*****************************************************************************
//*
//*		SetTextColor
//*
//*****************************************************************************
//	Stellt die Farben eines Textes ein.
//	nIndex		: Ist die Zeilennummer vom Text.
//	pColor		: Ist ein Zeiger auf die Farbnummern.
//				  Die Gre dieses Arrays muss mindestens so lange sein
//				  wie die Lnge des Textes.
//	Ergibt die Zeilennummer vom Text, bzw. LB_ERR bei einem Fehler.
int CColorListBox::SetTextColor(int nIndex,const BYTE *pColor)
{
LineData   *pLine;
CRect		sRect;


	pData->sSemaphor.Lock();

	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		pData->sSemaphor.Unlock();
		return LB_ERR;
		}

	pLine = pData->pLines[nIndex];

	if(((DWORD_PTR)pColor)>0xFF)
			memcpy(pLine->bData+pLine->wLineSize*sizeof(TCHAR),      pColor,pLine->wLineLen);
	else	memset(pLine->bData+pLine->wLineSize*sizeof(TCHAR),(BYTE)pColor,pLine->wLineLen);


	pData->sSemaphor.Unlock();


	if(nIndex>=pData->uScrollY && nIndex<=pData->uScrollY+pData->uPageEnties)
		{
		sRect.left	 = 0;
		sRect.right	 = pData->uSizeX+16;
		sRect.top	 = (nIndex-pData->uScrollY)*(pData->iFontHeight+pData->bHasLines);
		sRect.bottom = 	sRect.top+pData->iFontHeight;
		InvalidateRect(&sRect,FALSE);
		}


return nIndex;
}

//*****************************************************************************
//*
//*		SetText
//*
//*****************************************************************************
//	Stellt den Text und die Farben eines Textes ein.
//	nIndex		: Ist die Zeilennummer vom Text.
//	pText		: Ist der Zeiger auf den neunen Text
//	iLen		: Ist die Textlnge in Zeichen. Bei -1 wird strlen() benutzt.
//	pColor		: Ist ein Zeiger auf die Farbnummern.
//				  Die Gre dieses Arrays muss mindestens so lange sein
//				  wie die Lnge des Textes.
//				  Bei 0xFF wird nichts verndert
//	Ergibt die Zeilennummer vom Text, bzw. LB_ERR bei einem Fehler.
int CColorListBox::SetText(int nIndex,LPCTSTR pText,int iLen,const BYTE *pColor)
{
LineData   *pNew;
LineData   *pLine;
CRect		sRect;
int			iSize;
int			iDiff;


	pData->sSemaphor.Lock();

	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		pData->sSemaphor.Unlock();
		return LB_ERR;
		}

	if(iLen<0)iLen=_tcslen(pText);
	if(iLen>=0x8000)								// Ist der String zulang ?
		{
		pData->sSemaphor.Unlock();
		return LB_ERRSPACE;
		}


	pLine = pData->pLines[nIndex];

	if(pLine->wLineSize<(unsigned)iLen)				// Passt der neue Text in den alten Speicher
		{
		iSize = (iLen+3)&~3;
		pNew  = (LineData*)new char[(iSize+1)*(sizeof(TCHAR)+1)+LINE_DATA_SIZE];

		if(!pNew)
			{
			pData->sSemaphor.Unlock();
			return LB_ERRSPACE;
			}

		pNew->lParam	   = pLine->lParam;
		pNew->wLineSel	   = pLine->wLineSel;
		pNew->wLineSize    = iSize;
		}
	else{
		pNew  = pLine;
		iSize = pLine->wLineSize;
		}


	pNew->wLineLen	   = iLen;
	memcpy(pNew->bData,pText,iLen*sizeof(TCHAR));
	((TCHAR*)pNew->bData)[iLen] = 0;



	if(((DWORD_PTR)pColor)>0xFF)					// Farben einstellen
		{
		memcpy(pNew->bData+iSize*sizeof(TCHAR),pColor,iLen);
		}
	else if(((DWORD_PTR)pColor)<0xFF)
		{
		memset(pNew->bData+iSize*sizeof(TCHAR),(BYTE)pColor,iLen);
		}
	else{											// Alterfarbe beibehalten
		if(pNew!=pLine)
			{
			memcpy(pNew->bData+iSize*sizeof(TCHAR),pLine->bData+pLine->wLineSize*sizeof(TCHAR),pLine->wLineLen);
			}

		   iDiff = iLen-pLine->wLineLen;
		if(iDiff>0)
			{
			memset(pNew->bData+iSize*sizeof(TCHAR)+pLine->wLineLen,0,iDiff);
			}
		}


	if(pNew!=pLine)									// Den alten Speicher lschen
		{
		pData->pLines[nIndex] = pNew;
		delete pLine;
		}

	pData->sSemaphor.Unlock();


	if(nIndex>=pData->uScrollY && nIndex<=pData->uScrollY+pData->uPageEnties)
		{
		sRect.left	 = 0;
		sRect.right	 = pData->uSizeX+16;
		sRect.top	 = (nIndex-pData->uScrollY)*(pData->iFontHeight+pData->bHasLines);
		sRect.bottom = 	sRect.top+pData->iFontHeight;
		InvalidateRect(&sRect,FALSE);
		}


return nIndex;
}

//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Einen Text aus der Listbox auslesen
//	nIndex		: Ist die Zeilennummer vom Text.
//	pBuffer		: Zeiger auf den Textpuffer in dem der Text abgelegt wird.
//	iSize		: Gre des Textpuffers.
//	Ergibt die Lnge des Texts ohne Nullzeichen, bzw. LB_ERR bei einem Fehler.
int	CColorListBox::GetText(int nIndex,LPTSTR pBuffer,int iSize)
{
LineData	 *pLine;
int			  iLen;


	if(iSize<=0)
		{
		return LB_ERR;
		}

	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		pBuffer[0]=0;
		return LB_ERR;
		}

	pLine = pData->pLines[nIndex];
	iLen  = pLine->wLineLen;

	iSize--;
	if(iLen>iSize)iLen=iSize;

	memcpy(pBuffer,pLine->bData,iLen*sizeof(TCHAR));
	pBuffer[iLen]=0;


return iLen;
}

int	CColorListBox::GetText(int nIndex,LPTSTR pBuffer)
{
LineData	 *pLine;
int			  iLen;


	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		pBuffer[0]=0;
		return LB_ERR;
		}

	pLine = pData->pLines[nIndex];
	iLen  = pLine->wLineLen;

	memcpy(pBuffer,pLine->bData,iLen*sizeof(TCHAR));
	pBuffer[iLen]=0;


return iLen;
}

void CColorListBox::GetText(int nIndex, CString &sString)
{
LPTSTR		  pBuffer;
LineData	 *pLine;
int			  iLen;


	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		sString="";
		return;
		}

	pLine = pData->pLines[nIndex];
	iLen  = pLine->wLineLen;

	pBuffer=sString.GetBufferSetLength(iLen);
	memcpy(pBuffer,pLine->bData,iLen*sizeof(TCHAR));
	sString.ReleaseBuffer(iLen);

}

LPCTSTR CColorListBox::GetText(int nIndex,int &iSize)
{
LineData	 *pLine;



	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		iSize = 0;
		return NULL;
		}

	pLine = pData->pLines[nIndex];
	iSize = pLine->wLineLen;

return (LPCTSTR)pLine->bData;
}

LPCTSTR CColorListBox::GetText(int nIndex)
{
LineData	 *pLine;


	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		return NULL;
		}

	pLine = pData->pLines[nIndex];

return (LPCTSTR)pLine->bData;
}


//*****************************************************************************
//*
//*		GetTextLen
//*
//*****************************************************************************
//	Holt die Lnge eines Textes.
//	nIndex		: Ist die Zeilennummer vom Text.
//	Ergibt die Lnge des Texts ohne Nullzeichen, bzw. LB_ERR bei einem Fehler.
int	CColorListBox::GetTextLen(int nIndex)  const
{

	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		return LB_ERR;
		}

return pData->pLines[nIndex]->wLineLen;;
}

//*****************************************************************************
//*
//*		DeleteString
//*
//*****************************************************************************
//	Lscht einen Text aus der Listbox
//	nIndex		: Ist die Zeilennummer vom zu lschenden Text.
//	Ergibt die Zeilennummer vom gelschten Text, bzw. LB_ERR bei einem Fehler.
int	CColorListBox::DeleteString(int nIndex)
{
LineData	 *pLine;
SCROLLINFO	  sScrollInfo;
int			  iCount;
int			  iShift;
int			  iAdd;
int			  iLen;
int			  i;



	pData->sSemaphor.Lock();

	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		pData->sSemaphor.Unlock();
		return LB_ERR;
		}

	pLine=pData->pLines[nIndex];
	memmove(pData->pLines+nIndex,pData->pLines+nIndex+1,(pData->uListItemsCount-nIndex-1)*sizeof(pData->pLines[0]));
	pData->uListItemsCount--;

	if(pData->uListItemsCount<=0)
		{
		pData->iMaxSizeX	 = 0;
		}

														// Prfen ob Linien Zahl kleiner 0x8000 ist
	for(iShift=0,iCount=pData->uListItemsCount;iCount>=0x8000;iShift++)
		{
		iCount/=2;
		}


	sScrollInfo.cbSize	= sizeof(sScrollInfo);
	sScrollInfo.fMask	= SIF_RANGE;

	if(pData->uShiftY!=iShift)							// Hat sich der Verschub gendert
		{
		pData->uShiftY	 	= iShift;
		sScrollInfo.fMask	= SIF_RANGE|SIF_PAGE|SIF_POS;
		}

	if(pData->uScrollY>0 && pData->uScrollY<nIndex)
		{
		pData->uScrollY--;
		}

	if(pData->uScrollY>=pData->uListItemsCount)
		{
		   pData->uScrollY = pData->uListItemsCount-1;
		if(pData->uScrollY<0)pData->uScrollY = 0;
		}


	   iAdd=pData->uPageEnties/4;
	if(iAdd>10)iAdd=10;
	if(iAdd< 2)iAdd=2;

	sScrollInfo.nPage	= (pData->uPageEnties       )>>pData->uShiftY;
	sScrollInfo.nPos	= (pData->uScrollY       )>>pData->uShiftY;
	sScrollInfo.nMax	= (pData->uListItemsCount+iAdd)>>pData->uShiftY;
	sScrollInfo.nMin	= 0;

	pData->sSemaphor.Unlock();


	SetScrollInfo(SB_VERT,&sScrollInfo);

	if(pData->iMaxX==pLine->wLineLen)						// Neue Breite berechen
		{
		for(i=0,iLen=0;i<pData->uListItemsCount;i++)
			{
			if(iLen<=pData->pLines[nIndex]->wLineLen)continue;
			iLen=pData->pLines[nIndex]->wLineLen;
			}

		pData->iMaxX				= iLen;
		sScrollInfo.nMin	= 0;
		sScrollInfo.nMax	= pData->iMaxSizeX+16;
		if(pData->uStyleEx&CBL_EX_HASBUTTONS)sScrollInfo.nMax+=SELECT_SIZE;
		SetScrollInfo(SB_HORZ,&sScrollInfo);
		}

	if(pData->uSelectedLine==nIndex)								// Den selektierten Eintrag nachfhren
		{
		SetCurSel(-1,FALSE);
		}
	else if(pData->uSelectedLine>nIndex)
		{
		SetCurSel(pData->uSelectedLine-1,FALSE);
		}

	delete pLine;

	if(pData->cHasCaret && pData->iCursorY>nIndex)
		{
		   pData->iCursorY--;
		if(pData->iCursorY<0)pData->iCursorY=0;

		UpdateCaret();
		}

	if(pData->iMarkMode)										// Den markierten Bereich lschen
	if(pData->iMarkStartY>=nIndex || pData->iMarkStartY>=nIndex)
		{
		pData->iMarkMode	= 0;
		RedrawWindow();
		return nIndex;
		}


	if(nIndex<=pData->uScrollY+pData->uPageEnties)					// Neuzeichen wenn Sichtbar
		{
		RedrawWindow();
		}



return nIndex;
}

//*****************************************************************************
//*
//*		SetColor
//*
//*****************************************************************************
//	Eine Farbe einstellen.
//	iNr			: Ist der Index der Farbe die eingestellt werden soll.
//					1 = Farbe fr ausgewhlte Zeile (mit  Focus)
//					2 = Farbe fr ausgewhlte Zeile (ohne Focus)
//					3 = Farbe fr ausgewhlte Textmarke
//	cRgbText	: Ist die Textfarbe fr die Farbe.
//					0xFFFFFFFF steht fr keine nderung.
//					Bei den Farben 1 bis 3 kann mit 0xFF000000 bestimmt
//				    werden, das die ursprngliche Textfarbe fr Marken
//					verwendet werden soll.
//	cRgbHg		: Ist die Hintergrundfarbe fr die Farbe.
//					0xFFFFFFFF steht fr die aktuelle Hintergrund Farbe
//	Ergibt den Index der eingestllten Farbe, bzw. LB_ERR bei einem Fehler.
int CColorListBox::SetColor(int iNr,COLORREF cRgbText,COLORREF cRgbHg)
{

	if((unsigned)iNr>=CLB_MAX_COLOR+2)
		{
		return LB_ERR;
		}

	if(iNr>=CLB_MAX_COLOR)								// Gerade und ungerade Zeilen
		{
		if(cRgbText==0xFFFFFFFF)
			{
			pData->aColorFixed[iNr-CLB_MAX_COLOR+1] = 0;
			}
		else{
			pData->aColorFixed[iNr-CLB_MAX_COLOR+1] = 1;
			pData->aColorText[iNr] = cRgbText;
			}

		if(cRgbHg==0xFFFFFFFF)
			{
			pData->aColorFixed[iNr-CLB_MAX_COLOR+0] = 0;
			}
		else{
			pData->aColorFixed[iNr-CLB_MAX_COLOR+0] = 1;
			pData->aColorHg[iNr] = cRgbHg;
			}

		UpdateColors();
		}
	else{												// Normale Farben
		if(cRgbText==0xFFFFFFFF)
			{
			cRgbText=pData->aColorText[iNr];
			}

		pData->aColorHg  [iNr] = cRgbHg;
		pData->aColorText[iNr] = cRgbText;
		}



return iNr;
}

//*****************************************************************************
//*
//*		SetClipboardText
//*
//*****************************************************************************
//	Speichert einen Text in die Zwischenablage
//	pText	: Ist der Zeiger auf den Text
//	iSize	: Ist die maximale Lnge vom Text
//	Ergibt die Lnge des gespeicherten Textes bzw. 0 wenn kein Text gespeichert wurde.
int CColorListBox::SetClipboardText(LPCTSTR pText,int iSize)
{
TCHAR	   *pNew;
int			iOk=0;
HGLOBAL		hGlobal;


	if(iSize<=0)return 0;

	hGlobal	= GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE,(iSize+1)*sizeof(pText[0]));
	pNew	= (TCHAR*)GlobalLock(hGlobal);
	memcpy(pNew,pText,iSize*sizeof(TCHAR));
	pNew[iSize]=0;

	GlobalUnlock(hGlobal);

	if(OpenClipboard())
		{
		EmptyClipboard();
		if(!SetClipboardData((sizeof(TCHAR)>1)? CF_UNICODETEXT:CF_TEXT,hGlobal))GlobalFree(hGlobal);
		CloseClipboard();
		iOk=iSize;
		}
	else{
		GlobalFree(hGlobal);
		}


return iOk;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CColorListBox::OnDestroy()
{

	if(pData->iCaretOn)
		{
		HideCaret();
		pData->iCaretOn=0;
		}

	if(pData->iCaretExist)
		{
		DestroyCaret();
		pData->iCaretExist=0;
		}

	CWnd::OnDestroy();
	ResetContent();
}


//*****************************************************************************
//*
//*		OnHScroll
//*
//*****************************************************************************
void CColorListBox::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
SCROLLINFO	  sScrollInfo;
int			  iPage;



	sScrollInfo.cbSize	= sizeof(sScrollInfo);
	sScrollInfo.fMask	= SIF_ALL;
	GetScrollInfo(SB_HORZ,&sScrollInfo);

	iPage = sScrollInfo.nPage-1;

	switch(nSBCode)
		{
	case SB_LINEDOWN:		sScrollInfo.nPos+=pData->iFontWidth;	break;
	case SB_LINEUP:			sScrollInfo.nPos-=pData->iFontWidth;	break;
	case SB_PAGEDOWN:		sScrollInfo.nPos+=iPage;	break;
	case SB_PAGEUP:			sScrollInfo.nPos-=iPage;	break;
	case SB_THUMBPOSITION:	sScrollInfo.nPos =nPos;		break;
	case SB_THUMBTRACK:		sScrollInfo.nPos =nPos;		break;
		}

	if(sScrollInfo.nPos>= sScrollInfo.nMax-iPage)sScrollInfo.nPos=sScrollInfo.nMax-iPage;
	if(sScrollInfo.nPos<0)sScrollInfo.nPos=0;

	SetScrollInfo(SB_HORZ,&sScrollInfo);

	if(pData->uScrollX!=sScrollInfo.nPos)
		{
		pData->uScrollX = sScrollInfo.nPos;
		RedrawWindow();
		}
}



//*****************************************************************************
//*
//*		OnVScroll
//*
//*****************************************************************************
void CColorListBox::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
SCROLLINFO		sScrollInfo;
int				iPage;




	sScrollInfo.cbSize	= sizeof(sScrollInfo);
	sScrollInfo.fMask	= SIF_ALL;
	GetScrollInfo(SB_VERT,&sScrollInfo);

	iPage = sScrollInfo.nPage-1;

	switch(nSBCode)
		{
	case SB_LINEDOWN:		sScrollInfo.nPos+=1<<pData->uShiftY;	break;
	case SB_LINEUP:			sScrollInfo.nPos-=1<<pData->uShiftY;	break;
	case SB_PAGEDOWN:		sScrollInfo.nPos+=iPage;			break;
	case SB_PAGEUP:			sScrollInfo.nPos-=iPage;			break;
	case SB_THUMBPOSITION:	sScrollInfo.nPos =nPos;				break;
	case SB_THUMBTRACK:		sScrollInfo.nPos =nPos;				break;
		}


	if(sScrollInfo.nPos>= sScrollInfo.nMax-iPage)sScrollInfo.nPos=sScrollInfo.nMax-iPage;
	if(sScrollInfo.nPos<0)sScrollInfo.nPos=0;

	SetScrollInfo(SB_VERT,&sScrollInfo);

	if(pData->uScrollY!=(sScrollInfo.nPos<<pData->uShiftY))
		{
		pData->uScrollY = sScrollInfo.nPos<<pData->uShiftY;
		RedrawWindow();
		}

}



//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CColorListBox::OnCreate(LPCREATESTRUCT pCreateStruct)
{
SCROLLINFO	  sScrollInfo;


	pData->uScrollX = 0;
	pData->uScrollY = 0;

	if (CWnd::OnCreate(pCreateStruct) == -1)return -1;

	sScrollInfo.cbSize	  = sizeof(sScrollInfo);
	sScrollInfo.fMask	  = SIF_ALL;
	sScrollInfo.nMax	  = 1;
	sScrollInfo.nMin	  = 0;
	sScrollInfo.nPos	  = 0;
	sScrollInfo.nPage	  = 16;
	sScrollInfo.nTrackPos = 0;

	SetScrollInfo(SB_VERT,&sScrollInfo,FALSE);

	sScrollInfo.cbSize	  = sizeof(sScrollInfo);
	sScrollInfo.fMask	  = SIF_ALL;
	sScrollInfo.nMax	  = 1;
	sScrollInfo.nMin	  = 0;
	sScrollInfo.nPos	  = 0;
	sScrollInfo.nPage	  = 16;
	sScrollInfo.nTrackPos = 0;

	SetScrollInfo(SB_HORZ,&sScrollInfo,FALSE);


return 0;
}


//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CColorListBox::OnSize(UINT nType,int iSizeX,int iSizeY)
{
SCROLLINFO	sScrollInfo;
TEXTMETRIC 	sMetrics;
int			iNumX;
int			iNumY;
int			iFlag;
int			iAdd;
HDC			hDc;



	hDc=::GetDC(0);

	SelectObject(hDc,pData->hFont);
	GetTextMetrics(hDc,&sMetrics);

	   pData->iFontMaxX =(sMetrics.tmMaxCharWidth+sMetrics.tmAveCharWidth)/2;
	   pData->iFontWidth    = sMetrics.tmAveCharWidth;
	   pData->iFontHeight    = sMetrics.tmHeight;
	if(pData->iFontHeight<=0)pData->iFontHeight=1;
	if(pData->iFontWidth<=0)pData->iFontWidth=1;



	if((pData->uStyleEx&CBL_EX_HASBUTTONS) && pData->iFontHeight<SELECT_HEIGHT)
		{
		pData->iAddRows = SELECT_HEIGHT-pData->iFontHeight;
		pData->iFontHeight   = SELECT_HEIGHT;
		}
	else{
		pData->iAddRows = 0;
		}

	pData->iFontVar  =(sMetrics.tmPitchAndFamily&TMPF_FIXED_PITCH)? 1:0;
	pData->iTabSize  =(pData->iTabSteps<0)? -pData->iTabSteps:pData->iTabSteps*pData->iFontWidth;
	pData->uSizeX = iSizeX;
	pData->uSizeY = iSizeY;

	if(pData->iFontVar)
		{
		pData->iFontWidth++;
		}

	if(pData->iTabCount<=1)
		{
		pData->aTabPos[0] = pData->iTabSize;
		}

	::ReleaseDC(0,hDc);

	   iNumX=iSizeX/ pData->iFontWidth;
	   iNumY=iSizeY/(pData->iFontHeight+pData->bHasLines);
	if(iNumX<=0)iNumX=1;
	if(iNumY<=0)iNumY=1;

	iFlag = 0;

	if(iNumX!=pData->uSizeCharX)
		{
		sScrollInfo.cbSize	= sizeof(sScrollInfo);
		sScrollInfo.fMask	= SIF_PAGE;
		sScrollInfo.nPage	= pData->uSizeX;
		sScrollInfo.nPos	= GetScrollPos(SB_HORZ);

		if(iNumX>pData->uSizeCharX)
		if(sScrollInfo.nPos>0)
		if(sScrollInfo.nPos>pData->iMaxSizeX+16-pData->uSizeX)
			{
			sScrollInfo.nPos   = pData->iMaxSizeX+16-pData->uSizeX;
			sScrollInfo.fMask |= SIF_POS;
			if(sScrollInfo.nPos<0)sScrollInfo.nPos=0;
			}

		if(pData->uScrollX!=sScrollInfo.nPos)
			{
			pData->uScrollX = sScrollInfo.nPos;
			iFlag	   = 1;
			}

		pData->uSizeCharX			= iNumX;
		SetScrollInfo(SB_HORZ,&sScrollInfo);
		}

	if(iNumY!=pData->uPageEnties)
		{
		   iAdd=iNumY/4;
		if(iAdd>10)iAdd=10;
		if(iAdd< 2)iAdd=2;

		sScrollInfo.cbSize	= sizeof(sScrollInfo);
		sScrollInfo.fMask	= SIF_PAGE|SIF_RANGE;
		sScrollInfo.nPage	= iNumY>>pData->uShiftY;
		sScrollInfo.nPos	= GetScrollPos(SB_VERT);
		sScrollInfo.nMax	= (pData->uListItemsCount+iAdd)>>pData->uShiftY;
		sScrollInfo.nMin	= 0;


		if(iNumY>pData->uPageEnties)
		if(sScrollInfo.nPos>0)
		if(sScrollInfo.nPos>sScrollInfo.nMax-(int)sScrollInfo.nPage)
			{
			sScrollInfo.nPos    = sScrollInfo.nMax-sScrollInfo.nPage+1;
			if(sScrollInfo.nPos<0)sScrollInfo.nPos=0;
			sScrollInfo.nPos >>= pData->uShiftY;
			sScrollInfo.fMask |= SIF_POS;
			}

		if(iNumY+iAdd>=pData->uListItemsCount)
			{
			sScrollInfo.fMask |= SIF_POS;
			sScrollInfo.nPos   = 0;

			if(pData->uScrollY!=0)
				{
				pData->uScrollY = 0;
				iFlag	   = 1;
				}
			}

		if(pData->uScrollY!=(sScrollInfo.nPos<<pData->uShiftY))
			{
			pData->uScrollY = sScrollInfo.nPos<<pData->uShiftY;
			iFlag	   = 1;
			}

		pData->uPageEnties			= iNumY;
		SetScrollInfo(SB_VERT,&sScrollInfo);
		}

	if(iFlag)RedrawWindow();


	CWnd::OnSize(nType,iSizeX,iSizeY);

}


//*****************************************************************************
//*
//*		OnShowWindow
//*
//*****************************************************************************
void CColorListBox::OnShowWindow(BOOL bShow,UINT nStatus)
{

	CWnd::OnShowWindow(bShow,nStatus);

	if(bShow && !pData->bIsVisible)
		{
		pData->bIsVisible = TRUE;
		UpdateTextSize();
		return;
		}

	pData->bIsVisible = bShow;

}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CColorListBox::OnTimer(UINT uId)
{


	if(uId==1 && pData->iMarkMode==1)
		{
		int		iRow,iDiff,iLine,iYsize;
		CPoint	sPoint;

		GetCursorPos  (&sPoint);
		ScreenToClient(&sPoint);

		iYsize = (pData->iFontHeight+pData->bHasLines);
		iRow   = (sPoint.x+pData->iFontWidth/2)/pData->iFontWidth;
		iLine  = (sPoint.y+iYsize  /2)/iYsize;

		if(iRow<0)
			{
			iDiff = (-iRow)/4;
			if(iDiff>1 || (iDiff==1 && (pData->cTimerOn&1)) || (iDiff<=0 && (pData->cTimerOn&3)==2))
				{
				OnHScroll(SB_LINEUP,-1,NULL);
				}
			}

		if(iRow >=pData->uSizeCharX)
			{
			iDiff = (iRow-pData->uSizeCharX)/4;

			if(iDiff>1 || (iDiff==1 && (pData->cTimerOn&1)) || (iDiff<=0 && (pData->cTimerOn&3)==2))
				{
				OnHScroll(SB_LINEDOWN,1,NULL);
				}
			}

		if(iLine<0)
			{
			iDiff = (-iLine)/4;

			if(iDiff>1 || (iDiff==1 && (pData->cTimerOn&1)) || (iDiff<=0 && (pData->cTimerOn&3)==2))
				{
				OnVScroll(SB_LINEUP,-1,NULL);
				}
			}

		if(iLine>=pData->uPageEnties)
			{
			iDiff = (iLine-pData->uPageEnties)/4;

			if(iDiff>1 || (iDiff==1 && (pData->cTimerOn&1)) || (iDiff<=0 && (pData->cTimerOn&3)==2))
				{
				OnVScroll(SB_LINEDOWN,1,NULL);
				}
			}

		OnMouseMove(0,sPoint);

		if(pData->cTimerOn)pData->cTimerOn++;
		}

}

//*****************************************************************************
//*
//*		OnLButtonUp
//*
//*****************************************************************************
void CColorListBox::OnLButtonUp(UINT nFlags,CPoint sPoint)
{
int		iLine;
int		iRow;


	if(pData->uStyleEx&CBL_EX_HASBUTTONS)sPoint.x-=SELECT_SIZE;

	iLine  = sPoint.y/(pData->iFontHeight+pData->bHasLines)+pData->uScrollY;
	iRow   = RowOfPoint(iLine,sPoint.x,1);

	if(pData->iMarkType==3)									// Nur ganzzeilige Markierungen
		{
		if(pData->iMarkStartY<iLine || (pData->iMarkStartY==iLine && pData->iMarkStartX<iRow))
			{
			iLine          += 1;
			iRow			= 0;
			pData->iMarkStartX	= 0;
			}
		else{
			iRow			= 0;
			pData->iMarkStartX	= 0x8000;
			}
		}


	if(iLine>pData->uListItemsCount)iLine=pData->uListItemsCount;
	if(iLine<0)iLine=0;
	if(iRow <0)iRow =0;


	if(pData->cTimerOn)										// Den Scroll-Timer abschalten
		{
		pData->cTimerOn=0;
		KillTimer(1);
		}

	if(pData->iMarkType>=1 && pData->iMarkMode==1)
		{
		if(pData->iMarkType>=2)pData->iMarkStopY=iLine;
		pData->iMarkStopX  = iRow;							// Beginn einer Marke
		pData->iMarkMode   = 2;
		}


	if(pData->iMarkStopX==pData->iMarkStartX)
	if(pData->iMarkStopY==pData->iMarkStartY)
		{
		pData->iMarkMode=0;
		}

	ReleaseCapture();


}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
void CColorListBox::OnLButtonDown(UINT nFlags,CPoint sPoint)
{
LineData   *pLine;
CWnd	   *pWnd;
WORD		wId;
int			iLine;
int			iRow;
int			iOld;


	if(!pData->cHasFocus)SetFocus();

	iLine  = sPoint.y/(pData->iFontHeight+pData->bHasLines)+pData->uScrollY;

	if(iLine>=pData->uListItemsCount)return;
	if(iLine> pData->uListItemsCount)iLine=pData->uListItemsCount;
	if(iLine< 0)iLine=0;

	if(pData->uStyleEx&CBL_EX_HASBUTTONS)									// Umschalten der Auswahl
		{
		if(sPoint.x<20)
			{
			pLine = pData->pLines[iLine];

			if(!(pLine->wLineSel&2))					// Ist das Auswahlfeld eingeblendet
				{
				SetSel(iLine,!pLine->wLineSel,TRUE);
				}

			return;
			}

		sPoint.x-=SELECT_SIZE;
		}

	iRow = RowOfPoint(iLine,sPoint.x,1);


	if(iRow<0)iRow=0;

	SetCapture();

	iOld = pData->iMarkMode;

	if(pData->iMarkType>=1)
		{
		pData->iMarkMode   = 1;								// Beginn einer Marke
		pData->iMarkStartX = (pData->iMarkType==3)? 0:iRow;
		pData->iMarkStopX  = (pData->iMarkType==3)? 0:iRow;
		pData->iMarkStartY = iLine;
		pData->iMarkStopY  = iLine;
		}

	if(pData->cHasCaret)
	if(pData->iCursorX!=iRow || pData->iCursorY!=iLine)			// Eine neue Cursorposition setzen
		{
		pData->iCursorX = iRow;
		pData->iCursorY = iLine;
		UpdateCaret();
		}

	if(iLine!=pData->uSelectedLine)								// Hat sich die aktuelle Linie gendert
		{
		iOld=0;
		pData->uSelectedLine=iLine;
		RedrawWindow();

			pWnd=GetParent();
		if(!pWnd)return;

		wId=(WORD)GetWindowLong(pData->hWnd,GWL_ID);
		pWnd->SendMessage(WM_COMMAND,MAKELONG(wId,LBN_SELCHANGE),(LPARAM)pData->hWnd);
		}

	if(iOld)RedrawWindow();

}


//*****************************************************************************
//*
//*		OnLButtonDblClk
//*
//*****************************************************************************
void CColorListBox::OnLButtonDblClk(UINT nFlags,CPoint sPoint)
{
LineData   *pLine;
CWnd	   *pWnd;
LPCTSTR		pText;
int			iLine;
int			iPos1;
int			iPos2;
WORD		wId;



	iLine = sPoint.y/(pData->iFontHeight+pData->bHasLines)+pData->uScrollY;

	if(pData->bSelDblclk)
		{												// Umschalten der Auswahl
		if(iLine>=pData->uListItemsCount)return;
		if(iLine> pData->uListItemsCount)iLine=pData->uListItemsCount;
		if(iLine< 0)iLine=0;

		if(pData->uStyleEx&CBL_EX_HASBUTTONS)
			{
			if(sPoint.x>=20 || !(pData->uStyleEx&CBL_EX_HASBUTTONS))
				{
				pLine = pData->pLines[iLine];
				SetSel(iLine,!pLine->wLineSel,TRUE);
				}
			}
		}
	if(pData->uStyleEx&CBL_EX_HASBUTTONS)sPoint.x-=SELECT_SIZE;

	if(pData->uStyleEx&CBL_EX_SELWORDDBL  && iLine<pData->uListItemsCount)			// Das Wort auswhlen
	if(pData->iMarkType==1 || pData->iMarkType==2)
	if(sPoint.x>=0)
		{
		pLine = pData->pLines[iLine];
		pText = (TCHAR*)pLine->bData;
		iPos1 = RowOfPoint(iLine,sPoint.x);


		if(iPos1>0 && IsChar(pText[iPos1-1]))
			{
			iPos1--;
			while(iPos1>0 && IsChar(pText[iPos1-1]))iPos1--;
			}

		iPos2=iPos1;
		while(iPos2<pLine->wLineLen && IsChar(pText[iPos2]))iPos2++;

		if(iPos1!=iPos2)
		if(pData->iMarkStartX!=iPos1 || pData->iMarkStopX!=iPos2 ||
		   pData->iMarkStartY!=iLine || pData->iMarkStopY!=iLine)
			{
			pData->iMarkStartX = iPos1;
			pData->iMarkStopX  = iPos2;
			pData->iMarkStartY = iLine;
			pData->iMarkStopY  = iLine;
			pData->iMarkMode   = 2;

			RedrawWindow();
			}
		}


		pWnd=GetParent();
	if(!pWnd)return;

	wId=(WORD)GetWindowLong(pData->hWnd,GWL_ID);
	pWnd->SendMessage(WM_COMMAND,MAKELONG(wId,LBN_DBLCLK),(LPARAM)pData->hWnd);


}

//*****************************************************************************
//*
//*		OnRButtonDown
//*
//*****************************************************************************
void CColorListBox::OnRButtonDown(UINT nFlags,CPoint sPoint)
{
CMenu	sMenu;
CRect	sRect;


	if(!pData->cHasFocus)SetFocus();

	if(!pData->iMarkMode)
		{
		OnLButtonDown(nFlags,sPoint);
		OnLButtonUp  (nFlags,sPoint);
		}

	if(pData->bNoContext)
		{
		CWnd::OnRButtonDown(nFlags,sPoint);
		return;
		}


	sMenu.CreatePopupMenu();
	sMenu.AppendMenu(MF_STRING,ID_COPY   ,_T("&Kopieren"));
	sMenu.AppendMenu(MF_STRING,ID_MARKALL,_T("&Alles markieren"));
	sMenu.EnableMenuItem(ID_COPY   ,(pData->iMarkMode!=0                )? MF_ENABLED:MF_DISABLED|MF_GRAYED);
	sMenu.EnableMenuItem(ID_MARKALL,(pData->iMarkType>=2 && pData->uListItemsCount)? MF_ENABLED:MF_DISABLED|MF_GRAYED);

	GetWindowRect(&sRect);
	sPoint+=sRect.TopLeft();
	sMenu.TrackPopupMenu(TPM_LEFTALIGN,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();



}


//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
void CColorListBox::OnSetFocus(CWnd *pOldWnd)
{
CWnd	*pWnd;
WORD	 wId;


	pData->cHasFocus=1;

	RedrawWindow();

	if(pData->cHasCaret)
		{
		UpdateCaret();
		}

		pWnd=GetParent();
	if(!pWnd)return;

	wId=(WORD)GetWindowLong(pData->hWnd,GWL_ID);
	pWnd->SendMessage(WM_COMMAND,MAKELONG(wId,LBN_SETFOCUS),(LPARAM)pData->hWnd);

}


//*****************************************************************************
//*
//*		OnKillFocus
//*
//*****************************************************************************
void CColorListBox::OnKillFocus(CWnd *pNewWnd)
{
CWnd	*pWnd;
WORD	 wId;


	pData->cHasFocus=0;

	if(pData->cHasCaret)
		{
		UpdateCaret();

		if(pData->iCaretExist)							// Carret lschen bei Focusverlust
			{
			pData->iCaretExist = 0;
			DestroyCaret();
			}
		}

	RedrawWindow();

		pWnd=GetParent();
	if(!pWnd)return;

	wId=(WORD)GetWindowLong(pData->hWnd,GWL_ID);
	pWnd->SendMessage(WM_COMMAND,MAKELONG(wId,LBN_KILLFOCUS),(LPARAM)pData->hWnd);

}

//*****************************************************************************
//*
//*		OnSysColorChange
//*
//*****************************************************************************
void CColorListBox::OnSysColorChange()
{

	UpdateColors();
	RedrawWindow();

}

//*****************************************************************************
//*
//*		OnMouseWheel
//*
//*****************************************************************************
BOOL CColorListBox::OnMouseWheel(UINT nFlags,short iDelta,CPoint sPoint)
{
int iCount;


	if(nFlags&MK_CONTROL)
		{
		if(iDelta<0)OnVScroll(SB_PAGEDOWN,iDelta,GetScrollBarCtrl(SB_VERT));
		else		OnVScroll(SB_PAGEUP  ,iDelta,GetScrollBarCtrl(SB_VERT));
		}
	else{
		iCount=(nFlags&MK_SHIFT)? 9:3;

		for(;iCount>0;iCount--)
			{
			if(iDelta<0)OnVScroll(SB_LINEDOWN,iDelta,GetScrollBarCtrl(SB_VERT));
			else		OnVScroll(SB_LINEUP  ,iDelta,GetScrollBarCtrl(SB_VERT));
			}
		}


return TRUE;
}


//*****************************************************************************
//*
//*		OnMouseMove
//*
//*****************************************************************************
void CColorListBox::OnMouseMove(UINT nFlags,CPoint sPoint)
{
int		iChange;
int		iLine;
int		iRow;


	if(pData->iMarkMode!=1)return;
	if(pData->uStyleEx&CBL_EX_HASBUTTONS)sPoint.x-=SELECT_SIZE;

	iLine  = sPoint.y/(pData->iFontHeight+pData->bHasLines)+pData->uScrollY;
	iRow   = RowOfPoint(iLine,sPoint.x,1);

	if(pData->iMarkType==3)									// Nur ganzzeilige Markierungen
		{
		if(pData->iMarkStartY<iLine || (pData->iMarkStartY==iLine && pData->iMarkStartX<iRow))
			{
			iLine          += 1;
			iRow			= 0;
			pData->iMarkStartX	= 0;
			}
		else{
			iRow			= 0;
			pData->iMarkStartX	= 0x8000;
			}
		}


	if(iLine>pData->uListItemsCount)iLine=pData->uListItemsCount;
	if(iLine<0)iLine=0;
	if(iRow <0)iRow=0;

	if(pData->cHasCaret)
	if(pData->iCursorX!=iRow || pData->iCursorY!=iLine)			// Eine neue Cursorposition setzen
		{
		pData->iCursorX = iRow;
		pData->iCursorY = iLine;
		UpdateCaret();
		}


	if(!pData->cTimerOn)
		{
		if(iRow <0 || iRow >=pData->uPageEnties ||
		   iLine<0 || iLine>=pData->uSizeCharX)
		   {
		   pData->cTimerOn=1;
		   SetTimer(1,100,NULL);
		   }
		}


	iChange = 0;
	if(pData->iMarkType>=2 && pData->iMarkStopY!=iLine){pData->iMarkStopY=iLine;iChange=1;}
	if(pData->iMarkType>=1 && pData->iMarkStopX!=iRow ){pData->iMarkStopX=iRow ;iChange=1;}

	if(iChange)RedrawWindow();


}
int		SelectWord     ();

//*****************************************************************************
//*
//*		OnKeyDown
//*
//*****************************************************************************
void CColorListBox::OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags)
{
CWnd	   *pWnd;
LineData   *pLine;
LPCTSTR		pText;
NMKEY		sNotify;
int			iScrollNewX;
int			iScrollNewY;
int			iCurSelNew;
int			iCursorNew;
int			iChange;
int			iShift;
int			iType1;
int			iType2;
int			iTemp;
int			iPosX;
int			iPosY;
int			iBit;
WORD		wId;



	if(nChar==VK_CONTROL)return;

	iScrollNewX = pData->uScrollX;
	iScrollNewY = pData->uScrollY;
	iCursorNew  = pData->iCursorX;
	iCurSelNew  = (pData->uSelectedLine<0)? pData->iCursorY:pData->uSelectedLine;
	iShift      = GetAsyncKeyState(VK_SHIFT)&0x8000;;


	for(;nRepCnt;nRepCnt--)
	switch(nChar)
		{
	case VK_RETURN:	if(!pData->uStyleEx&CBL_EX_SELRETURN)break;

					   iTemp =  GetSel(pData->uSelectedLine);
					if(iTemp>=0)SetSel(pData->uSelectedLine,!iTemp,TRUE);
					return;

	case VK_HOME:	if(pData->cHasCaret)						// Anfang
					if(!(GetAsyncKeyState(VK_CONTROL)&0x8000))
						{
						iCursorNew = 0;
						break;
						}

					iCurSelNew=0;
					iCursorNew=0;
					break;

	case VK_END:	if(pData->cHasCaret)						// Ende
					if(!(GetAsyncKeyState(VK_CONTROL)&0x8000))
						{
						if(iCurSelNew>=pData->uListItemsCount)
							{
							iCursorNew = 0;
							break;
							}

						pLine		= pData->pLines[iCurSelNew];
						iCursorNew	= pLine->wLineLen;
						break;
						}

					iCurSelNew=pData->uListItemsCount-1;

					if(iCurSelNew<pData->uListItemsCount)
							iCursorNew=pData->pLines[iCurSelNew]->wLineLen;
					else	iCursorNew=0;
					break;

	case VK_UP:											// Auf
					if(GetAsyncKeyState(VK_CONTROL)&0x8000)
						{
						OnVScroll(SB_THUMBTRACK,(pData->uScrollY-1)>>pData->uShiftY,0);
						break;
						}

					if(iCurSelNew<=0)break;

					if(!iShift && pData->iMarkMode && pData->iMarkType!=3)
						{
						iPosY = (pData->iMarkStartY<pData->iMarkStopY)? pData->iMarkStartY:pData->iMarkStopY;

						if(iCurSelNew>iPosY)
							{
							iCurSelNew=iPosY;
							}
						}

					iCurSelNew--;
					iCursorNew = RowOfNewLine(iCurSelNew,pData->iCursorY,pData->iCursorX);
					break;

	case VK_DOWN:										// Ab
					if(GetAsyncKeyState(VK_CONTROL)&0x8000)
						{
						OnVScroll(SB_THUMBTRACK,(pData->uScrollY+1)>>pData->uShiftY,0);
						break;
						}

					if(iCurSelNew+1>=pData->uListItemsCount)break;

					if(!iShift && pData->iMarkMode && pData->iMarkType!=3)
						{
						iPosY = (pData->iMarkStartY>pData->iMarkStopY)? pData->iMarkStartY:pData->iMarkStopY;

						if(iCurSelNew<iPosY)
							{
							iCurSelNew=iPosY;
							}
						}

					iCurSelNew++;
					iCursorNew = RowOfNewLine(iCurSelNew,pData->iCursorY,pData->iCursorX);
					break;

	case VK_PRIOR:										// Seite auf
					if(GetAsyncKeyState(VK_CONTROL)&0x8000)
						{
						OnVScroll(SB_THUMBTRACK,(pData->uScrollY-pData->uPageEnties+1)>>pData->uShiftY,0);
						break;
						}

					iScrollNewX -= pData->uPageEnties-1;
					iCurSelNew  -= pData->uPageEnties-1;
					iCursorNew   = RowOfNewLine(iCurSelNew,pData->iCursorY,pData->iCursorX);
					break;

	case VK_NEXT:										// Seite ab
					if(GetAsyncKeyState(VK_CONTROL)&0x8000)
						{
						OnVScroll(SB_THUMBTRACK,(pData->uScrollY+pData->uPageEnties-1)>>pData->uShiftY,0);
						break;
						}

					iScrollNewY += pData->uPageEnties-1;
					iCurSelNew  += pData->uPageEnties-1;
					iCursorNew   = RowOfNewLine(iCurSelNew,pData->iCursorY,pData->iCursorX);
					break;

	case VK_LEFT:										// Cursor nach Links
					if(!pData->cHasCaret)break;


					if(!iShift && pData->iMarkMode && pData->iMarkType!=3)
						{
						GetMark(iPosX,iPosY,iTemp,iTemp);

						if(iCurSelNew>iPosY || (iCurSelNew==iPosY && iCursorNew>iPosX))
							{
							iCursorNew=iPosX;
							iCurSelNew=iPosY;
							break;
							}
						}

					if(iCursorNew==0 || iCurSelNew>=pData->uListItemsCount)
						{
						iCurSelNew--;

						if(iCurSelNew<0)
							{
							iCurSelNew = 0;
							iCursorNew = 0;
							}
						else{
							pLine		= pData->pLines[iCurSelNew];
							iCursorNew	= pLine->wLineLen;
							}
						}
					else{
						pLine = pData->pLines[iCurSelNew];
						pText = (TCHAR*)pLine->bData;

						if(GetAsyncKeyState(VK_CONTROL)&0x8000)
							{
							iType1 = CharType(pText[iCursorNew-1]);

							for(iCursorNew--;iCursorNew>0;iCursorNew--)
								{
								iType2 = CharType(pText[iCursorNew-1]);
								iBit   = 1<<(iType1+iType2*5);
								if(pData->iKeyStepMask&iBit)break;
								iType1 = iType2;
								}
							}
						else{
							iCursorNew--;

							}
						}

					break;

	case VK_RIGHT:										// Cursor nach Rechts
					if(!pData->cHasCaret)break;

					if(!iShift && pData->iMarkMode && pData->iMarkType!=3)
						{
						GetMark(iTemp,iTemp,iPosX,iPosY);

						if(iCurSelNew<iPosY || (iCurSelNew==iPosY && iCursorNew<iPosX))
							{
							iCursorNew=iPosX;
							iCurSelNew=iPosY;
							break;
							}
						}

					if(iCurSelNew>=pData->uListItemsCount)
						{
						iCursorNew=0;
						}
					else{
						pLine = pData->pLines[iCurSelNew];
						pText = (TCHAR*)pLine->bData;

						if(iCursorNew>=pLine->wLineLen)
							{
							if(iCurSelNew+1>=pData->uListItemsCount)
								{
								iCursorNew=pLine->wLineLen;
								break;
								}

							iCursorNew = 0;
							iCurSelNew++;
							break;
							}

						if(GetAsyncKeyState(VK_CONTROL)&0x8000)
							{
							iType1 = CharType(pText[iCursorNew]);

							for(iCursorNew++;iCursorNew<pLine->wLineLen;iCursorNew++)
								{
								iType2 = CharType(pText[iCursorNew]);
								iBit   = 1<<(iType1*5+iType2);
								if(pData->iKeyStepMask&iBit)break;
								iType1 = iType2;
								}
							}
						else{
							iCursorNew++;
							}
						}

					break;


	case VK_CLEAR:	if(pData->cHasCaret==0)break;			// Ein Wort auswhlen
					if(pData->iMarkType==0)break;
					if(pData->iMarkType==3)break;
					if(iCurSelNew>=pData->uListItemsCount)break;

					pLine		= pData->pLines[iCurSelNew];
					pText		= (TCHAR*)pLine->bData;
					iPosX		= pData->iCursorX;
					iShift		= 1;

					if(iPosX>0 && IsChar(pText[iPosX-1]))
						{
						iPosX--;
						while(iPosX>0 && IsChar(pText[iPosX-1]))iPosX--;
						}

					iCursorNew=iPosX;
					while(iCursorNew<pLine->wLineLen && IsChar(pText[iCursorNew]))iCursorNew++;

					if(iPosX!=iCursorNew)
					if(pData->iMarkStartX!=iPosX      || pData->iMarkStopX!=iCursorNew ||
					   pData->iMarkStartY!=iCurSelNew || pData->iMarkStopY!=iCurSelNew)
						{
						pData->iMarkMode = 0;
						pData->iCursorX  = iPosX;
						}

					break;

	case VK_TAB:

				if(pData->uStyleEx&CBL_EX_TABEXIT)
					{
					   pWnd=GetParent();
					if(pWnd)pWnd->SetFocus();
					}

				break;

	case VK_INSERT:
	case 'C':		if(GetAsyncKeyState(VK_CONTROL)&0x8000)OnCopy();break;
		}


	sNotify.hdr.code		= NM_KEYDOWN;
	sNotify.hdr.hwndFrom	= pData->hWnd;
	sNotify.hdr.idFrom		= GetWindowLong(pData->hWnd,GWL_ID);
	sNotify.nVKey			= nChar;
	sNotify.uFlags			= (nFlags<<16)|(nRepCnt);

	GetParent()->SendMessage(WM_NOTIFY,sNotify.hdr.idFrom,(LPARAM)&sNotify);


//*****************************************************************************


	if(pData->cHasCaret)										// Eine neue Cursorposition setzen
	if(pData->iCursorX!=iCursorNew || pData->iCursorY!=iCurSelNew)
		{
		if(iShift && pData->iMarkType)
			{											// Marke nachziehen
			iChange = 0;

			switch(pData->iMarkType)
				{
			case 3:	if(pData->iMarkStopY!=iCurSelNew)		// Nur ganzzeilige Marken
						{
						pData->iMarkStopY=iCurSelNew;
						iChange=1;
						}

					if(pData->iMarkMode==0)
						{
						if(pData->iMarkStartY!=pData->iCursorY){pData->iMarkStartY=pData->iCursorY;iChange=1;}
						}

					if(pData->iMarkStartY<=pData->iMarkStopY)
						{
						if(pData->iMarkStartX!=0x0000){pData->iMarkStartX=0x0000;iChange=1;}
						if(pData->iMarkStopX !=0x8000){pData->iMarkStopX =0x8000;iChange=1;}
						}
					else{
						if(pData->iMarkStartX!=0x8000){pData->iMarkStartX=0x8000;iChange=1;}
						if(pData->iMarkStopX !=0x0000){pData->iMarkStopX =0x0000;iChange=1;}
						}

					break;

			case 2:										// Mehrzeilige Marken
					if(pData->iMarkStopX!=iCursorNew){pData->iMarkStopX=iCursorNew;iChange=1;}
					if(pData->iMarkStopY!=iCurSelNew){pData->iMarkStopY=iCurSelNew;iChange=1;}

					if(pData->iMarkMode==0)
						{
						if(pData->iMarkStartX!=pData->iCursorX){pData->iMarkStartX=pData->iCursorX;iChange=1;}
						if(pData->iMarkStartY!=pData->iCursorY){pData->iMarkStartY=pData->iCursorY;iChange=1;}
						}

					break;

			case 1:	if(pData->iMarkStopX!=iCursorNew)		// Einzeilige Marken
						{
						pData->iMarkStopX=iCursorNew;
						iChange=1;
						}

					if(pData->iMarkMode==0)
						{
						if(pData->iMarkStartX!=pData->iCursorX){pData->iMarkStartX=pData->iCursorX;iChange=1;}
						if(pData->iMarkStartY!=iCurSelNew){pData->iMarkStartY=iCurSelNew;iChange=1;}
						if(pData->iMarkStopY !=iCurSelNew){pData->iMarkStopY =iCurSelNew;iChange=1;}
						}

					break;
				}

			pData->iCursorX = iCursorNew;
			pData->iCursorY = iCurSelNew;

			if(iChange)									// Hat sich die Marke verndert
				{
				if(pData->iMarkStartY!=pData->iMarkStopY || pData->iMarkStartX!=pData->iMarkStopX)
					{
					pData->iMarkMode=2;
					}
				else{
					pData->iMarkMode=0;
					}

				RedrawWindow();
				}
			else{
				UpdateCaret();
				}
			}
		else if(pData->iMarkMode && iCurSelNew==pData->uSelectedLine)	// Marke lschen
			{
			pData->iCursorX    = iCursorNew;
			pData->iCursorY    = iCurSelNew;

			pData->iMarkStopX  = 0;
			pData->iMarkStartX = 0;
			pData->iMarkStopY  = 0;
			pData->iMarkStartY = 0;
			pData->iMarkMode	  = 0;

			RedrawWindow();
			}
		else{
			pData->iCursorX    = iCursorNew;
			pData->iCursorY    = iCurSelNew;
			UpdateCaret();
			}

		iTemp = PointOfRow(pData->iCursorY,pData->iCursorX);		// X-Scroll-Position nach fhren

		if(iTemp<pData->uScrollX)
			{
			iScrollNewX = iTemp;
			}
		else if(iTemp+12>=pData->uSizeX+pData->uScrollX)
			{
			iScrollNewX = iTemp+12-pData->uSizeX;
			}

		if(pData->uScrollX<0)pData->uScrollX=0;


		if(iScrollNewX!=pData->uScrollX)
			{
			OnHScroll(SB_THUMBTRACK,iScrollNewX,0);
			}
		}

//*****************************************************************************

	if(iCurSelNew!=pData->uSelectedLine)
		{
		if(pData->iMarkMode!=0 && !iShift)					// Den markierten Bereich lschen
			{
			pData->iMarkStopX  = 0;
			pData->iMarkStartX = 0;
			pData->iMarkStopY  = 0;
			pData->iMarkStartY = 0;
			pData->iMarkMode	  = 0;

			RedrawWindow();
			}

		if(iCurSelNew< 0)iCurSelNew=0;
		if(iCurSelNew>=pData->uListItemsCount)iCurSelNew=pData->uListItemsCount-1;

		if(iCurSelNew>=0)
			{
			if(iScrollNewY            > iCurSelNew   )iScrollNewY=iCurSelNew;
			if(iScrollNewY+ pData->uPageEnties<=iCurSelNew   )iScrollNewY=iCurSelNew  -pData->uPageEnties+1;
			if(iScrollNewY>=pData->uListItemsCount-pData->uPageEnties/3)iScrollNewY=pData->uListItemsCount-pData->uPageEnties/3-1;
			if(iScrollNewY<0)iScrollNewY=0;

			if(iScrollNewY!=pData->uScrollY)
				{
				pData->uSelectedLine=iCurSelNew;
				OnVScroll(SB_THUMBTRACK,iScrollNewY>>pData->uShiftY,0);
				}
			else{
				if(iCurSelNew!=pData->uSelectedLine)
					{
					pData->uSelectedLine=iCurSelNew;
					RedrawWindow();
					}
				}
			}

		   pWnd=GetParent();
		if(pWnd)
			{
			wId=(WORD)GetWindowLong(pData->hWnd,GWL_ID);
			pWnd->SendMessage(WM_COMMAND,MAKELONG(wId,LBN_SELCHANGE),(LPARAM)pData->hWnd);
			}

		return;
		}

	CWnd::OnKeyDown(nChar,nRepCnt,nFlags);

}

//*****************************************************************************
//*
//*		OnChar
//*
//*****************************************************************************
void CColorListBox::OnChar(UINT nChar,UINT nRepCnt,UINT nFlags)
{
static TCHAR	cKeyData[16];
static unsigned uKeyLast;
static unsigned uKeyPos;
unsigned		uDelta;
unsigned 		uTick;
unsigned		uPos;
unsigned		uVal;
LPTSTR			pName;
CWnd		   *pWnd;
int				iNum;
int				iMax;
int				i=0;
WORD			wId;



	if(nChar>=' ')
		{
		if(pData->bSelSpace && nChar==' ')				// Auswahl mit der SPACE-Taste
			{
			   i =  GetSel(pData->uSelectedLine);
			if(i>=0)SetSel(pData->uSelectedLine,!i,TRUE);
			return;
			}

		iNum = pData->uSelectedLine;
		iMax = pData->uListItemsCount;

		if(iNum<0)iNum=0;
		if((nChar>='a' && nChar<='z') ||			// In Grosbuchstaben umwandeln
		   (nChar>=224 && nChar<=254))
			{
			nChar-='a'-'A';
			}

		for(;;) 									// Suche Anfangsbuchstaben
			{
			uTick  = GetTickCount();
			uDelta = (uKeyPos>0)? 750:500;

			if(uKeyPos>=3           )uDelta=1000;
			if(uTick-uKeyLast>uDelta)uKeyPos=0;
			if(uKeyPos>=8           )uKeyPos=0;
			if(uKeyPos==1 && cKeyData[0]==(TCHAR)nChar)
				{
				uKeyPos=0;
				}

			cKeyData[uKeyPos] = nChar;
			uKeyLast          = uTick;
			uKeyPos          += 1;

			if(uKeyPos>1)
				{
				iNum--;
				if(iNum<0)iNum=iMax-1;
				}

			if(iMax<=0)break;

			for(i=iNum+1;i!=iNum;i++)
				{
				if(i>=iMax){i=-1;continue;}

				pName=(LPTSTR)pData->pLines[i]->bData;

				for(uPos=0;uPos<uKeyPos;uPos++)			// Vergleiche die Texte
					{
					#if UNICODE
					uVal = pName[uPos];
					#else
					uVal = ((unsigned char*)pName)[uPos];
					#endif

					if((uVal>='a' && uVal<='z') ||		// In Grosbuchstaben umwandeln
					   (uVal>=224 && uVal<=254))
						{
						uVal-='a'-'A';
						}

					if(cKeyData[uPos]!=(TCHAR)uVal)
						{
						break;
						}
					}

				if(uPos<uKeyPos)continue;

				if(pData->iMarkMode)							// Lschen der Marke
					{
					pData->iMarkMode   = 0;
					pData->iMarkStartX = 0;
					pData->iMarkStopX  = 0;
					pData->iMarkStartY = 0;
					pData->iMarkStopY  = 0;

					RedrawWindow();
					}

				SetCurSel(i);
				EnsureVisible(i,FALSE);

				   pWnd=GetParent();
				if(pWnd)
					{
					wId=(WORD)GetWindowLong(pData->hWnd,GWL_ID);
					pWnd->SendMessage(WM_COMMAND,MAKELONG(wId,LBN_SELCHANGE),(LPARAM)pData->hWnd);
					}

				return;
				}

			if(i!=iNum   )break;
			if(uKeyPos<=1)break;

			iNum++;
			if(iNum>=iMax)iNum=iMax-1;

			uKeyPos=0;
			}

		return;
		}


	CWnd::OnChar(nChar,nRepCnt,nFlags);

}



//*****************************************************************************
//*
//*		OnGetDlgCode
//*
//*****************************************************************************
LRESULT CColorListBox::OnGetDlgCode(WPARAM wParam,LPARAM lParam)
{
MSG		   *pMsg;


	   pMsg=(MSG*)lParam;
	if(pMsg && pData->uStyleEx&CBL_EX_SELRETURN)
	if(pMsg->message==WM_KEYDOWN && pMsg->wParam==VK_RETURN)
		{
		return DLGC_WANTALLKEYS;
		}

	return DLGC_WANTARROWS|DLGC_WANTCHARS;;

}

//*****************************************************************************
//*
//*		OnMarkAll
//*
//*****************************************************************************
//	Markiert das ganze Fenster
void CColorListBox::OnMarkAll()
{

	if(pData->iMarkStartY==0 && pData->iMarkStopY==pData->uListItemsCount)
	if(pData->iMarkStartX==0 && pData->iMarkStopX==0)
		{
		return;
		}

	pData->iMarkStopY  = pData->uListItemsCount;
	pData->iMarkStartY = 0;
	pData->iMarkStopX  = 0;
	pData->iMarkStartX = 0;
	pData->iMarkMode	  = (pData->uListItemsCount>0)? 2:0;

	RedrawWindow();

}

//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
//	Kopiert den markierten Text in die Zwischenablage
void CColorListBox::OnCopy()
{
int			i,iChar,iLen;
int			iStartX,iStopX;
int			iStartY,iStopY;
TCHAR	   *pText,*pMem;
LineData   *pLine;


	if(pData->uListItemsCount<=0)return;


	if(pData->iMarkMode ==0)									// Ist etwas ausgewhlt
		{
		iStartX = 0;
		iStopX  = 0x8000;
		iStartY = GetCurSel();
		iStopY  = iStartY;
		}
	else if(pData->iMarkStartY<pData->iMarkStopY || (pData->iMarkStartY==pData->iMarkStopY && pData->iMarkStartX<pData->iMarkStopX))
		{
		iStartX = pData->iMarkStartX;
		iStartY = pData->iMarkStartY;
		iStopX  = pData->iMarkStopX;
		iStopY  = pData->iMarkStopY;
		}
	else{
		iStartX = pData->iMarkStopX;
		iStartY = pData->iMarkStopY;
		iStopX  = pData->iMarkStartX;
		iStopY  = pData->iMarkStartY;

		if(iStopY==iStartY && iStopX==iStartX)
			{
			iStartX =0;
			iStopX  =0x8000;
			}
		}

	if(iStartY==iStopY)									// Einzeilige Marke
		{
		if(iStartY>=pData->uListItemsCount || iStartY<0)return;

 		pLine = pData->pLines[iStartY];
		pText = (TCHAR*)pLine->bData;
		iChar = pLine->wLineLen;

		if(iStartX>iChar)iStartX=iChar;
		if(iStopX >iChar)iStopX =iChar;

		iLen  = iStopX-iStartX;
		if(iLen>0)SetClipboardText(pText+iStartX,iLen);

		return;
		}


	if(iStopY>=pData->uListItemsCount)							// Koordinaten prfen
		{
		iStopY=pData->uListItemsCount-1;
		iStopX=pData->pLines[iStopY]->wLineLen;
		}

	if(iStartY<0)
		{
		iStartY=0;
		iStopX =0;
		}


	iLen  = pData->pLines[iStartY]->wLineLen;				// Lnge der mehrzeiligen Marke bestimmen
	if(iStartX>iLen)iStartX=iLen;
	iLen -= iStartX;
	iLen += 2;

	for(i=iStartY+1;i<iStopY;i++)
		{
		iLen += pData->pLines[i]->wLineLen+2;
		}

	i = pData->pLines[iStopY]->wLineLen;
	if(iStopX>i)iStopX=i;

		pMem=new TCHAR[iLen+iStopX+1];
	if(!pMem)return;

	iLen  = pData->pLines[iStartY]->wLineLen;				// Die Texte kopieren
	iLen -= iStartX;
	if(iLen<0)iLen=0;

	memcpy(pMem,pData->pLines[iStartY]->bData+iStartX,iLen*sizeof(TCHAR));
	pMem[iLen]='\r';iLen++;
	pMem[iLen]='\n';iLen++;

	for(i=iStartY+1;i<iStopY;i++)
		{
		memcpy(pMem+iLen,pData->pLines[i]->bData,pData->pLines[i]->wLineLen*sizeof(TCHAR));
		iLen += pData->pLines[i]->wLineLen;
		pMem[iLen]='\r';iLen++;
		pMem[iLen]='\n';iLen++;
		}

	memcpy(pMem+iLen,pData->pLines[iStopY]->bData,iStopX*sizeof(TCHAR));
	iLen += iStopX;

	SetClipboardText(pMem,iLen);


}

//*****************************************************************************
//*
//*		SetTopIndex
//*
//*****************************************************************************
//	Stellt die oberste sichtbare Zeile ein
//	iIndex	: Ist die Nummer der Zeile die eingestellt werden soll.
//	Ergibt die Zeilennummer der oberste sichtbaren Zeile.
int	CColorListBox::SetTopIndex(int iIndex)
{


	if(iIndex>pData->uListItemsCount-pData->uPageEnties+1)iIndex=pData->uListItemsCount-pData->uPageEnties+1;
	if(iIndex<0)iIndex=0;
	if(iIndex==pData->uScrollY)return iIndex;


	OnVScroll(SB_THUMBPOSITION,iIndex>>pData->uShiftY,NULL);


return iIndex;
}


//*****************************************************************************
//*
//*		SetItemData
//*
//*****************************************************************************
//	Stellt einen Userdatenwert eines Textes ein.
//	nIndex		: Ist die Zeilennummer vom Text.
//	lParam		: Ist der Userdatenwert der eingestellt werden soll.
//	Ergibt die Zeilennummer, bzw. LB_ERR bei einem Fehler.
int CColorListBox::SetItemData(int nIndex,LPARAM lParam)
{
LineData	 *pLine;


	pData->sSemaphor.Lock();

	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		pData->sSemaphor.Unlock();
		return LB_ERR;
		}

	pLine			= pData->pLines[nIndex];
	pLine->lParam	= lParam;


	pData->sSemaphor.Unlock();


return nIndex;
}

//*****************************************************************************
//*
//*		GetItemData
//*
//*****************************************************************************
//	Holt einen Userdatenwert eines Textes.
//	nIndex		: Ist die Zeilennummer vom Text.
//	Ergibt den Userdatenwert, bzw. LB_ERR bei einem Fehler.
LPARAM CColorListBox::GetItemData(int nIndex) const
{
LineData	 *pLine;


	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		return LB_ERR;
		}

	pLine = pData->pLines[nIndex];


return pLine->lParam;
}


//*****************************************************************************
//*
//*		ItemFromPoint
//*
//*****************************************************************************
//	Sucht den nhesten Eintrag in der Listbox bei einem Punkt.
//	sPoint		: Sind die Koordinaten des Puntkes relativ zur linken
//				  oberen Ecke der Listbox.
//	pOutside	: Wenn dieser Zeiger ungleich 0 ist wird hier gespeichert
//				  ob der Punkt im Client-Bereich der Listbox ist.
//	Ergibt die Zeile des nhesten Eintrags.
UINT CColorListBox::ItemFromPoint(CPoint sPoint,BOOL *pOutside) const
{
int		 iLine;
CRect	 sRect;


	if(pOutside)										// Auerhalb des Fensters
		{
		GetClientRect(&sRect);


		if(sPoint.x<sRect.left || sPoint.x>=sRect.right ||
		   sPoint.y<sRect.top  || sPoint.y>=sRect.bottom)
			{
			*pOutside = TRUE;
			}
		else{
			*pOutside = FALSE;
			}
		}

   	iLine  = sPoint.y/pData->iFontHeight;

	if(iLine<0)											// Ober dem Fenster
		{
		iLine = pData->uScrollY;
		}
	else if(iLine>=pData->uPageEnties)							// Unter dem Fenster
		{
		iLine = pData->uScrollY+pData->uPageEnties-1;
		}
	else{
		iLine += pData->uScrollY;
		}

	if(iLine>=pData->uListItemsCount)								// ber Zeilenanzahl
		{
		return pData->uListItemsCount-1;
		}


return iLine;
}


//*****************************************************************************
//*
//*		GetItemRect
//*
//*****************************************************************************
//	Holt die Abmessung der sichtbaren Bereiches eines Eintrages.
//	nIndex		: Ist die Zeilennummer vom Eintrag.
//	pRect		: Hier werden die Abmessungen gespeichert.
//	Ergibt 0 wenn die Zeile sichtbar ist ansonsten LB_ERR.
int CColorListBox::GetItemRect(int nIndex, LPRECT pRect) const
{


	if(nIndex<pData->uScrollY || nIndex>pData->uScrollY+pData->uPageEnties)
		{
		memset(pRect,0,sizeof(RECT));
		return LB_ERR;
		}

	GetClientRect(pRect);

	pRect->top	   += nIndex*(pData->iFontHeight+pData->bHasLines);
	pRect->bottom	= pRect->top+pData->iFontHeight;


return 0;
}


//*****************************************************************************
//*
//*		FindString
//*
//*****************************************************************************
//	Sucht einen Text in der Listbox ohne Grokeinunterscheidung.
//	nAfter		: Ist die Zeilennummer nach der mit der Suche begonnen werden
//				  soll. Bei -1 beginnt die Suche beim ersten Eintrag.
//	pItem		: Ist eine Zeiger auf den Text nach dem gesucht werden soll.
//	Ergibt die Zeilennummer des gefunden Textes oder LB_ERR wenn der Text
//	nicht gefunden wurde.
int CColorListBox::FindString(int nAfter,LPCTSTR pItem)
{
LineData *pLine;


	if(nAfter<0)nAfter=0;

	pData->sSemaphor.Lock();

	for(nAfter++;nAfter<pData->uListItemsCount;nAfter++)
		{
		pLine = pData->pLines[nAfter];
		if(_tcsicmp((TCHAR*)pLine->bData,pItem))continue;
		pData->sSemaphor.Unlock();
		return nAfter;
		}

	pData->sSemaphor.Unlock();


return LB_ERR;
}

//*****************************************************************************
//*
//*		FindStringExact
//*
//*****************************************************************************
//	Sucht einen Text in der Listbox mit Grokeinunterscheidung.
//	nAfter		: Ist die Zeilennummer nach der mit der Suche begonnen werden
//				  soll. Bei -1 beginnt die Suche beim ersten Eintrag.
//	pItem		: Ist eine Zeiger auf den Text nach dem gesucht werden soll.
//	Ergibt die Zeilennummer des gefunden Textes oder LB_ERR wenn der Text
//	nicht gefunden wurde.
int CColorListBox::FindStringExact(int nAfter,LPCTSTR pItem)
{
LineData *pLine;


	if(nAfter<0)nAfter=0;

	pData->sSemaphor.Lock();

	for(nAfter++;nAfter<pData->uListItemsCount;nAfter++)
		{
		pLine = pData->pLines[nAfter];
		if(_tcscmp((TCHAR*)pLine->bData,pItem))continue;
		pData->sSemaphor.Unlock();
		return nAfter;
		}

	pData->sSemaphor.Unlock();


return LB_ERR;
}

//*****************************************************************************
//*
//*		SelectString
//*
//*****************************************************************************
//	Whlt eine einen Text in der Listbox aus.
//	nAfter		: Ist die Zeilennummer nach der mit der Suche begonnen werden
//				  soll. Bei -1 beginnt die Suche beim ersten Eintrag.
//
//	pItem		: Ist ein Zeiger auf den Text nach dem gesucht werden soll.
//	bExact		: Bei TRUE erfolg die Suche mit Grokeinunterscheidung.
//	Ergibt die Zeilennummer des gewhlten Textes oder LB_ERR wenn der Text
//	nicht gefunden wurde.
int CColorListBox::SelectString(int nAfter,LPCTSTR pItem,BOOL bExact)
{

	if(bExact)
			nAfter = FindStringExact(nAfter,pItem);
	else	nAfter = FindString     (nAfter,pItem);

	if(nAfter<0)return 0;


return SetCurSel(nAfter);
}


//*****************************************************************************
//*
//*		SetMarkType
//*
//*****************************************************************************
//	Einstellen des Modses fr die Textauswahl.
//	iType		: Ist der Modus fr die Textauswahl:
//					0 = Es ist keine Textauswahl mglich.
//					1 = Es kann eine einzeilige  Textauswahl gemacht werden.
//					2 = Es kann eine mehrzeilige Textauswahl gemacht werden.
//					3 = Es kann eine mehrzeilige Textauswahl gemacht werden. (nur ganze Zeilen)
void CColorListBox::SetMarkType(int iType)
{


	if(pData->iMarkType==iType)return;

	pData->iMarkType = iType&3;

	if(pData->iMarkMode)
		{
		pData->iMarkStartX	  = 0;								// Beginn einer Marke
		pData->iMarkStartY	  = 0;								//			*
		pData->iMarkStopX	  = 0;								// Ende   einer Marke
		pData->iMarkStopY	  = 0;								//			*
		pData->iMarkMode	      = 0;

		if(IsWindow(pData->hWnd))RedrawWindow();
		}

}


//*****************************************************************************
//*
//*		SetCursorMode
//*
//*****************************************************************************
//	ber diese Funktion kann ein Cursor ein bzw. ausgeschalten werden,
//	iOn		: Bestimmt ob der Cursor aktiviert werden soll.
void CColorListBox::SetCursorMode(int iOn)
{

	if(iOn)iOn=1;

	if(pData->cHasCaret==iOn)return;

	pData->cHasCaret = iOn;

	if(iOn && pData->uSelectedLine>=0 && pData->uSelectedLine!=pData->iCursorY)
		{
		pData->iCursorY = pData->uSelectedLine;
		}

	UpdateCaret();

}


//*****************************************************************************
//*
//*		SetTabExit
//*
//*****************************************************************************
//	ber diese Funktion kann eingestellt werden das der Focus mit TAB zum
//	Elternfenster ber geht.
//	iOn		: Bestimmt ob der Focus zum Elternfenster gehen soll.
void CColorListBox::SetTabExit(int iOn)
{

	if(iOn)iOn=1;

	if((pData->uStyleEx&CBL_EX_TABEXIT)==iOn)return;

	pData->bTabExit = iOn;

}

//*****************************************************************************
//*
//*		SetMarkMode
//*
//*****************************************************************************
//	ber diese Funktion kann eingestellt werden ob der gerade ausgewhlte Text,
//	in der Listbox markiert dargestellt werden.
//	iOn		: Bestimmt ob der selektierte Text angezeigt werden soll.
void CColorListBox::SetMarkMode(int iOn)
{

	if(iOn)iOn=1;

	if(pData->cSelectEnable==iOn)return;

	pData->cSelectEnable = iOn;

	if(pData->uSelectedLine!=-1)
		{
		if(IsWindow(pData->hWnd))RedrawWindow();
		}

}

//*****************************************************************************
//*
//*		SetSelectDblclk
//*
//*****************************************************************************
//	Die Auswahl von Eintrgen mit einem Doppelcklicks erlauben.
//	iMode		: Bestimmt den Modus (0=nein 1=ja)
void CColorListBox::SetSelectDblclk(int iMode)
{

	pData->bSelDblclk = (iMode)? 1:0;

}

//*****************************************************************************
//*
//*		SetSelectSpace
//*
//*****************************************************************************
//	Die Auswahl von Eintrgen mit der SPACE-Tatse erlauben.
//	iMode		: Bestimmt den Modus (0=nein 1=ja)
void CColorListBox::SetSelectSpace(int iMode)
{

	pData->bSelSpace = (iMode)? 1:0;

}

//*****************************************************************************
//*
//*		SetSelectReturn
//*
//*****************************************************************************
//	Die Auswahl von Eintrgen mit der RETURN-Tatse erlauben.
//	iMode		: Bestimmt den Modus (0=nein 1=ja)
void CColorListBox::SetSelectReturn(int iMode)
{

	pData->uStyleEx&CBL_EX_SELRETURN = (iMode)? 1:0;

}

//*****************************************************************************
//*
//*		SetSelectMode
//*
//*****************************************************************************
//	ber diese Funktion kann eingestellt werden ob ein Auswahlfeld.
//	eingeblendet werden soll.
//	iOn		: Bestimmt ob Auswahlfelder sichtbar sein sollen
void CColorListBox::SetSelectMode(int iOn,BOOL bRedraw)
{
CRect	sRect;


	if(iOn)iOn=1;

	if((pData->uStyleEx&CBL_EX_HASBUTTONS)==iOn)return;

	pData->bHasSelect = iOn;

	GetClientRect(&sRect);
	OnSize(0,sRect.right,sRect.bottom);

	if(bRedraw)RedrawWindow();

}

//*****************************************************************************
//*
//*		SetSelectWord
//*
//*****************************************************************************
//	Wortauswahl mit Doppelcklick aktivieren
//	iMode		: Bestimmt den Modus (0=nein 1=ja)
void CColorListBox::SetSelectWord(int iMode)
{

	pData->uStyleEx&CBL_EX_SELWORDDBL = (iMode)? 1:0;

}

//*****************************************************************************
//*
//*		SetAlternated
//*
//*****************************************************************************
//	Einstellen ob Zeichen mit der Standart-Hintergund-Farbe mit wechselnder
//	Farbe dargestellt werden sollen.
//	iOn			: Betimmt ob die Option aktiviert werden soll.
//	bRedraw		: Soll das Fenster neu geszeichnet werden
void CColorListBox::SetAlternated(int iOn,BOOL bRedraw)
{

	if(iOn)iOn=1;

	if(pData->bAlternated==iOn)return;

	pData->bAlternated = iOn;

	if(bRedraw)RedrawWindow();

}

//*****************************************************************************
//*
//*		SetContextMode
//*
//*****************************************************************************
//	Stellt den Modus fr das Context-Men fr die rechte Maustaste ein
//	iMode		: 0=mit Men   1=ohne Men
void CColorListBox::SetContextMode(int iMode)
{

	if(iMode)iMode=1;
	pData->bNoContext = iMode;

}


//*****************************************************************************
//*
//*		SetLineFrames
//*
//*****************************************************************************
//	Einstellen ob Linien um die Eintrge gezeichnet werden sollen.
//	Farbe dargestellt werden sollen.
//	iOn			: Betimmt ob die Option aktiviert werden soll.
//	bRedraw		: Soll das Fenster neu geszeichnet werden
void CColorListBox::SetLineFrames(int iOn,BOOL bRedraw)
{
CRect	sRect;


	if(iOn)iOn=1;

	if(pData->bHasLines==iOn)return;

	pData->bHasLines = iOn;

	GetClientRect(&sRect);
	OnSize(0,sRect.right,sRect.bottom);

	if(bRedraw)RedrawWindow();

}

//*****************************************************************************
//*
//*		RowOfNewLine
//*
//*****************************************************************************
//	Berechnet die Reihe in einer neuen Zeile auf der gleichen X-Koordinate.
//	iLineNew	: Neue Zeilenposition
//	iLineNow	: Aktuelle Zeilenposition
//	iPosNow		: Aktuelle Reihe in der Zeile
//	Ergibt die Reihe in der neuen Zeile
int	CColorListBox::RowOfNewLine(int iLineNew,int iLineNow,int iPosNow)
{
int		iPos;
int		iRow;


	if(iLineNew>=pData->uListItemsCount)return 0;
	if(iLineNow>=pData->uListItemsCount)return 0;

	iPos = PointOfRow(iLineNow,iPosNow);
	iRow = RowOfPoint(iLineNew,iPos+pData->iFontWidth/4);


return iRow;
}

//*****************************************************************************
//*
//*		RowOfPoint
//*
//*****************************************************************************
//	Holt die Textspalte von einem Punkt in einer Zeile
//	iLine		: Ist die Nummer der Zeile
//	iPosX		: Pixel-Position in der Zeile
//	iAddHalf	: Eine Position weiter wenn ber die Buchstabenhlfte
//	Ergibt die Textspalte auf die der Punkt zeigt.
int	CColorListBox::RowOfPoint(int iLine,int iPosX,int iAddHalf)
{
LPCTSTR     pText;
SIZE		sSize;
INT			iSize;
INT			iRow;
INT			iPos;
INT			iEnd;
INT			iOld;
INT			iOff;
INT			iTab;
CDC		   *pDc;


	if(iLine<0 || iLine>=pData->uListItemsCount)						// Gibt es die Zeile
		{
		return 0;
		}

	pText = (TCHAR*)pData->pLines[iLine]->bData;
	iSize =         pData->pLines[iLine]->wLineLen;


	pDc = GetDC();
	pDc->SelectObject(pData->hFont);
	iPosX += pData->uScrollX;

	iPos=0;
	iOff=0;
	iTab=0;

	for(;;)
		{
		for(iEnd=iPos;iEnd<iSize;iEnd++)					// Suche nchstes TAB
			{
			if(pText[iEnd]=='\t')break;
			}

		iRow  = iEnd-iPos;

		if(iRow>0)
			{
			GetTextExtentExPoint(pDc->pData->hDC,pText+iPos,iRow,iPosX-iOff,&iRow,NULL,&sSize);
			iRow += iPos;
			}
		else{
			iRow     = iPos;
			sSize.cx = 0;
			}

		if(iRow<iEnd)										// X-Koordinate berschritten
			{
			if(!iAddHalf)break;

			iOff = iPosX-PointOfRow(iLine,iRow,pDc);
			GetTextExtentExPoint(pDc->pData->hDC,pText+iRow,1,1000,NULL,NULL,&sSize);

			if(iOff*2>=sSize.cx)iRow++;
			break;
			}

		if(iEnd>=iSize)break;

		iOff += sSize.cx;
		iOld  = iOff;

		for(;;iTab++)
			{
			if(iTab>=pData->iTabCount)							// Fixe Tabulatorabstnde
				{
				iOff += pData->iTabSize;
				iOff /= pData->iTabSize;
				iOff *= pData->iTabSize;
				break;
				}

			if(iOff<pData->aTabPos[iTab])
				{
				iOff = pData->aTabPos[iTab];
				break;
				}
			}

		iEnd += 1;

		if(iPosX<iOff)										// X-Koordinate berschritten
			{
			if(!iAddHalf)break;
			if((iPosX-iOld)*2>=iOff-iOld)iRow++;
			break;
			}

		if(iEnd>=iSize)break;

		iPos = iEnd;
		}


	ReleaseDC(pDc);


return iRow;
}

//*****************************************************************************
//*
//*		PointOfRow
//*
//*****************************************************************************
//	Holt die X-Koordinate von einem Zeichen in einer Zeile
//	iLine	: Ist die Nummer der Zeile
//	iPos	: Buchstaben-Position in der Zeile
//	Ergibt die X-Koordinate auf der der Buchstaben beginnt.
int	CColorListBox::PointOfRow(int iLine,int iPos,CDC *pDc)
{
LPCTSTR     pText;
CSize		sSize;
BOOL		bInit;
INT			iSize;




	if(iLine<0 || iLine>=pData->uListItemsCount || iPos<=0)			// Gibt es die Zeile
		{
		return 0;
		}

	pText = (TCHAR*)pData->pLines[iLine]->bData;
	iSize =         pData->pLines[iLine]->wLineLen;

	if(iPos>iSize)iPos=iSize;

	if(!pDc)
		{
		bInit = 1;
		pDc = GetDC();
		pDc->SelectObject(pData->hFont);
		}
	else{
		bInit = 0;
		}

	sSize = pDc->GetTabbedTextExtent(pText,iPos,pData->iTabCount,pData->aTabPos);

	if(bInit)
		{
		ReleaseDC(pDc);
		}



return sSize.cx;
}

//*****************************************************************************
//*
//*		UpdateCaret
//*
//*****************************************************************************
void CColorListBox::UpdateCaret()
{
int		iPosX;
int		iPosY;


	if(pData->cHasCaret && pData->cHasFocus)
		{
		pData->iCaretX = PointOfRow(pData->iCursorY,pData->iCursorX);
		pData->iCaretY = pData->iCursorY*(pData->iFontHeight+pData->bHasLines);
		if(pData->uStyleEx&CBL_EX_HASBUTTONS)pData->iCaretX+=SELECT_SIZE;

		if(!pData->iCaretExist)
			{
			pData->iCaretExist = 1;
			CreateSolidCaret(2,pData->iFontHeight-1);
			}

		if(pData->iCaretX>=pData->uScrollX && pData->iCaretX <pData->uScrollX+pData->uSizeX)
			{
			iPosX = pData->iCaretX-pData->uScrollX;
			iPosY = pData->iCaretY-pData->uScrollY*(pData->iFontHeight+pData->bHasLines);
			SetCaretPos(CPoint(iPosX,iPosY+1));

			if(!pData->iCaretOn)
				{
				pData->iCaretOn=1;
				ShowCaret();
				}

			return;
			}
		}

	if(pData->iCaretOn)
		{
		pData->iCaretOn=0;
		HideCaret();
		}

}

//*****************************************************************************
//*
//*		UpdateColors
//*
//*****************************************************************************
void CColorListBox::UpdateColors()
{
int			iDiff;
int			iSum;


	if(!pData->aColorFixed[0])
		{
		pData->aColorHg[CLB_COLOR_EVEN] = GetSysColor(COLOR_WINDOW);
		}

	if(!pData->aColorFixed[1])
		{
		pData->aColorHg[CLB_COLOR_ODD ] = GetSysColor(COLOR_INFOBK);

		iDiff = ((pData->aColorHg[CLB_COLOR_ODD]    )&0xFF)-((pData->aColorHg[CLB_COLOR_EVEN]    )&0xFF); iSum  = iDiff*iDiff;
		iDiff = ((pData->aColorHg[CLB_COLOR_ODD]>> 8)&0xFF)-((pData->aColorHg[CLB_COLOR_EVEN]>> 8)&0xFF); iSum += iDiff*iDiff;
		iDiff = ((pData->aColorHg[CLB_COLOR_ODD]>>16)&0xFF)-((pData->aColorHg[CLB_COLOR_EVEN]>>16)&0xFF); iSum += iDiff*iDiff;

		if(iSum<64)											// Ist die alternierente Farbe fast gleich ?
			{
			pData->aColorHg[CLB_COLOR_ODD]  =   pData->aColorHg[CLB_COLOR_EVEN]&0x0000FFFF;
			pData->aColorHg[CLB_COLOR_ODD] |= ((pData->aColorHg[CLB_COLOR_EVEN]&0x00FF0000)-0x00080000)&0x00FF0000;
			}
		}

	if(!pData->aColorFixed[2])pData->aColorText[CLB_COLOR_EVEN] = GetSysColor(COLOR_3DFACE);
	if(!pData->aColorFixed[3])pData->aColorText[CLB_COLOR_ODD ] = GetSysColor(COLOR_3DFACE);
}


//*****************************************************************************
//*
//*		UpdateTextSize
//*
//*****************************************************************************
//	Die Schriftart fr die Listbox einstellen.
//	pData->hFont		: Ist der Zeiger auf den Font
//	bRedraw		: Soll die Listbox neu gezeichnet werden.
//	Ergibt TRUE wenn der Font eingestellt wurde.
void CColorListBox::UpdateTextSize()
{
CDC		   *pDc;
LineData   *pLine;
SCROLLINFO	sScrollInfo;
CRect		sRect;
CSize		sSize;
int			iLine;
int			iMax;



	pData->sSemaphor.Lock();

	iMax  = 0;
	pDc   = GetDC();
	pDc->SelectObject(pData->hFont);

	for(iLine=0;iLine<pData->uListItemsCount;iLine++)
		{
		pLine = pData->pLines[iLine];
		sSize = pDc->GetTabbedTextExtent((TCHAR*)pLine->bData,pLine->wLineLen,pData->iTabCount,pData->aTabPos);
		if(sSize.cx<=iMax)continue;
		iMax  = sSize.cx;
		}

	ReleaseDC(pDc);

	pData->sSemaphor.Unlock();

	if(pData->iMaxSizeX!=iMax)
		{
		pData->iMaxSizeX			= iMax;
		sScrollInfo.cbSize	= sizeof(sScrollInfo);
		sScrollInfo.fMask	= SIF_RANGE|SIF_PAGE;
		sScrollInfo.nPage	= pData->uSizeX;
		sScrollInfo.nMax	= pData->iMaxSizeX+16;
		sScrollInfo.nMin	= 0;
		if(pData->uStyleEx&CBL_EX_HASBUTTONS)sScrollInfo.nMax+=SELECT_SIZE;
		SetScrollInfo(SB_HORZ,&sScrollInfo);
		}

}

//*****************************************************************************
//*
//*		SetFlags
//*
//*****************************************************************************
//	Stellt einige Optionen fr das Fenster ein
//	iFlags		: Sind die einzelnen Optionen
//					CLB_FLAG_MARKOFF		Keine       Markierungen
//					CLB_FLAG_MARKSINGLE		Mehrzeilige Markierungen
//					CLB_FLAG_MARKMULTI		Einzeilige  Markierungen
//					CLB_FLAG_MARKFULL		Ganzzeilige Markierungen
//					CLB_FLAG_LINES			Farben fr ungerade Zeilen
//					CLB_FLAG_ALTERNATED		Abwechselnde Faren fr die Zeilen
//					CLB_FLAG_SELMARK		Ausgewhlte Zeile markieren
//					CLB_FLAG_SELFIELD		Auswahlfelder einblenden
//					CLB_FLAG_SELDBLCLK		Auswahl mit Doppelcklick
//					CLB_FLAG_SELSPACE		Auswahl mit SPACE-Taste
//					CLB_FLAG_SELRETURN		Auswahl mit SPACE-Taste
//					CLB_FLAG_CURSOR			Cursor ein bzw. ausblenden
//					CLB_FLAG_WORDDBLCLK		Wortauswahl mit Doppelcklick
//					CLB_FLAG_TABEXIT		Bei TAB den Focus ans Elternfenster geben
//					CLB_FLAG_NOCONTEXT		Kein Kontextmen
//	iMask		: Ist die Maske der Optionen die gendert werden sollen
//					CLB_FLAG_MARKMASK		Maske fr Markierungsart
//					CLB_FLAG_LINES			Farben fr ungerade Zeilen
//					CLB_FLAG_ALTERNATED		Abwechselnde Faren fr die Zeilen
//					CLB_FLAG_SELMARK		Ausgewhlte Zeile markieren
//					CLB_FLAG_SELFIELD		Auswahlfelder einblenden
//					CLB_FLAG_SELDBLCLK		Auswahl mit Doppelcklick
//					CLB_FLAG_SELSPACE		Auswahl mit SPACE-Taste
//					CLB_FLAG_SELRETURN		Auswahl mit SPACE-Taste
//					CLB_FLAG_CURSOR			Cursor ein bzw. ausblenden
//					CLB_FLAG_WORDDBLCLK		Wortauswahl mit Doppelcklick
//					CLB_FLAG_TABEXIT		Bei TAB den Focus ans Elternfenster geben
//					CLB_FLAG_NOCONTEXT		Kein Kontextmen
//	Ergibt die alten Optionen
int CColorListBox::SetFlags(int iFlags,int iMask)
{
BOOL	bRedraw;
int		iChg;
int		iOld;



	bRedraw	= 0;
					   iOld =pData->iMarkType;
	if(pData->bHasLines    )iOld|=CLB_FLAG_LINES;
	if(pData->bAlternated  )iOld|=CLB_FLAG_ALTERNATED;
	if(pData->uStyleEx&CBL_EX_HASBUTTONS   )iOld|=CLB_FLAG_SELFIELD;
	if(pData->cSelectEnable)iOld|=CLB_FLAG_SELMARK;
	if(pData->bSelSpace    )iOld|=CLB_FLAG_SELSPACE;
	if(pData->uStyleEx&CBL_EX_SELRETURN	  )iOld|=CLB_FLAG_SELRETURN;
	if(pData->bSelDblclk   )iOld|=CLB_FLAG_SELDBLCLK;
	if(pData->uStyleEx&CBL_EX_SELWORDDBL  )iOld|=CLB_FLAG_WORDDBLCLK;
	if(pData->cHasCaret    )iOld|=CLB_FLAG_CURSOR;
	if(pData->uStyleEx&CBL_EX_TABEXIT     )iOld|=CLB_FLAG_TABEXIT;
	if(pData->bNoContext   )iOld|=CLB_FLAG_NOCONTEXT;
	if(pData->bKeyStepMisc )iOld|=CLB_FLAG_STEPMISC;
	if(pData->bKeyStepFirst)iOld|=CLB_FLAG_STEPFIRST;
	if(pData->bKeyStepUpper)iOld|=CLB_FLAG_STEPUPPER;
	if(pData->bKeyStepUnter)iOld|=CLB_FLAG_STEPUNTER;



	iFlags  = iFlags &  iMask;
	iFlags |= iOld   & ~iMask;
	iChg    = iFlags ^  iOld;


	if(iChg&CLB_FLAG_SELMARK)
		{
		SetMarkMode(iFlags&CLB_FLAG_SELMARK);
		}

	if(iChg&CLB_FLAG_MARKMASK)
		{
		SetMarkType(iFlags&CLB_FLAG_MARKMASK);
		}

	if(iChg&CLB_FLAG_LINES)
		{
		SetLineFrames(iFlags&CLB_FLAG_LINES,FALSE);
		bRedraw = 1;
		}

	if(iChg&CLB_FLAG_ALTERNATED)
		{
		SetAlternated(iFlags&CLB_FLAG_ALTERNATED,FALSE);
		bRedraw = 1;
		}

	if(iChg&CLB_FLAG_SELFIELD)
		{
		SetSelectMode(iFlags&CLB_FLAG_SELFIELD,FALSE);
		bRedraw = 1;
		}

	if(iChg&CLB_FLAG_SELSPACE)
		{
		SetSelectSpace(iFlags&CLB_FLAG_SELSPACE);
		}

	if(iChg&CLB_FLAG_SELSPACE)
		{
		SetSelectReturn(iFlags&CLB_FLAG_SELRETURN);
		}

	if(iChg&CLB_FLAG_SELDBLCLK)
		{
		SetSelectDblclk(iFlags&CLB_FLAG_SELDBLCLK);
		}

	if(iChg&CLB_FLAG_CURSOR)
		{
		SetCursorMode(iFlags&CLB_FLAG_CURSOR);
		}

	if(iChg&CLB_FLAG_WORDDBLCLK)
		{
		SetSelectWord(iFlags&CLB_FLAG_WORDDBLCLK);
		}

	if(iChg&CLB_FLAG_TABEXIT)
		{
		SetTabExit(iFlags&CLB_FLAG_TABEXIT);
		}

	if(iChg&CLB_FLAG_NOCONTEXT)
		{
		SetContextMode(iFlags&CLB_FLAG_NOCONTEXT);
		}

	if(iChg&CLB_FLAG_STEPALL)
		{
		SetKeyStepMode(iFlags&CLB_FLAG_STEPMISC,iFlags&CLB_FLAG_STEPFIRST,iFlags&CLB_FLAG_STEPUPPER,iFlags&CLB_FLAG_STEPUNTER);
		}

	if(bRedraw)RedrawWindow();



return iOld;
}


//*****************************************************************************
//*
//*		GetMark
//*
//*****************************************************************************
//	Holt den aktuellen markierten Bereich
//	iStartX/iStartY		: Hier wird der Anfang der Markierung gespeichert.
//						  Das ist immer der kleinere Koordinatenwert.
//	iStopX /iStopY		: Hier wird das Ende   der Markierung gespeichert.
//						  Das ist immer der grere Koordinatenwert.
//	Ergibt die Art der Marke
//				0 = keine Markierung
//				1 = einzeilige Markierung
//				2 = mehrzeilige Markierung
int CColorListBox::GetMark(int &iStartX,int &iStartY,int &iStopX,int &iStopY)
{

	if(!pData->iMarkMode)
		{
		iStartX = 0;
		iStartY = 0;
		iStopX  = 0;
		iStopY  = 0;

		return 0;
		}

	if(pData->iMarkStartY<pData->iMarkStopY || (pData->iMarkStartY==pData->iMarkStopY && pData->iMarkStartX<pData->iMarkStopX))
		{
		iStartX = pData->iMarkStartX;
		iStartY = pData->iMarkStartY;
		iStopX  = pData->iMarkStopX;
		iStopY  = pData->iMarkStopY;
		}
	else{
		iStartX = pData->iMarkStopX;
		iStartY = pData->iMarkStopY;
		iStopX  = pData->iMarkStartX;
		iStopY  = pData->iMarkStartY;
		}


return pData->iMarkMode;
}


//*****************************************************************************
//*
//*		GetMark
//*
//*****************************************************************************
//	Holt den aktuellen markierten Bereich. Bei Zeilenmodi (2,3) werden die
//	Y-Koordinaten gespeichert, beim Modus 1 die X-Koordinaten.
//	iStart		: Hier wird der Anfang der Markierung gespeichert.
//				  Das ist immer der kleinere Koordinatenwert.
//	iStop		: Hier wird das Ende   der Markierung gespeichert.
//				  Das ist immer der grere Koordinatenwert.
//	Ergibt die Art der Marke
//				0 = keine Markierung
//				1 = einzeilige Markierung
//				2 = mehrzeilige Markierung
int CColorListBox::GetMark(int &iStart ,int &iStop)
{

	if(!pData->iMarkMode)
		{
		iStart = 0;
		iStop  = 0;

		return 0;
		}

	if(pData->iMarkType>=2)
		{
		if(pData->iMarkStartY<pData->iMarkStopY || (pData->iMarkStartY==pData->iMarkStopY && pData->iMarkStartX<pData->iMarkStopX))
			{
			iStart = pData->iMarkStartY;
			iStop  = pData->iMarkStopY;
			if(pData->iMarkStopX>0)iStop++;
			}
		else{
			iStart = pData->iMarkStopY;
			iStop  = pData->iMarkStartY;
			if(pData->iMarkStartX>0)iStop++;
			}
		}
	else{
		if(pData->iMarkStartX<pData->iMarkStopX)
			{
			iStart = pData->iMarkStartX;
			iStop  = pData->iMarkStopX;
			}
		else{
			iStart = pData->iMarkStopX;
			iStop  = pData->iMarkStartX;
			}
		}


return pData->iMarkMode;
}

//*****************************************************************************
//*
//*		GetSel
//*
//*****************************************************************************
//	Liest aus ob ein Eintrag ausgewhlt ist
//	nIndex		: Ist die Zeilennummer vom Text.
//	Ergibt			0       Wenn der Eintrag nicht ausgewhlt ist
//					1		Wenn der Eintrag ausgewhlt ist
//					LB_ERR	Wenn der Eintrag nicht existiert
int CColorListBox::GetSel(int nIndex) const
{
LineData	 *pLine;


	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		return LB_ERR;
		}

	pLine = pData->pLines[nIndex];

return pLine->wLineSel&1;
}

//*****************************************************************************
//*
//*		SetSel
//*
//*****************************************************************************
//	Whlt einen Eintrag aus bzw. ab.
//	nIndex		: Ist die Zeilennummer vom Text.
//	bSelect		: Soll der Eintrag ausgewhlt werden.
//	Ergibt			0       Wenn der Eintrag existiert
//					LB_ERR	Wenn der Eintrag nicht existiert
int CColorListBox::SetSel(int nIndex,BOOL bSelect,BOOL bNotify)
{
LineData	 *pLine;
CLB_STATUS	  sNotify;
CRect		  sRect;
WORD		  wValue;


	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		return LB_ERR;
		}

	pLine   = pData->pLines[nIndex];
	wValue  = (bSelect)? 1:0;
	wValue |= pLine->wLineSel&2;

	if(pLine->wLineSel!=wValue)							// Hat sich etwas verndert
		{
		pLine->wLineSel = wValue;

		if(!(pLine->wLineSel&2))
		if(nIndex>=pData->uScrollY && nIndex<=pData->uScrollY+pData->uPageEnties)
			{
			sRect.left	 = 0;
			sRect.right	 = SELECT_SIZE;
			sRect.top	 = (nIndex-pData->uScrollY)*(pData->iFontHeight+pData->bHasLines);
			sRect.bottom = 	sRect.top+pData->iFontHeight;
			InvalidateRect(&sRect,FALSE);
			}

		if(bNotify)										// Eine Notify-Nachricht verschicken
			{
			sNotify.sNmHdr.code		= CFL_SELCHANED;
			sNotify.sNmHdr.hwndFrom	= pData->hWnd;
			sNotify.sNmHdr.idFrom	= GetWindowLong(pData->hWnd,GWL_ID);
			sNotify.iItem			= nIndex;
			sNotify.iSelected		= wValue&1;

			GetParent()->SendMessage(WM_NOTIFY,sNotify.sNmHdr.idFrom,(LPARAM)&sNotify);
			}
		}

return 0;
}

//*****************************************************************************
//*
//*		EnableSel
//*
//*****************************************************************************
//	Ermglicht oder sperrt das Auswahlfeld eines Eintrages.
//	nIndex		: Ist die Zeilennummer vom Text.
//	bEnable		: Soll das Auswahlfeld eingeblendet werden
//	Ergibt			0       Wenn der Eintrag existiert
//					LB_ERR	Wenn der Eintrag nicht existiert
int CColorListBox::EnableSel(int nIndex,BOOL bEnable)
{
LineData	 *pLine;
CRect		  sRect;
WORD		  wValue;


	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		return LB_ERR;
		}

	pLine   = pData->pLines[nIndex];
	wValue  = (bEnable)? 0:2;
	wValue |= pLine->wLineSel&1;

	if(pLine->wLineSel!=wValue)							// Hat sich etwas verndert
		{
		pLine->wLineSel = wValue;

		if(nIndex>=pData->uScrollY && nIndex<=pData->uScrollY+pData->uPageEnties)
			{
			sRect.left	 = 0;
			sRect.right	 = SELECT_SIZE;
			sRect.top	 = (nIndex-pData->uScrollY)*(pData->iFontHeight+pData->bHasLines);
			sRect.bottom = 	sRect.top+pData->iFontHeight;
			InvalidateRect(&sRect,FALSE);
			}
		}

return 0;
}

//*****************************************************************************
//*
//*		EnsureVisible
//*
//*****************************************************************************
//	Prft ob ein Eintrag sichtbar ist, und scrollt wenn ntig zum Eintrag.
//	nIndex		: Ist die Zeilennummer des Eintrages
//	bPartialOK	: Darf der Eintrag auch teilweise sichtbar sein.
//	Ergibt TRUE wenn der Eintrag exisiert, ansonsten FALSE.
BOOL CColorListBox::EnsureVisible(int nIndex, BOOL bPartialOK)
{
int		iMax;
int		iNum;



	if(nIndex<0 || nIndex>=pData->uListItemsCount)
		{
		return FALSE;
		}


	iMax = pData->uScrollY+pData->uPageEnties;

	if(bPartialOK)
		{
		   iNum = pData->uSizeY%(pData->iFontHeight+pData->bHasLines);
		if(iNum>3)iMax++;
		}

	if(nIndex>=pData->uScrollY && nIndex<iMax)
		{
		return TRUE;
		}


	if(nIndex>pData->uScrollY)
		{
		SetTopIndex(nIndex-pData->uPageEnties/4);
		}
	else{
		SetTopIndex(nIndex-pData->uPageEnties*3/4);
		}


return TRUE;
}

//*****************************************************************************
//*
//*		SelectWord
//*
//*****************************************************************************
//	Whlt das Wort aus auf dem der Cursor gerade steht
//	Eribt die Anzahl der Markierten Buchstaben
int	CColorListBox::SelectWord()
{

	OnKeyDown(VK_CLEAR,1,0);


return (pData->iMarkStopX<pData->iMarkStartX)? pData->iMarkStartX-pData->iMarkStopX:pData->iMarkStopX-pData->iMarkStartX;
}


//*****************************************************************************
//*
//*		SetKeyStepMode
//*
//*****************************************************************************
//	Stellt das Verhalten bei Wortsprngen mit Ctrl+Left|Right ein.
//	iMisc		: Auch diversen Zeichen anhalten.
//	iFirst		: Nur am Beginn eines Wortes/Bereichs anhalten.
//	iUpper		: Auch Gro/Kleinbergngen anhalten.
//	iUnter		: Das '_' nicht als Buchstaben betrachten.
void CColorListBox::SetKeyStepMode(int iMisc,int iFirst,int iUpper,int iUnter)
{

	if(iUnter)
		{
		         pData->bKeyStepUnter=1;
				 pData->iKeyStepMask =iKeyMaskDefaultUl;
		if(iMisc)pData->iKeyStepMask|=iKeyMaskExtentedUl;
		}
	else{
	             pData->bKeyStepUnter=0;
			     pData->iKeyStepMask =iKeyMaskDefault;
		if(iMisc)pData->iKeyStepMask|=iKeyMaskExtented;
		}

	if(iUpper)pData->iKeyStepMask |= iKeyMaskUpperCase;
	if(iFirst)pData->iKeyStepMask &= iKeyMaskFirst;

	pData->bKeyStepMisc  = (iMisc )? 1:0;
	pData->bKeyStepFirst = (iFirst)? 1:0;
	pData->bKeyStepUpper = (iUpper)? 1:0;

}


//*****************************************************************************
//*
//*		SetTabSize
//*
//*****************************************************************************
//	Stellt die Tabulatorbreite ein
//	iTab		: Ist der Wert fr die Tabulatorbreite.
//					>=0		Dann ist die Angabe in Buchstaben
//					< 0		Dann ist die Angabe in Pixeln (negiert)
//	bRedraw		: Muss das Fenster neu gezeichnet werden.
void CColorListBox::SetTabSize(int iTab,BOOL bRedraw)
{
int iOld;


	iOld				=  pData->iTabSize;
	pData->iTabSteps	=  iTab;
	pData->iTabSize		= (pData->iTabSteps<0)? -pData->iTabSteps:pData->iTabSteps*pData->iFontWidth;
	pData->aTabPos[0]	=  pData->iTabSize;
	pData->iTabCount	=  1;

	if(iOld==pData->iTabSize)return;


	UpdateTextSize();
	if(bRedraw)RedrawWindow();

}

//*****************************************************************************
//*
//*		SetTabStops
//*
//*****************************************************************************
//	Stellt die Tabulatorabstnde fr die Zeilen ein.
//	iTabs		: Ist die Anzahl der Tabulatoren im Feld.
//				  Wenn dieser Wert ist werden konstante Abstnde eingestellt.
//	pTabStops	: Zeiger auf das Feld mit den Tabulatoren.
//				  Die Werte im Feld mssen aufsteigent sein.
//	bRedraw		: Muss das Fenster neugezeichnet werden
//	Ergibt TRUE wenn die Tabulatorabstnde gesetzt wurden, ansonsten FALSE.
int	CColorListBox::SetTabStops(int iTabs,INT *pTabStops,BOOL bRedraw)
{
int		iChg;
int		iOff;
int		iPos;
int		iNum;



	if(iTabs<1)return FALSE;

	if(iTabs==1)
		{
		SetTabSize(-pTabStops[0],bRedraw);
		return TRUE;
		}


	iOff = 0;
	iPos = 0;
	iChg = (pData->iTabCount==CLB_MAX_TABS)? 0:1;

	for(iNum=0;iNum<iTabs;iNum++)
		{
		if(pTabStops[iNum]<iOff)continue;
		if(pData->aTabPos[iPos]!=pTabStops[iNum])
			{
			pData->aTabPos[iPos]	= pTabStops[iNum];
			iChg			= 1;
			}

		iOff	= pTabStops[iNum];
		iPos   += 1;

		if(iPos>=CLB_MAX_TABS)break;
		}

	for(;iPos>=CLB_MAX_TABS;iPos++)
		{
		iOff += 64;
		iOff /= 64;
		iOff *= 64;

		if(pData->aTabPos[iPos]!=iOff)
			{
			pData->aTabPos[iPos] = iOff;
			iChg			= 1;
			}
		}

	pData->iTabCount = CLB_MAX_TABS;
	pData->iTabSize	 = pData->iFontWidth*8;


	if(iChg && bRedraw)RedrawWindow();


return TRUE;
}
