//*****************************************************************************
//*
//*
//*		ColorListBox.h : Header-Datei
//*
//*
//*****************************************************************************
#ifndef	__COLORLISTBOX_H__
#define __COLORLISTBOX_H__

#if _MSC_VER > 1000
#pragma once
#endif


#include	<afxmt.h>

#define		CLB_MAX_TABS		32							// Maximale Tabulatorsprnge
#define		CLB_MAX_COLOR		20							// Maximale Farbenanzahl
#define 	CLB_COLOR_EVEN		(CLB_MAX_COLOR+0)			// Farben fr gerade Zeilen
#define 	CLB_COLOR_ODD		(CLB_MAX_COLOR+1)			// Farben fr ungerade Zeilen
#define 	CLB_FLAG_MARKOFF	0x00000000					// Keine       Markierungen
#define 	CLB_FLAG_MARKSINGLE	0x00000001					// Mehrzeilige Markierungen
#define 	CLB_FLAG_MARKMULTI	0x00000002					// Einzeilige  Markierungen
#define 	CLB_FLAG_MARKFULL	0x00000003					// Ganzzeilige Markierungen
#define 	CLB_FLAG_MARKMASK	0x0000000F					// Maske fr Markierungsart
#define 	CLB_FLAG_LINES		0x00000010					// Einen Rahmen um jede Zeile zeichen
#define 	CLB_FLAG_ALTERNATED	0x00000020					// Abwechselnde Faren fr die Zeilen
#define 	CLB_FLAG_SELMARK	0x00000040					// Ausgewhlte Zeile markieren
#define 	CLB_FLAG_SELFIELD	0x00000080					// Auswahlfelder einblenden
#define 	CLB_FLAG_SELDBLCLK	0x00000100					// Auswahl mit Doppelcklick
#define 	CLB_FLAG_SELSPACE	0x00000200					// Auswahl mit SPACE-Taste
#define 	CLB_FLAG_SELRETURN	0x00000400					// Auswahl mit SPACE-Taste
#define 	CLB_FLAG_CURSOR		0x00000800					// Cursor ein bzw. ausblenden
#define 	CLB_FLAG_WORDDBLCLK	0x00001000					// Wortauswahl mit Doppelcklick
#define 	CLB_FLAG_TABEXIT	0x00002000					// Bei TAB den Focus ans Elternfenster geben
#define 	CLB_FLAG_NOCONTEXT	0x00004000					// Kein Kontextmen
#define 	CLB_FLAG_STEPMISC	0x00008000					// Bei Wortsprngen auch diversen Zeichen anhalten
#define 	CLB_FLAG_STEPFIRST	0x00010000					// Bei Wortsprngen nur am Beginn eines Wortes/Bereichs anhalten
#define 	CLB_FLAG_STEPUPPER	0x00020000					// Bei Wortsprngen auch Gro/Kleinbergngen anhalten
#define 	CLB_FLAG_STEPUNTER	0x00040000					// Bei Wortsprngen das '-' nicht als Buchstaben betrachten
#define 	CLB_FLAG_STEPALL	0x00078000					// Bei Wortsprungoptionen
#define 	CLB_FLAG_ALL		0xFFFFFFFF					// Maske fr alle Optionen


// Konstanten fr Notify-Nachrichten
#define		CFL_SELCHANED		0x1302						// nderung der Auswahl

typedef struct
	{
	NMHDR	sNmHdr;											// Notify Daten
	int		iItem;											// Nummer des Eintrages
	int		iSelected;										// Ist der Eintrag asugewhlt
	}CLB_STATUS,*LPCLB_STATUS;


//*****************************************************************************
//*
//*		CColorListBox
//*
//*****************************************************************************
class CColorListBox : public CWnd
{
public:
			 CColorListBox();
	virtual ~CColorListBox();
	virtual BOOL CColorListBox::Create  (                DWORD dwStyle,const RECT &sRect,CWnd* pParentWnd,UINT nID=0);
	        BOOL CColorListBox::CreateEx(DWORD dwExStyle,DWORD dwStyle,const RECT &sRect,CWnd* pParentWnd,UINT nID=0);


	int		SelectString   (int    nAfter,LPCTSTR pItem,BOOL bExact=FALSE);
	int		FindString     (int    nAfter,LPCTSTR pItem   );
	int		FindStringExact(int    nAfter,LPCTSTR pItem   );
	int		GetMark        (int &iStartX,int &iStartY,int &iStopX,int &iStopY);
	int		GetMark        (int &iStart ,int &iStop);
	UINT	ItemFromPoint  (CPoint sPoint,BOOL &bOutside  ) const;
	UINT	ItemFromPoint  (CPoint sPoint,BOOL *pOutside=0) const;
	BOOL	SetFont        (CFont *pFont     ,BOOL  bRedraw=TRUE);
	BOOL	SetFont        (HFONT  hFont     ,BOOL  bRedraw=TRUE);
	BOOL	SetFont		   (int    pData->iFontVar,BOOL  bRedraw=TRUE);
	BOOL	EnsureVisible  (int nIndex, BOOL    bPartialOK=FALSE);
	int		AddString      (            LPCTSTR pItem,const BYTE *pColor=0,int iLen=-1);
	int		AddString      (            LPCTSTR pItem,      BYTE  bColor  ,int iLen=-1);
	int     InsertString   (int nIndex, LPCTSTR pItem,const BYTE *pColor=0,int iLen=-1);
	int     InsertString   (int nIndex, LPCTSTR pItem,      BYTE  bColor  ,int iLen=-1);
	int		DeleteString   (int nIndex);
	int		GetSel		   (int nIndex) const;
	int		SetSel		   (int nIndex, BOOL bSelect=TRUE);
	int		EnableSel	   (int nIndex, BOOL bEnable=TRUE);
	int		SetCurSel      (int nIndex);
	int		SetItemDataPtr (int nIndex,LPVOID   pPtr);
	int		SetItemData	   (int nIndex,LPARAM   lParam);
	int     SetText        (int nIndex,LPCTSTR  pText,int iLen,const BYTE *pColor);
	int     SetText        (int nIndex,LPCTSTR  pText,int iLen=-1,   BYTE  bColor=0xFF);
	int		GetText        (int nIndex,LPTSTR   pBuffer,int iSize);
	int		GetText        (int nIndex,LPTSTR   pBuffer);
	void	GetText        (int nIndex,CString &sString);
	LPCTSTR	GetText        (int nIndex,int	   &iSize);
	LPCTSTR	GetText        (int nIndex);
	int		GetTextLen     (int nIndex) const;
	LPARAM  GetItemData	   (int nIndex) const;
	LPVOID	GetItemDataPtr (int nIndex) const;
	int 	GetItemRect	   (int nIndex, LPRECT pRect) const;
	int		SetTextColor   (int nIndex,const BYTE *pColor);
	int		SetTextColor   (int nIndex,      BYTE  bColor=0);
	int		SetColor       (int iNr   ,COLORREF cRgbText,COLORREF cRgbHg=0xFFFFFFFF);
	int		SetFlags       (int iFlags,int iMask=CLB_FLAG_ALL);
	void	SetAlternated  (int iOn,BOOL bRedraw=TRUE);
	void	SetLineFrames  (int iOn,BOOL bRedraw=TRUE);
	void 	SetSelectMode  (int iOn,BOOL bRedraw=TRUE);
	void	SetKeyStepMode (int iMisc,int iFirst=0,int iUpper=0,int iUnter=0);
	void	SetContextMode (int iMode );
	void	SetSelectDblclk(int iMode );
	void	SetSelectReturn(int iMode );
	void	SetSelectSpace (int iMode );
	void	SetSelectWord  (int iMode );
	int		SetTopIndex    (int iIndex);
	void 	SetMarkType    (int iType );
	void	SetMarkMode    (int iOn   );
	void	SetCursorMode  (int iOn   );
	void	SetTabExit	   (int iOn   );
	void 	SetTabSize     (int iTab ,BOOL bRedraw=TRUE);
	int		SetTabStops	   (int iTabs,INT *pTabStops,BOOL bRedraw=TRUE);
	int		SetTabStops	   (const int &iTabStop,BOOL bRedraw=TRUE);
	int		SelectWord     ();
	int		IsSeleced      ();
	int		GetFontHeight  ();
	int		GetTabSize     ();
	int		GetTopIndex    ();
	int		GetLineCount   ();
	void	ResetContent   ();
	int		GetCurSel      ();
	int		GetCount       ();
	void	MarkAll		   ();
	void	OnMarkAll	   ();
	void	OnCopy         ();
	void	Copy           ();


public:


	//{{AFX_VIRTUAL(CColorListBox)
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CColorListBox)
	afx_msg void OnPaint         ();
	afx_msg void OnDestroy       ();
	afx_msg void OnSysColorChange();
	afx_msg void OnTimer         (UINT);
	afx_msg void OnHScroll       (UINT nSBCode,UINT nPos,CScrollBar *pScrollBar);
	afx_msg void OnVScroll       (UINT nSBCode,UINT nPos,CScrollBar *pScrollBar);
	afx_msg void OnSize          (UINT nType,int iSizeX,int iSizeY);
	afx_msg void OnRButtonDown   (UINT nFlags,CPoint sPoint);
	afx_msg void OnLButtonUp     (UINT nFlags,CPoint sPoint);
	afx_msg void OnLButtonDown   (UINT nFlags,CPoint sPoint);
	afx_msg void OnLButtonDblClk (UINT nFlags,CPoint sPoint);
	afx_msg void OnMouseMove     (UINT nFlags,CPoint sPoint);
	afx_msg BOOL OnMouseWheel    (UINT nFlags,short  iDelta , CPoint pt);
	afx_msg void OnKeyDown       (UINT nChar ,UINT   nRepCnt, UINT nFlags);
	afx_msg void OnChar          (UINT nChar ,UINT   nRepCnt, UINT nFlags);
	afx_msg int  OnCreate        (LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnShowWindow    (BOOL bShow, UINT nStatus);
	afx_msg void OnSetFocus      (CWnd *pOldWnd);
	afx_msg void OnKillFocus     (CWnd *pNewWnd);
	afx_msg LRESULT OnGetDlgCode (WPARAM wParam,LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	int		SetSel		    (int nIndex,BOOL bSelect,BOOL bNotify);
	int		SetClipboardText(LPCTSTR pText,int iSize);
	int		PointOfRow		(int iLine,int iPosX,CDC *pDc=0);
	int		RowOfPoint      (int iLine,int iPosX,int iAddHalf=0);
	int		RowOfNewLine    (int iLineNew,int iLineNow,int iPosNow);
	int		SetCurSel		(int nIndex,BOOL bRedraw);
	void	UpdateTextSize  ();
	void	UpdateColors    ();
	void	UpdateCaret     ();

//*****************************************************************************
//*
//*		Variabeln
//*
//*****************************************************************************

	typedef	struct
		{
		LPARAM	lParam;								// Userdatenwert
		WORD	wLineLen;							// Zeilenlnge
		WORD	wLineSel;							// Ist Zeile aus gewhlt
		WORD	wLineSize;							// Zeilen-Speicherlnge
		BYTE	bData[1];							// Zeilendaten
		}LineData,*PLineData;


	LineData  **pData->pLines;							// Zeiger auf Zeilendaten
	int			pData->uListItemsCount;						// Anzahl der Zeilen
	int			pData->iLineSize;						// Anzahl der Zeileneintrge in pData->pLines
	CSemaphore	pData->sSemaphor;						// Schutz fr Items

	BOOL		pData->bKeyStepMisc;						// Bei Wortsprngen auch diversen Zeichen anhalten
	BOOL		pData->bKeyStepFirst;					// Bei Wortsprngen nur am Beginn eines Wortes/Bereichs anhalten
	BOOL		pData->bKeyStepUpper;					// Bei Wortsprngen auch Gro/Kleinbergngen anhalten
	BOOL		pData->bKeyStepUnter;					// Bei Wortsprngen das '-' nicht als Buchstaben betrachten
	BOOL		pData->bTabExit;							// Bei TAB den Focus ans Elternfenster geben
	BOOL		pData->cHasFocus;						// Hat das Fenster den Focus
	BOOL		pData->bHasLines;						// Trennlinien zwischen den Zeilen
	BOOL		pData->bHasSelect;						// Hat das Fenster Hckchen zum auswhlen
	BOOL		pData->cHasCaret;						// Hat das Fenster einen Cursor
	BOOL		pData->bNoContext;						// Kein Conteext-Men mit rechter Maustaste
	BOOL		pData->bSelDblclk;						// Auswahl mit Doppelclick
	BOOL		pData->bSelSpace;						// Auswahl mit SPACE-Taste
	BOOL		pData->bSelReturn;						// Auswahl mit RETURN-Taste
	BOOL		pData->bSetWordDbl;						// Wortauswahl mit Doppelcklick
	BOOL		pData->bAlternated;						// Abwecheselnde Farbe fr Zeilen
	BOOL		pData->bIsVisible;						// Ist das Fenster sichtbar
	HFONT		pData->hFont;							// Ausgewhlter Font
	COLORREF	pData->aColorHg  [CLB_MAX_COLOR+2];		// Farben fr den Hintergrund
	COLORREF	pData->aColorText[CLB_MAX_COLOR+2];		// Farben fr den Text
	BYTE		pData->aColorFixed[4];					// Wurde die Hintergrund Farben verndert
	int			pData->iColorCount;						// Anzahl der Farben
	int			pData->uSelectedLine;							// Ausgewhlte Zeile
	int			pData->iFontVar;							// Ist es ein Font mit variabler Breite
	int			pData->iScrollX ,pData->iScrollY;				// Scrollposition
	int			pData->iWindowX ,pData->iWindowY;				// Fenstergre in Buchstaben
	int			pData->iWindowXS,pData->iWindowYS;			// Fenstergbreite in Pixel
	int			pData->iFontWidth,pData->iFontHeight;					// Schriftgre in Pixel
	int			pData->iFontMaxX;						// Schriftgre in Pixel maximal
	int			pData->iMaxX;							// Maximale X-Gre in Zeichen
	int			pData->iAddRows;							// Pixelreihen einfgen nach Zeile
	int			pData->iCursorX,pData->iCursorY;				// Aktuelle Cursor Position
	int			pData->iCaretX ,pData->iCaretY;				// Koortinaten fr Caret
	int			pData->iCaretExist;						// Wurde das Caret erzeugt
	int			pData->iCaretOn;							// Ist der Cursor sichtbar
	int			pData->iMaxSizeX;						// Maximale X-Gre in Pixel
	int			pData->iMarkStartX,pData->iMarkStartY;		// Beginn einer Marke
	int			pData->iMarkStopX ,pData->iMarkStopY;			// Ende   einer Marke
	int			pData->iMarkMode;						// Ist eine Marke vorhanden 0=Keine 1=Ziehen 2=Fertig
	int			pData->iMarkType;						// Erlaubte Markierungsart (0=Keine 1=Einzeilig 2=Mehzeilig 3=Nur ganze Zeilen)
	int			pData->iTimerOn;							// Ist der Scrolltimer ein
	int			pData->cSelectEnable;					// Die selektierte Zeile anzeigen
	int			pData->iTabSteps;						// Ist die Tab-Breite in Buchstaben
	int			pData->iTabSize;							// Ist die Tab-Breite in Pixel
	int			pData->aTabPos[CLB_MAX_TABS];			// Tabulatorpositionen
	int			pData->iTabCount;						// Anzhalt der Eintrge in pData->aTabPos
	int			pData->uShiftY;						// Um wievile Bits mssen scroll werte verschoben werden
	int			pData->iKeyStepMask;						// Maske fr Wortsprnge mit der Tastatur
	static int	pData->iRegClassDone;					// Wurde die Klasse registiert
	static HPEN pData->hPen1;							// Zeichenstifte fr Hckchen
	static HPEN pData->hPen2;							//		*

};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline int		CColorListBox::SetTabStops	 (const int &iTabStop      ,BOOL  bRedraw ){return SetTabStops(1,&(INT)iTabStop,bRedraw);}
inline UINT		CColorListBox::ItemFromPoint (CPoint sPoint,            BOOL &bOutside) const {return ItemFromPoint   (sPoint,&bOutside);}
inline int		CColorListBox::AddString     (LPCTSTR pItem,      const BYTE *pColor,int iLen){return InsertString(-1,pItem,pColor,iLen);}
inline int		CColorListBox::AddString     (LPCTSTR pItem,            BYTE  bColor,int iLen){return InsertString(-1,pItem,bColor,iLen);}
inline int		CColorListBox::InsertString  (int nIndex ,LPCTSTR pItem,BYTE  bColor,int iLen){return InsertString(nIndex,pItem,(BYTE*)bColor,iLen);}
inline int		CColorListBox::SetText       (int nIndex ,LPCTSTR pText,int iLen,BYTE  bColor){return SetText     (nIndex,pText,iLen,(BYTE*)bColor);}
inline int		CColorListBox::SetTextColor  (int nIndex, BYTE bColor ){return SetTextColor(nIndex,(BYTE*)bColor);}
inline int		CColorListBox::SetSel        (int nIndex ,BOOL bSelect){return SetSel(nIndex,bSelect,FALSE);}
inline int		CColorListBox::SetCurSel	 (int nIndex              ){return SetCurSel(nIndex,TRUE);}
inline int		CColorListBox::SetItemDataPtr(int nIndex, LPVOID  pPtr){return SetItemData(nIndex,(LPARAM)pPtr);};
inline LPVOID	CColorListBox::GetItemDataPtr(int nIndex) const{return (LPVOID)GetItemData(nIndex);};
inline int		CColorListBox::GetLineCount  (){return pData->iWindowY;  }
inline int		CColorListBox::GetCurSel     (){return pData->uSelectedLine;   }
inline int		CColorListBox::GetCount      (){return pData->uListItemsCount;}
inline int		CColorListBox::GetFontHeight (){return pData->iFontHeight;    }
inline int		CColorListBox::GetTopIndex   (){return pData->iScrollY;  }
inline int		CColorListBox::GetTabSize    (){return pData->iTabSteps; }
inline int		CColorListBox::IsSeleced     (){return pData->iMarkType; }
inline void 	CColorListBox::MarkAll		 (){OnMarkAll();}
inline void 	CColorListBox::Copy			 (){OnCopy   ();}
//{{AFX_INSERT_LOCATION}}

#endif
